% function 'chebym': constructs Chebyshev polynomials up tp the mth degree 
%                   computed at the nodes x (where x is a row vector)

function T=chebyc(n,x);

if size(x,2) == 1;

    T = ones(n,size(x,1));
    for i=2:n,
       if i == 2
           T(i,:) = x';
       else
           T(i,:) = 2*x'.*T(i-1,:)-T(i-2,:);
       end
	end
    
else
    
    T = ones(n,size(x,2),size(x,1));
    for i=2:n,
       if i == 2
           T(i,:,:) = x';
       else
           T(i,:,:) = 2*x'.*squeeze(T(i-1,:,:))-squeeze(T(i-2,:,:));
       end
	end
end    
