% function 'chebym': constructs Chebyshev polynomials up tp the mth degree 
%                   computed at the nodes x (where x is a row vector)

function Out = chebyd(x,delta);

n = size(delta,1);
if size(x,2) == 1;

    T = ones(size(x,1),2);
    Out = repmat(delta(1),[size(x,1) 1]);
    for i=2:n,
       if i == 2
           T(:,2) = x;
           Out = Out + x.*repmat(delta(2),[size(x,1) 1]);
       else
           Tadd = 2*x.*T(:,2)-T(:,1);
           T(:,1) = T(:,2);
           T(:,2) = Tadd;
           Out = Out + Tadd.*repmat(delta(i),[size(x,1) 1]);
       end
	end
    
else
    
    T = ones(2,size(x,1),size(x,2));
    Out = repmat(delta(1,:),[size(x,1) 1]);
    for i=2:n,
       if i == 2
           T(2,:,:) = x;
           Out = Out + x.*repmat(delta(2,:),[size(x,1) 1]);
       else
           Tadd = 2*x.*squeeze(T(2,:,:))-squeeze(T(1,:,:));
           T(1,:,:) = T(2,:,:);
           T(2,:,:) = Tadd;
           Out = Out + Tadd.*repmat(delta(i,:),[size(x,1) 1]);           
       end
	end
end    
