% this is a trial program for Chebishev polynominials

% PARAMETERS OF THE INTERPOLATION
a=-4;                   % starting point of the domain
b=4;                    % end point of the domain
m=1000;
n=50 ;
d=.001;

x0=(a:d:b).';         %grid of points

f=fu(x0,d,3,a);
plot(x0,f,'y');


x=chnodes(m);                                                %step 1
z=((x+1)*(b-a)/2)+a*ones(size(x));                           %step 2
y=fu(z,(b-a)/m,3,a);                                               %step 3


T=cheby(n,x);                                                %step 4-a
mult=[1;2*ones(n-1,1)]/m;
ahat=mult.*(T*y);                                            %step 4-b

fhat=cheby(n,-1+2*((x0-a*ones(size(x0)))/(b-a))).'*ahat(1:n);%step 5

f=fu(x0,d,3,a);        % function that needs to be approximated
(f-fhat).'*(f-fhat)
plot(x0,f,'y',x0,fhat,'r',x0,f-fhat,'g');
plot(x0,f,'y',x0,fhat,'r');






