close all;
clear all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% PRELIMINARY STUFF
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

run startdsgeprioeuro;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%      paths & parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
chdata = choosedata;
[mspec,mprior,dataset,dates,nvar,nlags,T0,Tend,npara,lambdaseq,para_names,bounds,para, ...
        varnames,cum_for,polipar,polivalue,cum_irf,names_shocks,fixparamseq,coint,JustMode, ...
        stime,st,nblocks,nsim,nburn,qahead,para_mask,para_fix] = varspec(chdata);

[fpath,spath,gpath] = pathspec(num2str(floor(dataset)),chdata);


fprintf(1,'model: %2.0f, dataset: %2.1f, prior: %2.0f',[mspec,dataset,mprior]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% load data
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[YYall,XXall,ti,nobsall] = loaddata(dataset,fpath,T0,Tend,coint,nvar,nlags,chdata,mspec);

dataset = num2str(10*dataset);

ICUM = find(cum_for);
INCUM = find(cum_for == 0);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Load information for prior distribution

lprior    = num2str(mprior);
lmodel    = strcat('m',num2str(mspec));
priorfile = strcat(lmodel,lprior,'pri');
prior = feval(priorfile);

pmean  = prior(1:npara,1);
pstdd  = prior(1:npara,2);
pshape = prior(1:npara,3);

pshape = pshape.*(1-para_mask);


nonpolipar = [1:1:npara];
nonpolipar(polipar) = [];

% Load transformation scheme for parameters
trspec = feval('transp',mspec);

trspec(:,1) = trspec(:,1).*(1-para_mask);
        



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Set parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% doing rolling sample estimation?
ROLL = 1
SAVEALL = 0
DOFORECAST = 1
if ROLL 
	DOFORECAST = 1;
	SAVEALL = 0;
end
start_period = stime;                               % minimum # quarters to compute VAR estimates (80)


start_period = nobsall-qahead+1-3
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% CHAnGE

trial_period = nobsall-start_period-qahead+1;      % # quarters to compute RMSE


%%  Configure the Metropolis Algorithm
cc0     = 0.002;
cc      = 0.15;


Verbose = 0


date_q = (1:1:qahead)';

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% do Lambda loop
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fixparam = fixparamseq          
L = 0;
for lambdas = lambdaseq     

	lambdas

	spath1 = strcat(spath,'/1/')
            
	load(strcat(spath1,'Fh',lmodel,lprior,dataset,st,num2str(fixparam),num2str(JustMode),num2str(100*lambdas)),'Fh');
        load(strcat(spath1,'Yh',lmodel,lprior,dataset,st,num2str(fixparam),num2str(JustMode),num2str(100*lambdas)),'Yh');

	yh_1 = Yh;
	fh_1 = Fh;

	spath1 = strcat(spath,'/2/')
            
	load(strcat(spath1,'Fh',lmodel,lprior,dataset,st,num2str(fixparam),num2str(JustMode),num2str(100*lambdas)),'Fh');
        load(strcat(spath1,'Yh',lmodel,lprior,dataset,st,num2str(fixparam),num2str(JustMode),num2str(100*lambdas)),'Yh');

	yh_2 = Yh;
	fh_2 = Fh;

	spath1 = strcat(spath,'/3/')
            
	load(strcat(spath1,'Fh',lmodel,lprior,dataset,st,num2str(fixparam),num2str(JustMode),num2str(100*lambdas)),'Fh');
        load(strcat(spath1,'Yh',lmodel,lprior,dataset,st,num2str(fixparam),num2str(JustMode),num2str(100*lambdas)),'Yh');

	yh_3 = Yh;
	fh_3 = Fh;

	spath1 = strcat(spath,'/4/')
            
	load(strcat(spath1,'Fh',lmodel,lprior,dataset,st,num2str(fixparam),num2str(JustMode),num2str(100*lambdas)),'Fh');
        load(strcat(spath1,'Yh',lmodel,lprior,dataset,st,num2str(fixparam),num2str(JustMode),num2str(100*lambdas)),'Yh');

	yh_4 = Yh;
	fh_4 = Fh;


	keyboard;
end         % end lambdaseq
    
    


