close all;
clear all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% PRELIMINARY STUFF
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

run startdsswfed;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%      paths & parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
chdata = choosedata;
[mspec,mprior,dataset,dates,nvar,nlags,T0,Tend,npara,lambdaseq,para_names,bounds,para, ...
        varnames,cum_for,polipar,polivalue,cum_irf,names_shocks,fixparamseq,coint,cointadd,cointall,cointvec,cointaddvec,JustMode, ...
        stime,st,nblocks,nsim,nburn,qahead,para_mask,para_fix,para_aux,mspec_ref] = varspec(chdata);

[fpath,spath,gpath] = pathspec(num2str(floor(dataset)),chdata);
%[fpath,spath,gpath] = pathspecmh(num2str(floor(dataset)),chdata,coint);

fprintf(1,'model: %2.0f, dataset: %2.1f, prior: %2.0f',[mspec,dataset,mprior]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% load data
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[YYall,XXall,ti,nobsall] = loaddata(dataset,fpath,T0,Tend,coint,cointadd,cointall,nvar,nlags,chdata,mspec);

%dataset = num2str(10*dataset);

ICUM = find(cum_for);
INCUM = find(cum_for == 0);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%*
% Load information for prior distribution

lprior    = num2str(mprior);
lmodel    = strcat('m',num2str(mspec));
priorfile = strcat(lmodel,lprior,'pri');
prior = feval(priorfile);

pmean  = prior(1:npara,1);
pstdd  = prior(1:npara,2);
pshape = prior(1:npara,3);

pshape = pshape.*(1-para_mask);


nonpolipar = [1:1:npara];
nonpolipar(polipar) = [];

% Load transformation scheme for parameters
trspec = feval('transp',mspec);

trspec(:,1) = trspec(:,1).*(1-para_mask);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Set parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% set date
I = find(ti == dates);


%%  Configure the Metropolis Algorithm
cc0     = 0.02;
cc      = 0.002;



date_q = (1:1:qahead)';

TINU = '/home/f1mdn14/nas02/amdn/';
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% do Lambda loop
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for lambdas = lambdaseq
  dataset0 = dataset
  spath0 = spath;%strcat(TINU,'wk/save/dsgeprio/fed/404/',num2str(floor(dataset0)),'/');strcat(TINU,'wk/save/dsgeprio/fed/404/4/');%
  L = 0;
  lambdas0 = NaN%lambdas;
  nlags0 = nlags;
  I0 = find(ti == dates);
  st0 = num2str(st);
  mspec0 = mspec
  coint0 = coint;
  lprior0 = num2str(mprior);
  lmodel0    = strcat('m',num2str(mspec0));
  
  infile0 = strcat(spath0,lmodel0,lprior0,'para',num2str(coint0),st0,num2str(100*lambdas0),num2str(100*ti(I0)),num2str(nlags0),'Mode') 
  fid0 = fopen(infile0,'r');     % input file (set to read)   
  params = fread(fid0,[npara,1],'single');
  fclose(fid0);

  infile01 = strcat(spath0,lmodel0,lprior0,'hessian',num2str(coint0),st0,num2str(100*lambdas0),num2str(100*ti(I0)),num2str(nlags0),'Mode'); 
  fid01 = fopen(infile01,'r');     % input file (set to read)   
  hessian = fread(fid01,[npara,npara],'single')';
  fclose(fid01);
  
  %params(8) = .7
  %params(5) = 1
  
  %params(3) = .5;  params(13) = .5
   %params(1) = .33
   %params(19+4) = .15
   %params(19+6+2) = .8 
   %params(19+6+5) = .8
   %params(19+6+7) = .8
   
  dataset = dataset;
  spath = spath; %strcat(TIN,'wk/save/dsgeprio/fed/404/',num2str(floor(dataset)),'/');
  lambdas1= lambdas
  nlags1 = nlags
  I1 = find(ti == dates) 	        
  st1 = num2str(st) %% 120
  mspec1 = mspec
  coint1 = coint;
  lprior1 = num2str(mprior)
  lmodel1    = strcat('m',num2str(mspec1));
  
  %oparaest1 = strcat(spath,lmodel1,lprior1,'para',num2str(coint1),st1,num2str(100*lambdas1),num2str(100*ti(I1)),num2str(nlags1));
  %assignin('base',strcat('params',num2str(100*lambdas1),num2str(100*ti(I1)),num2str(nlags1)),params);
  %save(oparaest1,'params');
  %save(oparaest1,strcat('params',num2str(100*lambdas1),num2str(100*ti(I1)),num2str(nlags1)),'-append');
  %assignin('base',strcat('hessian',num2str(100*lambdas1),num2str(100*ti(I1)),num2str(nlags1)),hessian);
  %save(oparaest1,strcat('hessian',num2str(100*lambdas1),num2str(100*ti(I1)),num2str(nlags1)),'-append');      
  
  outfile0 = strcat(spath,lmodel1,lprior1,'para',num2str(coint1),st1,num2str(100*lambdas1),num2str(100*ti(I1)),num2str(nlags1),'Mode'); 
  fid0 = fopen(outfile0,'w');     % output file (set to write)   
  fwrite(fid0,params','single');
  fclose(fid0);

  outfile01 = strcat(spath,lmodel1,lprior1,'hessian',num2str(coint1),st1,num2str(100*lambdas1),num2str(100*ti(I1)),num2str(nlags1),'Mode');   fid01 = fopen(outfile01,'w');     % output file (set to write)   
  fwrite(fid01,hessian(:),'single');
  fclose(fid01);
  
end	


    
