close all;
clear all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% PRELIMINARY STUFF
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

run startdsgeprioeuro;
!hostname;
!ps -C matlab;
rand('state',sum(100*clock))
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%      paths & parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
chdata = choosedata;
[mspec,mprior,dataset,dates,nvar,nlags,T0,Tend,npara,lambdaseq,para_names,bounds,para, ...
 varnames,cum_for,polipar,polivalue,cum_irf,names_shocks,fixparamseq,coint,cointadd,cointall,cointvec,cointaddvec,JustMode, ...
 stime,st,nblocks,nsim,nburn,qahead,para_mask,para_fix,para_aux,mspec_ref] = varspec(chdata);

%[fpath,spath,gpath] = pathspecmh(num2str(floor(dataset)),chdata,coint);
[fpath,spath,gpath] = pathspec(num2str(floor(dataset)),chdata);


fprintf(1,'model: %2.0f, dataset: %2.1f, prior: %2.0f, cointall: %2.0f,',[mspec,dataset,mprior,cointall]);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% load data
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[YYall,XXall,ti,nobsall] = loaddata(dataset,fpath,T0,Tend,coint,cointadd,cointall,nvar,nlags,chdata,mspec);
Dat = dataset;
if Dat == 4
  I_inf = 6;
end
dataset = num2str(10*dataset);

ICUM = find(cum_for);
INCUM = find(cum_for == 0);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Load information for prior distribution

lprior    = num2str(mprior);
lmodel    = strcat('m',num2str(mspec));
priorfile = strcat(lmodel,lprior,'pri');
prior = feval(priorfile);

pmean  = prior(1:npara,1);
pstdd  = prior(1:npara,2);
pshape = prior(1:npara,3);

pshape = pshape.*(1-para_mask);
pmean = pmean.*(1-para_mask)+para_fix.*para_mask;
pstdd = pstdd.*(1-para_mask);


nonpolipar = [1:1:npara];
nonpolipar(polipar) = [];

% Load transformation scheme for parameters
trspec = feval('transp',mspec);

trspec(:,1) = trspec(:,1).*(1-para_mask);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Set parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% doing rolling sample estimation?
ROLL = 1;
SAVEALL = 0;
DOFORECAST = 0;
if ROLL 
  DOFORECAST = 1;
  SAVEALL = 0;
end
fprintf(1,'\n\n ROLL: %2.0f, SAVEALL: %2.0f, DOFORECAST: %2.0f\n',[ROLL,SAVEALL,DOFORECAST]);
start_period = stime;                               % minimum # quarters to compute VAR estimates 


%mkdir(spath,'/2/');
%spath = strcat(spath,'/1/');
%start_period = nobsall-qahead+1-3
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% CHAnGE

trial_period = nobsall-start_period-qahead+1;      % # quarters to compute RMSE


%%  Configure the Metropolis Algorithm
cc0     = 0.01;
cc      = 0.12;


Verbose = 0;


date_q = (1:1:qahead)';

NOCUM = 0;
if NOCUM 
  NOCUM_ = 'NOCUM';
else
  NOCUM_ = '';
end
  
%% set output file
runn = strcat('outcomprestables',lmodel,lprior,dataset,num2str(coint),st,num2str(lambdaseq(1)),num2str(lambdaseq(end)),NOCUM_);
outfile = strcat(fpath,runn,'.tex')		% output file name 


runn1 = strcat('outcomprestrash',lmodel,lprior,dataset,num2str(coint),st,num2str(lambdaseq(1)),num2str(lambdaseq(end)),NOCUM_);
outfile1 = strcat(fpath,runn1,'.txt')		% output file name 

fid1 = fopen(outfile1,'w');		% output file (set to write)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%      load results: Lambda sequence
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

date_q = (1:1:qahead)';

if ROLL        
  Iseq = start_period+1:start_period+trial_period-1;

  fprintf(1,'\n beginning: %2.4f ; end:  %2.4f \n',[ti(Iseq(1)),ti(Iseq(end))]);

else

  disp('set ROLL = 1');
  return;
end

Y = zeros(qahead,nvar+1,length(lambdaseq));
Fhall = zeros(qahead,nvar,length(Iseq),length(lambdaseq));
Yhall = zeros(qahead,nvar,length(Iseq),length(lambdaseq));
Mhall = zeros(length(Iseq),length(lambdaseq));

fixparam = fixparamseq          
L = 0;
for lambdas = lambdaseq     
  
  L = L+1;        
  
  if isnan(lambdas)
    coint0 = coint;
  elseif lambdas == 0
    coint0 = coint;
  else
    coint0 = cointall;
  end

  for I = Iseq;

    if stime                           
      YY = YYall(I-stime+1:I,:);
      XX = XXall(I-stime+1:I,:);             
      tiI = ti(I-stime+1:I);
    else
      YY     = YYall(1:I,:);
      XX     = XXall(1:I,:);                   
      tiI = ti(1:I);
    end
    
    %% Define initial Y's and cointegration vector for DSGE model estimation
    %% ignore cointadd
    
    %% YY0: lagged growth rates
    YY0 = zeros(nlags,size(YY,2));
    for lagind = 1:nlags
      YY0(nlags-lagind+1,:) = XX(1,1+cointall+(lagind-1)*nvar+1:1+cointall+lagind*nvar);
    end
    
    %% YYcoint0: lagged cointegration vector
    if coint > 0            
      YYcoint0 = XX(1,1+cointadd:cointall);
      for lagind = 1:(nlags-1)
        YYcoint0 = YYcoint0-XX(1,1+cointall+(lagind-1)*nvar+1:1+cointall+lagind*nvar)*cointvec';
      end
    else
      YYcoint0 = [];               
    end
    
    if I+qahead <= nobsall
      YYfut  = YYall(I+1:I+qahead,:);
      XXpred = XXall(I+1,:);
    elseif I == nobsall
      YYfut  = NaN*zeros(qahead,nvar);
      XXpred = XXall(end,:);
    elseif (I < nobsall) & (I+qahead > nobsall)
      Ii = nobsall-I
      YYfut  = [YYall(I+1:I+Ii,:);NaN*zeros(qahead-Ii,nvar)];
      XXpred = XXall(end-Ii,:);        
    end

    if Dat == 4
      YYfut(:,I_inf) = YYfut(:,I_inf)/4;
    end

    if lambdas ~= 0

%      load(strcat(spath,'Fh',lmodel,lprior,dataset,num2str(coint0),st,num2str(fixparam),num2str(JustMode),num2str(100*lambdas),num2str(100*ti(I))),'Fh');
%      load(strcat(spath,'Yh',lmodel,lprior,dataset,num2str(coint0),st,num2str(fixparam),num2str(JustMode),num2str(100*lambdas),num2str(100*ti(I))),'Yh');

      infile011 = strcat(spath,'mFh',lmodel,lprior,dataset,num2str(cointall),st,num2str(fixparam),num2str(JustMode),num2str(100*lambdas),num2str(100*ti(I)));
      fid011 = fopen(infile011,'r');     % output file (set to write)   
      Fh = fread(fid011,[qahead,nvar],'single');
      fclose(fid011);
      
    
      infile012 = strcat(spath,'mYh',lmodel,lprior,dataset,num2str(cointall),st,num2str(fixparam),num2str(JustMode),num2str(100*lambdas),num2str(100*ti(I)));
      fid012 = fopen(infile012,'r');     % output file (set to write)   
      Yh = fread(fid012,[qahead,nvar],'single');
      fclose(fid012);


      infile0 = strcat(spath,'Mh',lmodel,lprior,dataset,num2str(cointall),st,num2str(fixparam),num2str(JustMode),num2str(100*lambdas),num2str(100*ti(I)));
      fid0 = fopen(infile0,'r');     % output file (set to write)   
      pint0 = fread(fid0,[1,1],'single');
      fclose(fid0);
      
      Mhall(I-start_period,L) = pint0;
      
    else
      lmodel0    = strcat('m',num2str(106));

      load(strcat(spath,'Fh',lmodel0,lprior,dataset,num2str(coint0),st,num2str(fixparam),num2str(JustMode),num2str(100*lambdas),num2str(100*ti(I))),'Fh');

      load(strcat(spath,'Yh',lmodel0,lprior,dataset,num2str(coint0),st,num2str(fixparam),num2str(JustMode),num2str(100*lambdas),num2str(100*ti(I))),'Yh');
    end

    if Dat == 4
      Fh(:,I_inf) = Fh(:,I_inf)/4;
      Yh(:,I_inf) = Yh(:,I_inf)/4;
    end


    yfut = YYfut;
    yfut(:,ICUM) = cumsum(yfut(:,ICUM));
    
    if abs(norm(yfut-(Yh-Fh))) > 10^-4; disp(yfut); disp(Yh-Fh); disp('problem'); pause; end;
    
  
    % ADD THIS IF YOU DO NOT WANT CUMULATIVE
    if NOCUM
      Fh(2:end,:) = Fh(2:end,:)-Fh(1:end-1,:);    Yh(2:end,:) = Yh(2:end,:)-Yh(1:end-1,:);
    end
    
    Fhall(:,:,I-start_period,L) = Fh;
    Yhall(:,:,I-start_period,L) = Yh;
  
  end %% end roll

  FhL = squeeze(Fhall(:,:,:,L));

  Y(:,1:nvar,L) = sqrt(mean(FhL(:,:,:).^2,3));
  
  for j = 1:qahead
    fj = squeeze(FhL(j,:,:))';
    matfj = fj'*fj/size(fj,1);
    Y(j,nvar+1,L) = -log(det(matfj))/(2*nvar);
  end

end %% end lambdaseq

L = 0;
for lambdas = lambdaseq     

  L = L+1;        
  outfile01 = strcat(spath,'foracc',lmodel,lprior,dataset,num2str(coint),st,num2str(100*lambdas));
  fid01 = fopen(outfile01,'w');     % output file (set to write)   
  out =  Y(:,:,L);
  fwrite(fid01,out(:),'single');
  fclose(fid01);

end


for ivar = 1:nvar
  fprintf(fid1,'\n\n %2.99s \n\n',varnames{ivar});
  sel = [1 4 12];
  qsel = (1:qahead);
  qsel = qsel(sel);
  
  Fh0 = [[0,qsel,qsel];[(1:size(Fhall,3))',squeeze(Fhall(qsel,ivar,:,1))',squeeze(Yhall(qsel,ivar,:,1))']];
  fprintf(fid1,'\n lambda');
  dispmatrix(0,2,fid1);
  fprintf(fid1,' rmse');
  dispmatrix([qsel;Y(qsel,ivar,1)'],4,fid1);
  fprintf(fid1,' bias');
  dispmatrix([qsel;mean(squeeze(Fhall(qsel,ivar,:,1))')],4,fid1);
  fprintf(fid1,' st dev');
  dispmatrix([qsel;std(squeeze(Fhall(qsel,ivar,:,1))')],4,fid1);
  dispmatrix(Fh0,2,fid1);

  
  Fh1 = [[0,qsel,qsel];[(1:size(Fhall,3))',squeeze(Fhall(qsel,ivar,:,4))',squeeze(Yhall(qsel,ivar,:,4))']];
  fprintf(fid1,'\n lambda');
  dispmatrix(1,2,fid1);
  fprintf(fid1,' rmse');
  dispmatrix([qsel;Y(qsel,ivar,4)'],4,fid1);
  fprintf(fid1,' bias');
  dispmatrix([qsel;mean(squeeze(Fhall(qsel,ivar,:,4))')],4,fid1);
  fprintf(fid1,' st dev');
  dispmatrix([qsel;std(squeeze(Fhall(qsel,ivar,:,4))')],4,fid1);
  dispmatrix(Fh1,2,fid1);

  Fhinf = [[0,qsel,qsel];[(1:size(Fhall,3))',squeeze(Fhall(qsel,ivar,:,find(isinf(lambdaseq))))',squeeze(Yhall(qsel,ivar,:,find(isinf(lambdaseq))))']];
  fprintf(fid1,'\n lambda');
  dispmatrix(inf,2,fid1);
  fprintf(fid1,' rmse');
  dispmatrix([qsel;Y(qsel,ivar,find(isinf(lambdaseq)))'],4,fid1);
  fprintf(fid1,' bias');
  dispmatrix([qsel;mean(squeeze(Fhall(qsel,ivar,:,find(isinf(lambdaseq))))')],4,fid1);
  fprintf(fid1,' st dev');
  dispmatrix([qsel;std(squeeze(Fhall(qsel,ivar,:,find(isinf(lambdaseq))))')],4,fid1);
  dispmatrix(Fhinf,2,fid1);

  if isnan(lambdaseq(end))
    Fhnan = [[0,qsel,qsel];[(1:size(Fhall,3))',squeeze(Fhall(qsel,ivar,:,find(isnan(lambdaseq))))',squeeze(Yhall(qsel,ivar,:,find(isnan(lambdaseq))))']];
    fprintf(fid1,'\n lambda');
    dispmatrix(NaN,2,fid1);
    fprintf(fid1,' rmse');
    dispmatrix([qsel;Y(qsel,ivar,find(isnan(lambdaseq)))'],4,fid1);
    fprintf(fid1,' bias');
    dispmatrix([qsel;mean(squeeze(Fhall(qsel,ivar,:,find(isnan(lambdaseq))))')],4,fid1);
    fprintf(fid1,' st dev');
    dispmatrix([qsel;std(squeeze(Fhall(qsel,ivar,:,find(isnan(lambdaseq))))')],4,fid1);
    dispmatrix(Fhnan,2,fid1);
  end

end


%% compute forecasts for lambda hat

%% for zero, put -Inf
if any(lambdaseq == 0)
  Mhall(:,1) = -inf;
  L = 1;
  lambdaseqmh = lambdaseq;
  lambdaseqmh(find(lambdaseqmh == 0)) = [];
else
  L = 0;
  lambdaseqmh = lambdaseq;
end
Mhall = real(Mhall);

[mhval,mhI] = max(Mhall,[],2);

lambdahat = [];
Fhlambdahat = zeros(qahead,nvar,trial_period);

for i = 1:length(mhI)
  lambdahat = [lambdahat;lambdaseq(mhI(i))];
  Fhlambdahat(:,:,i) = Fhall(:,:,i,mhI(i));
end
save(strcat(spath,'lambdahat.txt'),'lambdahat','-ascii');
Ylambdahat = zeros(qahead,nvar+1);
Ylambdahat(:,1:nvar) = sqrt(mean(Fhlambdahat(:,:,:).^2,3));

for j = 1:qahead
  fj = squeeze(Fhlambdahat(j,:,:))';
  matfj = fj'*fj/size(fj,1);
  Ylambdahat(j,nvar+1) = -log(det(matfj))/(2*nvar);
end

matmh = [[0,lambdaseq,0];[(1:1:size(Mhall,1))',Mhall,lambdahat]];
fprintf(fid1,'\n\n period, lambdas, lambdahat \n');
dispmatrix(matmh,2,fid1);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%      display results
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%      Lambda plot
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Lambdaseq =  [1:1:length(lambdaseq)]';
nselex = (3:2:(length(lambdaseq)-1));
lambdaticks = num2str(flipdim(lambdaseq(Lambdaseq)',1))
lambdaticks(nselex,:) = ' ';

tirf = lambdaseq./(1+lambdaseq)
if isnan(lambdaseq(end))
  tirf(end-1) = 1;
else
  tirf(end) = 1;
end
sirf = tirf;
if isnan(lambdaseq(end)); sirf(end) = 1.1; end;
tirf = num2str(tirf',2);
if isnan(lambdaseq(end))
 tirf(end,:) = 'DSGE';
end

tirf1 = tirf; 
tirf1(1:end-1,1) = ' '; 
tirf1([5 7],2) = ' ';

sirf = flipdim(sirf,2);
tirf = flipdim(tirf,1);
tirf1 = flipdim(tirf1,1);


sele = [1 2 4 6 8];
date_q = (1:1:qahead)';
datt = [1:1:length(date_q(sele,:))]';
datte = [date_q(sele,:)];


for i = 1:nvar
  
  figure(1000);
  subplot(ceil((nvar+1)/2),2,i);
  Q = squeeze(Y(sele,i,:));
  Q1 = repmat(Q(:,1),[1 length(lambdaseq)]);     
  Q = flipdim(100*(1-Q./Q1),2);
%  Q = 100*(1-Q./Q1);
  if i == 1
    %Q = flipdim(Q,1);        
  end
  
%  mesh(Lambdaseq,datt,Q,'FaceColor','none','LineWidth',1,'LineStyle','-','EdgeColor',[0 0 .5]);
  mesh(-sirf,datt,Q,'FaceColor','none','LineWidth',1,'LineStyle','-','EdgeColor',[0 0 0]);
  Q1 = zeros(2,2);      
  %hold on;mesh([Lambdaseq(1);Lambdaseq(end)],[datt(1);datt(end)],Q1,'FaceColor','none','LineWidth',1,'LineStyle',':','EdgeColor',[0 0 0]);
  hold off;
  ylabel('quarters ahead');
  set(gca,'YTick',datt);
  set(gca,'YTickLabel',num2str(datte));
  set(gca,'YTickLabel',[]);
  if any(i == [1,2,3])
    set(gca,'ZLim',[-30 30])
  elseif any(i == [4,6,7])
    set(gca,'ZLim',[-10 30])
  end        
  xlabel('\lambda/1+\lambda');
  set(gca,'XTick',-sirf);
  set(gca,'XTickLabel',tirf);  
  set(gca,'XTickLabel',[]);  
  zlabel('%');
  
  title(varnames{i});
  

  figure(i)
  mesh(-sirf,datt,Q,'FaceColor','none','LineWidth',1,'LineStyle','-','EdgeColor',[0 0 0]);
  Q1 = zeros(2,2);      
  %hold on;mesh([Lambdaseq(1);Lambdaseq(end)],[datt(1);datt(end)],Q1,'FaceColor','none','LineWidth',1,'LineStyle',':','EdgeColor',[0 0 0]);
  hold off;
  ylabel('quarters ahead');
  set(gca,'YTick',datt);
  set(gca,'YTickLabel',num2str(datte));
  if any(i == [1,2,3])
    set(gca,'ZLim',[-30 30])
  elseif any(i == [4,6,7])
    set(gca,'ZLim',[-10 50])
  end        
  xlabel('\lambda/1+\lambda');
  %set(gca,'XTick',Lambdaseq);
  %set(gca,'XTickLabel',lambdaticks);  
  set(gca,'XTick',-sirf);
  set(gca,'XTickLabel',tirf);  
  zlabel('%');
  
  runn = strcat('comprmses',lmodel,lprior,dataset,num2str(coint),st,num2str(fixparam),num2str(JustMode),num2str(lambdaseq(1)),num2str(lambdaseq(end)),'-',varnames{i});

  figure(i)
  %set(figure(1),'PaperPosition',[0 0 8 6])
  %saveas(figure(i),strcat(gpath,runn,'.fig'),'fig');
  %print(char(strcat(gpath,runn,'.eps')),'-depsc'); 
  print(char(strcat(gpath,runn,'.pdf')),'-dpdf');



end
figure(1000);
subplot(ceil((nvar+1)/2),2,nvar+1);
Q = squeeze(Y(sele,nvar+1,:));
Q1 = repmat(Q(:,1),[1 length(lambdaseq)]);     
Q = flipdim(100*(Q-Q1),2);
  mesh(-sirf,datt,Q,'FaceColor','none','LineWidth',1,'LineStyle','-','EdgeColor',[0 0 0]);
Q1 = zeros(2,2);      
%hold on;mesh([Lambdaseq(1);Lambdaseq(end)],[datt(1);datt(end)],Q1,'FaceColor','none','LineWidth',1,'LineStyle',':','EdgeColor',[0 0 0]);
hold off;
ylabel('quarters ahead');
set(gca,'YTick',datt);
set(gca,'YTickLabel',num2str(datte));
set(gca,'YTickLabel',[]);
  xlabel('\lambda/1+\lambda');
  set(gca,'XTick',-sirf);
  set(gca,'XTickLabel',tirf);  
set(gca,'XTickLabel',[]);  
zlabel('%');
set(gca,'ZLim',[0  30])
title('multivariate statistic');

%saveas(figure(1),strcat(gpath,runn,'.fig'),'fig');

runn = strcat('comprmses',lmodel,lprior,dataset,num2str(coint),st,num2str(fixparam),num2str(JustMode),num2str(lambdaseq(1)),num2str(lambdaseq(end)));

figure(1000)
%set(figure(1),'PaperPosition',[0 0 8 6])
print(char(strcat(gpath,runn,'.eps')),'-depsc'); 
print(char(strcat(gpath,runn,'.pdf')),'-dpdf');


figure(nvar+1);
Q = squeeze(Y(sele,nvar+1,:));
Q1 = repmat(Q(:,1),[1 length(lambdaseq)]);     
Q = flipdim(100*(Q-Q1),2);
  mesh(-sirf,datt,Q,'FaceColor','none','LineWidth',1,'LineStyle','-','EdgeColor',[0 0 0]);
Q1 = zeros(2,2);      
%hold on;mesh([Lambdaseq(1);Lambdaseq(end)],[datt(1);datt(end)],Q1,'FaceColor','none','LineWidth',1,'LineStyle',':','EdgeColor',[0 0 0]);
hold off;
ylabel('quarters ahead');
set(gca,'YTick',datt);
set(gca,'YTickLabel',num2str(datte));
  xlabel('\lambda/1+\lambda');
  set(gca,'XTick',-sirf);
  set(gca,'XTickLabel',tirf1);  
  zlabel('%');
%set(gca,'ZLim',[0  30])
%title('multivariate statistic');

%saveas(figure(1),strcat(gpath,runn,'.fig'),'fig');

runn = strcat('comprmses',lmodel,lprior,dataset,num2str(coint),st,num2str(fixparam),num2str(JustMode),num2str(lambdaseq(1)),num2str(lambdaseq(end)),'-multivar');

figure(nvar+1)
%print(char(strcat(gpath,runn,'.eps')),'-depsc'); 
print(char(strcat(gpath,runn,'.pdf')),'-dpdf');



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%      Tables
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fid = fopen(outfile,'w');		% output file (set to write)
fprintf(fid,'\n \\documentclass[12pt]{article}');
fprintf(fid,'\n \\begin{document}');
fprintf(fid,'\n \\setlength{\\tabcolsep}{.7mm}');

fprintf(fid,'\n beginning: %2.4f ; end:  %2.4f \n',[ti(Iseq(1)),ti(Iseq(end))]);

%% choose
if isnan(lambdaseq(end))
  chlambdaseq = [Inf NaN]
else
  chlambdaseq = [Inf]
end
chiotaseq = [];

for chla = chlambdaseq 

  chlambda = chla

  if ~isnan(chlambda)
    Il = find( floor(10*lambdaseq)==floor(10*chlambda) )
  elseif isnan(chlambda)
    Il = find( isnan(lambdaseq) )
  end	
  
  tabletitle = strcat('Percentage gain in RMSEs relative to Unrestricted VAR ');
  fprintf(1,'\n \\begin{table} \\begin{center}');
  fprintf(1,'\n \\caption{'); fprintf(1,tabletitle); fprintf(1,'}');
  
  fprintf(1,'\n \\vspace{.2cm} \n \\begin{tabular}{|l|');
  FORMAT = '\n {\\tiny  %2.0f}';
  datt = [datte];
  for i = 1:(nvar+1),
    fprintf(1,'c'); 
    FORMAT = strcat(FORMAT,' & {\\small  %5.3f}'); 
    if i == nvar+1
      datt = [datt,100*(squeeze(Y(sele,i,Il))-squeeze(Y(sele,i,1)))];
    else
      datt = [datt,-100*(squeeze(Y(sele,i,Il))./squeeze(Y(sele,i,1))-1)];
    end
    
    fprintf(1,'|'); 
  end
  fprintf(1,' }\\hline');
  FORMAT = strcat(FORMAT,' \\\\');  
  
  fprintf(1,'\n  ');
  for i = 1:nvar,
    fprintf(1,' & \\multicolumn{%2.0f}{c}',1); 
    fprintf(1,'{%9.92s}	 ',varnames{i}); 
  end
  fprintf(1,' & \\multicolumn{%2.0f}{c|}',1); 
  fprintf(1,'{multivariate}	\\\\ \\hline '); 
  
  fprintf(1,'\n  ');
  for i = 1:(nvar+1),
    fprintf(1,' & {\\tiny  $ \\lambda $= %2.2f}',chlambda); 
  end
  fprintf(1,'\\\\ \\hline '); 
  
  fprintf(1,FORMAT,datt');
  fprintf(1,' \\hline');
  fprintf(1,'\n \\end{tabular} \\end{center}');        
  fprintf(1,'\n \\end{table} ');
  

  tabletitle = strcat('RMSEs ');
  fprintf(fid,'\n \\begin{table} \\begin{center}');
  fprintf(fid,'\n \\caption{'); fprintf(fid,tabletitle); fprintf(fid,'}');
  
  fprintf(fid,'\n \\vspace{.2cm} \n \\begin{tabular}{|l|');
  FORMAT = '\n {\\tiny  %2.0f}';
  datt = [datte];
  for i = 1:(nvar+1),
    fprintf(fid,'c'); 
    FORMAT = strcat(FORMAT,' & {\\small  %5.3f}'); 

    datt = [datt,squeeze(Y(sele,i,Il))];
    fprintf(fid,'|'); 
  end
  fprintf(fid,' }\\hline');
  FORMAT = strcat(FORMAT,' \\\\');  
  
  fprintf(fid,'\n  ');
  for i = 1:nvar,
    fprintf(fid,' & \\multicolumn{%2.0f}{c}',1); 
    fprintf(fid,'{%9.92s}	 ',varnames{i}); 
  end
  fprintf(fid,' & \\multicolumn{%2.0f}{c|}',1); 
  fprintf(fid,'{multivariate}	\\\\ \\hline '); 
  
  fprintf(fid,'\n  ');
  for i = 1:(nvar+1),
    fprintf(fid,' & {\\tiny  $ \\lambda $= %2.2f}',chlambda); 
  end
  fprintf(fid,'\\\\ \\hline '); 
  
  fprintf(fid,FORMAT,datt');
  fprintf(fid,' \\hline');
  fprintf(fid,'\n \\end{tabular} \\end{center}');        
  fprintf(fid,'\n \\end{table} ');

end

%%% lambdahat 



tabletitle = strcat('Percentage gain in RMSEs  relative to Unrestricted VAR ');
fprintf(fid,'\n \\begin{table} \\begin{center}');
fprintf(fid,'\n \\caption{'); fprintf(fid,tabletitle); fprintf(fid,'}');

fprintf(fid,'\n \\vspace{.2cm} \n \\begin{tabular}{|l|');
FORMAT = '\n {\\tiny  %2.0f}';
datt = [datte];
for i = 1:(nvar+1),
  fprintf(fid,'c'); 
  FORMAT = strcat(FORMAT,' & {\\small  %5.3f}'); 
  if i == nvar+1
    datt = [datt,100*(squeeze(Ylambdahat(sele,i))-squeeze(Y(sele,i,1)))];
  else
    datt = [datt,-100*(squeeze(Ylambdahat(sele,i))./squeeze(Y(sele,i,1))-1)];
  end
  
  
  fprintf(fid,'|'); 
end
fprintf(fid,' }\\hline');
FORMAT = strcat(FORMAT,' \\\\');  

fprintf(fid,'\n  ');
for i = 1:nvar,
  fprintf(fid,' & \\multicolumn{%2.0f}{c}',1); 
  fprintf(fid,'{%9.92s}	 ',varnames{i}); 
end
fprintf(fid,' & \\multicolumn{%2.0f}{c|}',1); 
fprintf(fid,'{multivariate}	\\\\ \\hline '); 

fprintf(fid,'\n  ');
for i = 1:(nvar+1),
  fprintf(fid,' & {\\tiny  $ \\hat{\\lambda} $}'); 
end
fprintf(fid,'\\\\ \\hline '); 

fprintf(fid,FORMAT,datt');
fprintf(fid,' \\hline');
fprintf(fid,'\n \\end{tabular} \\end{center}');        
fprintf(fid,'\n \\end{table} ');


tabletitle = strcat('RMSEs');
fprintf(fid,'\n \\begin{table} \\begin{center}');
fprintf(fid,'\n \\caption{'); fprintf(fid,tabletitle); fprintf(fid,'}');

fprintf(fid,'\n \\vspace{.2cm} \n \\begin{tabular}{|l|');
FORMAT = '\n {\\tiny  %2.0f}';
datt = [datte];
for i = 1:(nvar+1),
  fprintf(fid,'c'); 
  FORMAT = strcat(FORMAT,' & {\\small  %5.3f}'); 
  datt = [datt,squeeze(Ylambdahat(sele,i))];

  fprintf(fid,'|'); 
end
fprintf(fid,' }\\hline');
FORMAT = strcat(FORMAT,' \\\\');  

fprintf(fid,'\n  ');
for i = 1:nvar,
  fprintf(fid,' & \\multicolumn{%2.0f}{c}',1); 
  fprintf(fid,'{%9.92s}	 ',varnames{i}); 
end
fprintf(fid,' & \\multicolumn{%2.0f}{c}',1); 
fprintf(fid,'{multivariate}	\\\\ \\hline '); 

fprintf(fid,'\n  ');
for i = 1:(nvar+1),
  fprintf(fid,' & {\\tiny  $ \\hat{\\lambda} $}'); 
end
fprintf(fid,'\\\\ \\hline '); 

fprintf(fid,FORMAT,datt');
fprintf(fid,' \\hline');
fprintf(fid,'\n \\end{tabular} \\end{center}');        
fprintf(fid,'\n \\end{table} ');



if any(isnan(lambdaseq))

  tabletitle = strcat('Percentage gain in RMSEs  relative to DSGE Model ');
  fprintf(fid,'\n \\begin{table} \\begin{center}');
  fprintf(fid,'\n \\caption{'); fprintf(fid,tabletitle); fprintf(fid,'}');
  
  fprintf(fid,'\n \\vspace{.2cm} \n \\begin{tabular}{|l|');
  FORMAT = '\n {\\tiny  %2.0f}';
  datt = [datte];
  for i = 1:(nvar+1),
    fprintf(fid,'c'); 
    FORMAT = strcat(FORMAT,' & {\\small  %5.3f}'); 
    if i == nvar+1
      datt = [datt,100*(squeeze(Ylambdahat(sele,i))-squeeze(Y(sele,i,end)))];
    else
      datt = [datt,-100*(squeeze(Ylambdahat(sele,i))./squeeze(Y(sele,i,end))-1)];
    end
    
    
    fprintf(fid,'|'); 
  end
  fprintf(fid,' }\\hline');
  FORMAT = strcat(FORMAT,' \\\\');  
  
  fprintf(fid,'\n  ');
  for i = 1:nvar,
    fprintf(fid,' & \\multicolumn{%2.0f}{c}',1); 
    fprintf(fid,'{%9.92s}	 ',varnames{i}); 
  end
  fprintf(fid,' & \\multicolumn{%2.0f}{c|}',1); 
  fprintf(fid,'{multivariate}	\\\\ \\hline '); 
  
  fprintf(fid,'\n  ');
  for i = 1:(nvar+1),
    fprintf(fid,' & {\\tiny  $ \\hat{\\lambda} $}'); 
  end
  fprintf(fid,'\\\\ \\hline '); 
  
  fprintf(fid,FORMAT,datt');
  fprintf(fid,' \\hline');
  fprintf(fid,'\n \\end{tabular} \\end{center}');        
  fprintf(fid,'\n \\end{table} ');


  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %%%%%%%%%%% new table
  
  tabletitle = strcat('Out-of-Sample Root Mean Squared Errors: DSGE-VAR versus VAR versus DSGE Model ');
  fprintf(fid,'\n \\begin{table} \\begin{center}');
  fprintf(fid,'\n \\caption{'); fprintf(fid,tabletitle); fprintf(fid,'}');
  
  fprintf(fid,'\n \\vspace{.2cm} \n \\begin{tabular}{lrl');
  FORMAT = ' ';
  FORMAT2 = ' ';
  for j = 1:length(sele),
    fprintf(fid,'c'); 
    FORMAT = strcat(FORMAT,' & {\\footnotesize  %2.3f}');
    FORMAT2 = strcat(FORMAT2,' & {\\footnotesize  (%2.1f)}');                         
  end
  fprintf(fid,' }\\hline');

  fprintf(fid,'\n & & & \\multicolumn{%2.0f}{c}{forecast horizon}   \\\\',length(sele));
  fprintf(fid,'\n & & ');
  for j = 1:length(sele),
    fprintf(fid,' & %2.0f ',datte(j));
  end
  fprintf(fid,'\\\\ ');
  
  for i = 1:nvar,
    %% DSGE-VAR
    fprintf(fid,'\n {\\small %9.92s} & & {\\footnotesize  DSGE-VAR($\\hat{\\lambda}$)}',varnames{i});
    fprintf(fid,FORMAT,squeeze(Ylambdahat(sele,i))');
    fprintf(fid,'\\\\[-.3ex]  ');
    
    %% DSGE
    fprintf(fid,'\n  & {\\tiny relative to} & {\\footnotesize  DSGE }');
    %fprintf(fid,FORMAT,squeeze(Y(sele,i,end))');
    %fprintf(fid,'\\\\[-1ex] \n  &  ');
    fprintf(fid,FORMAT2,-100*(squeeze(Ylambdahat(sele,i))./squeeze(Y(sele,i,end))-1)');
    fprintf(fid,'\\\\[-.3ex]  ');

    %% VAR
    fprintf(fid,'\n  &  {\\tiny relative to} & {\\footnotesize  VAR }');
    %fprintf(fid,FORMAT,squeeze(Y(sele,i,1))');
    %fprintf(fid,'\\\\[-1ex] \n  &  ');
    fprintf(fid,FORMAT2,-100*(squeeze(Ylambdahat(sele,i))./squeeze(Y(sele,i,1))-1)');
    fprintf(fid,'\\\\[.1ex]  ');

  end

  for i = (nvar+1),
    %% DSGE-VAR
    fprintf(fid,'\n {\\small Multivariate} & & {\\footnotesize  DSGE-VAR($\\hat{\\lambda}$)}');
    fprintf(fid,FORMAT,squeeze(Ylambdahat(sele,i))');
    fprintf(fid,'\\\\[-.3ex]  ');
    
    %% DSGE
    fprintf(fid,'\n {\\small Statistic} & {\\tiny relative to} & {\\footnotesize  DSGE }');
    %fprintf(fid,FORMAT,squeeze(Y(sele,i,end))');
    %fprintf(fid,'\\\\[-1ex] \n  &  ');
    fprintf(fid,FORMAT2,100*(squeeze(Ylambdahat(sele,i))-squeeze(Y(sele,i,end)))');
    fprintf(fid,'\\\\[-.3ex]  ');

    %% VAR
    fprintf(fid,'\n  & {\\tiny relative to} & {\\footnotesize  VAR }');
    %fprintf(fid,FORMAT,squeeze(Y(sele,i,1))');
    %fprintf(fid,'\\\\[-1ex] \n  &  ');
    fprintf(fid,FORMAT2,100*(squeeze(Ylambdahat(sele,i))-squeeze(Y(sele,i,1)))');
    fprintf(fid,'\\\\[.1ex]  ');

  end

  fprintf(fid,' \\hline');
  fprintf(fid,'\n \\end{tabular} \\end{center}');        
  fprintf(fid,'\n \\end{table} ');
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%% new new new table (DGSE)
if isnan(lambdaseq(end))
  
  tabletitle = strcat('Out-of-Sample Root Mean Squared Errors: Percentage Improvement relative to VAR ');
  fprintf(fid,'\n \\begin{table} \\begin{center}');
  fprintf(fid,'\n \\caption{'); fprintf(fid,tabletitle); fprintf(fid,'}');
  
  fprintf(fid,'\n \\vspace{.2cm} \n \\begin{tabular}{lrl');
  FORMAT = ' ';
  FORMAT2 = ' ';
  for j = 1:length(sele),
    fprintf(fid,'c'); 
    FORMAT = strcat(FORMAT,' & {\\footnotesize {\\it %2.2f}} ');
    FORMAT2 = strcat(FORMAT2,' & {\\footnotesize  %2.1f}');                         
  end
  fprintf(fid,' }\\hline');

  fprintf(fid,'\n & & & \\multicolumn{%2.0f}{c}{forecast horizon}   \\\\',length(sele));
  fprintf(fid,'\n & & ');
  for j = 1:length(sele),
    fprintf(fid,' & %2.0f ',datte(j));
  end
  fprintf(fid,'\\\\ ');
  
  for i = 1:nvar,
    %% DSGE-VAR
    fprintf(fid,'\n {\\small %9.92s} & {\\footnotesize  DSGE-VAR($\\hat{\\lambda}$),} & ',varnames{i});
    %fprintf(fid,FORMAT,squeeze(Ylambdahat(sele,i))');
    fprintf(fid,FORMAT2,-100*(squeeze(Ylambdahat(sele,i))./squeeze(Y(sele,i,1))-1)');
    fprintf(fid,'\\\\[-.3ex]  ');
    
    %% DSGE
    fprintf(fid,'\n  & {\\footnotesize  DSGE,} & ');
    %fprintf(fid,FORMAT,squeeze(Y(sele,i,end))');
    %fprintf(fid,'\\\\[-1ex] \n  &  ');
    fprintf(fid,FORMAT2,-100*(squeeze(Y(sele,i,end))./squeeze(Y(sele,i,1))-1)');
    fprintf(fid,'\\\\[-.3ex]  ');

    %% VAR
    fprintf(fid,'\n  &  {\\footnotesize  VAR,} &  {\\tiny RMSE:} ');
    fprintf(fid,FORMAT,squeeze(Y(sele,i,1))');
    %fprintf(fid,'\\\\[-1ex] \n  &  ');
    %fprintf(fid,FORMAT2,-100*(squeeze(Ylambdahat(sele,i))./squeeze(Y(sele,i,1))-1)');
    fprintf(fid,'\\\\[.1ex]  ');

  end

  for i = (nvar+1),
    


    %% DSGE-VAR
    fprintf(fid,'\n {\\small Multivariate} & {\\footnotesize  DSGE-VAR($\\hat{\\lambda}$),} & ');
    %fprintf(fid,FORMAT,squeeze(Ylambdahat(sele,i))');
    fprintf(fid,FORMAT2,100*(squeeze(Ylambdahat(sele,i))-squeeze(Y(sele,i,1)))');
    fprintf(fid,'\\\\[-.3ex]  ');


    %% DSGE
    fprintf(fid,'\n {\\small Statistic} & {\\footnotesize  DSGE,} & ');
    %fprintf(fid,FORMAT,squeeze(Y(sele,i,end))');
    %fprintf(fid,'\\\\[-1ex] \n  &  ');
    fprintf(fid,FORMAT2,100*(squeeze(Y(sele,i,end))-squeeze(Y(sele,i,1)))');
    fprintf(fid,'\\\\[-.3ex]  ');


    %% VAR
    fprintf(fid,'\n  &  {\\footnotesize  VAR,} &  {\\tiny RMSE:} ');
    fprintf(fid,FORMAT,squeeze(Y(sele,i,1))');
    %fprintf(fid,'\\\\[-1ex] \n  &  ');
    %fprintf(fid,FORMAT2,-100*(squeeze(Ylambdahat(sele,i))./squeeze(Y(sele,i,1))-1)');
    fprintf(fid,'\\\\[.1ex]  ');


  end

  fprintf(fid,' \\hline');
  fprintf(fid,'\n \\end{tabular} \\end{center}');        
  fprintf(fid,'\n \\end{table} ');
  


  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %%%%%%%%%%% new new new table (INF)
elseif isinf(lambdaseq(end))
  
  tabletitle = strcat('Out-of-Sample Root Mean Squared Errors: Percentage Improvement relative to VAR ');
  fprintf(fid,'\n \\begin{table} \\begin{center}');
  fprintf(fid,'\n \\caption{'); fprintf(fid,tabletitle); fprintf(fid,'}');
  
  fprintf(fid,'\n \\vspace{.2cm} \n \\begin{tabular}{lrl');
  FORMAT = ' ';
  FORMAT2 = ' ';
  for j = 1:length(sele),
    fprintf(fid,'c'); 
    FORMAT = strcat(FORMAT,' & {\\footnotesize {\\it %2.2f}} ');
    FORMAT2 = strcat(FORMAT2,' & {\\footnotesize  %2.1f}');                         
  end
  fprintf(fid,' }\\hline');

  fprintf(fid,'\n & & & \\multicolumn{%2.0f}{c}{forecast horizon}   \\\\',length(sele));
  fprintf(fid,'\n & & ');
  for j = 1:length(sele),
    fprintf(fid,' & %2.0f ',datte(j));
  end
  fprintf(fid,'\\\\ ');
  
  for i = 1:nvar,
    %% DSGE-VAR
    fprintf(fid,'\n {\\small %9.92s} & {\\footnotesize  DSGE-VAR($\\hat{\\lambda}$),} & ',varnames{i});
    %fprintf(fid,FORMAT,squeeze(Ylambdahat(sele,i))');
    fprintf(fid,FORMAT2,-100*(squeeze(Ylambdahat(sele,i))./squeeze(Y(sele,i,1))-1)');
    fprintf(fid,'\\\\[-.3ex]  ');
    
    %% DSGE
    fprintf(fid,'\n  & {\\footnotesize  DSGE-VAR($\\infty$),} & ');
    %fprintf(fid,FORMAT,squeeze(Y(sele,i,end))');
    %fprintf(fid,'\\\\[-1ex] \n  &  ');
    fprintf(fid,FORMAT2,-100*(squeeze(Y(sele,i,end-1))./squeeze(Y(sele,i,1))-1)');
    fprintf(fid,'\\\\[-.3ex]  ');

    %% VAR
    fprintf(fid,'\n  &  {\\footnotesize  VAR,} &  {\\tiny RMSE:} ');
    fprintf(fid,FORMAT,squeeze(Y(sele,i,1))');
    %fprintf(fid,'\\\\[-1ex] \n  &  ');
    %fprintf(fid,FORMAT2,-100*(squeeze(Ylambdahat(sele,i))./squeeze(Y(sele,i,1))-1)');
    fprintf(fid,'\\\\[.1ex]  ');

  end

  for i = (nvar+1),
    


    %% DSGE-VAR
    fprintf(fid,'\n {\\small Multivariate} & {\\footnotesize  DSGE-VAR($\\hat{\\lambda}$),} & ');
    %fprintf(fid,FORMAT,squeeze(Ylambdahat(sele,i))');
    fprintf(fid,FORMAT2,100*(squeeze(Ylambdahat(sele,i))-squeeze(Y(sele,i,1)))');
    fprintf(fid,'\\\\[-.3ex]  ');


    %% DSGE
    fprintf(fid,'\n {\\small Statistic} & {\\footnotesize  DSGE-VAR($\\infty$),} & ');
    %fprintf(fid,FORMAT,squeeze(Y(sele,i,end))');
    %fprintf(fid,'\\\\[-1ex] \n  &  ');
    fprintf(fid,FORMAT2,100*(squeeze(Y(sele,i,end-1))-squeeze(Y(sele,i,1)))');
    fprintf(fid,'\\\\[-.3ex]  ');


    %% VAR
    fprintf(fid,'\n  &  {\\footnotesize  VAR,} &  {\\tiny RMSE:} ');
    fprintf(fid,FORMAT,squeeze(Y(sele,i,1))');
    %fprintf(fid,'\\\\[-1ex] \n  &  ');
    %fprintf(fid,FORMAT2,-100*(squeeze(Ylambdahat(sele,i))./squeeze(Y(sele,i,1))-1)');
    fprintf(fid,'\\\\[.1ex]  ');


  end

  fprintf(fid,' \\hline');
  fprintf(fid,'\n \\end{tabular} \\end{center}');        
  fprintf(fid,'\n \\end{table} ');

  disp('MONA')
end


fprintf(fid,'\n \\end{document}');
fclose('all');		% close output file


disp('press any key to clear all plots');
pause;
close all;

