close all;
clear all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% PRELIMINARY STUFF
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
run startdsswfed;
!hostname;
!ps -C matlab;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%      paths & parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
varspec;

[fpath,spath,gpath] = pathspec(num2str(floor(dataset)));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%*
% Load information for prior distribution

lprior    = num2str(mprior);
lmodel    = strcat('m',num2str(mspec));
priorfile = strcat('pri',lprior)
prior = feval(priorfile);

pmean  = prior(1:npara,1);
pstdd  = prior(1:npara,2);
pshape = prior(1:npara,3);

pshape = pshape.*(1-para_mask);


nonpolipar = [1:1:npara];
nonpolipar(polipar) = [];

% Load transformation scheme for parameters
trspec = feval('transp',mspec);

trspec(:,1) = trspec(:,1).*(1-para_mask);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% load data
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[YYall,XXall,ti,nobsall] = loaddata(dataset,fpath,T0,Tend,coint,cointadd,cointall,nvar,nlags,mspec);

dataset = num2str(10*dataset);

Iseq = find(ti == dates);
I = Iseq;
if stime                           
  YY = YYall(I-stime+1:I,:);
  XX = XXall(I-stime+1:I,:);             
  tiI = ti(I-stime+1:I);
  
  YY_p = YYall(1:I-stime,:);
  XX_p = XXall(1:I-stime,:);             
  nobs_p = size(YY_p,1)
  
else
  YY     = YYall(1:I,:);
  XX     = XXall(1:I,:);                   
  tiI = ti(1:I);
end
nobs = size(YY,1);

k     = nlags*nvar;

YYYY = YY'*YY;
XXYY = XX'*YY;
XXXX = XX'*XX;

MeY_0 = XXYY(1+cointall,:)'/nobs
VaY_0 = (YYYY/nobs)-MeY_0*MeY_0';
stdY_0 = sqrt(diag(VaY_0));
CorY_0 = VaY_0./(stdY_0*stdY_0');
%CoY_0 = (XXYY(1+cointall+1:1+cointall+nvar,:)/nobs)-MeY_0*MeY_0'
%ACorY_0 = diag(CoY_0)./diag(VaY_0)
ACorY_0 = zeros(nvar,1);
for ii = 1:nvar;
  ACorY_0(ii) = corr(YY(:,ii),XX(:,1+cointall+ii));
end
ACorY_0

stats_0 = [MeY_0' stdY_0' ACorY_0' CorY_0(:)'];

infile200 = strcat(spath,'/stats');		
fid200 = fopen(infile200,'r');		% output file (set to write)   
stats_0 = fread(fid200,[1 inf],'single'); 
fclose(fid200);

infile200 = strcat(spath,'/statsPre');		
fid200 = fopen(infile200,'r');		% output file (set to write)   
stats_0b = fread(fid200,[1 inf],'single'); 
fclose(fid200);

ICUM = find(cum_for);
INCUM = find(cum_for == 0);

lambdas = lambdaseq     
  if isnan(lambdas)
    coint0 = coint;
  else
    coint0 = cointall;
  end
fixparam = fixparamseq(1);
if fixparam ~= 0 
  fixparam
  break
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Set parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% WANT POPULATION OR SAMPLE MOMENTS?
POPUL = 0
if POPUL 
  POP_ = '';
else
  POP_ = 'P';
end

percent = .90;

dobench = 2%inf;

mspecno = [1 3  5];
mspeclist = [6,106,6,106,6,106];
mspec_ref_list = cell(length(mspeclist),1);
mspec_ref_list(1) = {[]};
mspec_ref_list(2) = {[NaN]};
mspec_ref_list(3) = {[]};
mspec_ref_list(4) = {[NaN]};
mspec_ref_list(5) = {[]};
mspec_ref_list(6) = {[NaN]};

nobsdrat_list = cell(length(mspeclist),1);
nobsdrat_list(1) = {[0/100]};
nobsdrat_list(2) = {[4/100]};
nobsdrat_list(3) = {[0/100]};
nobsdrat_list(4) = {[4/100]};
nobsdrat_list(5) = {[0/100]};
nobsdrat_list(6) = {[4/100]};

nlagsc_list = cell(length(mspeclist),1);
nlagsc_list(1) = {[1]};
nlagsc_list(2) = {[1]};
nlagsc_list(3) = {[1]};
nlagsc_list(4) = {[1]};
nlagsc_list(5) = {[1]};
nlagsc_list(6) = {[1]};

mprior_list = cell(length(mspeclist),1);
mprior_list(1) = {[52]};
mprior_list(2) = {[53]};
mprior_list(3) = {[42]};
mprior_list(4) = {[43]};
mprior_list(5) = {[62]};
mprior_list(6) = {[63]};

prio_list = cell(length(mspeclist),1);
prio_list(1) = {[0]};
prio_list(2) = {[0]};
prio_list(3) = {[0]};
prio_list(4) = {[0]};
prio_list(5) = {[0]};
prio_list(6) = {[0]};

stup_list = cell(length(mspeclist),1);
stup_list(1) = {[1]};
stup_list(2) = {[1]};
stup_list(3) = {[1]};
stup_list(4) = {[1]};
stup_list(5) = {[1]};
stup_list(6) = {[1]};

Acolor = zeros(length(mspeclist),3);
Acolor(1,:) = [0 1 0]%[0 .2 .2];
Acolor(2,:) = [0 0 1]%[0 .2 .2];
Acolor(3,:) = [1 0 0]%[0 .2 .2];
Acolor(4,:) = [0 0 0]%[0 .2 .2];

allmodelnames = cell(20,1);
allmodelnames(1) = {'No Dynamic Indexation'};
allmodelnames(6) = {'Baseline'};
allmodelnames(4) = {'Flex Wages and  Prices'};
allmodelnames(5) = {'Flex Wages'};
allmodelnames(7) = {'Full Indexation'};
allmodelnames(8) = {'No Habit'};
allmodelnames(9) = {'No Investment Adj. Costs'};
allmodelnames(10) = {'No Capital Adj. Costs'};
allmodelnames(11) = {'No Wage Stickiness and No Indexation'};
allmodelnames(12) = {'Uncorrelated Mark-up Shocks'};
allmodelnames(13) = {'Flex Prices'};
allmodelnames(14) = {'Uncorrelated Mark-up Shocks and No Indexation'};


modelnames = cell(length(mspeclist),1);
for ii = 1:length(mspeclist)
  if mspeclist(ii) > 100
  modelnames{ii} = {allmodelnames{mspeclist(ii)-100}};
  else
  modelnames{ii} = {allmodelnames{mspeclist(ii)}};
  end
end

modls = 'm';
for ispec = mspecno 
  mspec = mspeclist(ispec);
  modls = strcat(modls,num2str(mspec));
  modls = strcat(modls,num2str(mprior_list{ispec}));  
  if ~isempty(mspec_ref_list{ispec})
    modls = strcat(modls,'-',num2str(mspec_ref_list{ispec}));
    modls = strcat(modls,'n',num2str(100*nobsdrat_list{ispec}));
    modls = strcat(modls,'l',num2str(nlagsc_list{ispec}));
    modls = strcat(modls,'stup',num2str(stup_list{ispec}));
  end    

 if prio_list{ispec} == 1
    modls = strcat(modls,'Prio');
  elseif prio_list{ispec} == 0
    modls = strcat(modls,'Post');
  end
  modls = strcat(modls,'---');  
end


outfile00 = strcat(fpath,modls,lprior,POP_,'-PMom.tex');		% output file name 
fid00 = fopen(outfile00,'w')		% output file (set to write)
fprintf(fid00,'\n \\documentclass[12pt]{article} \n \\usepackage[dvips]{color}\n ');
fprintf(fid00,'\n \\begin{document}');

Theta1 = [];
Theta2 = [];
ThetaB = [];


for ispec = mspecno 
  mspec = mspeclist(ispec)
  lmodel    = strcat('m',num2str(mspec));

  mprior = mprior_list{ispec}
  lprior    = num2str(mprior);
  
  mspec_ref = mspec_ref_list{ispec}
  nobsdrat = nobsdrat_list{ispec}
  nlagsc = nlagsc_list{ispec}
  n_s = [];
  if isempty(mspec_ref)
    lmodel_ref = [];
    nobsdrat_ = [];
    nlagsc_ = [];
    n_s_ = [];
    stup_ = [];

    %lprior    = strcat(lprior,'2');
    
  else
    lmodel_ref = strcat('m',num2str(mspec_ref));
    nobsdrat_ = num2str(100*nobsdrat);
    n_s_ = [];
    stup_ = num2str(stup);
    if nlagsc == 4
      nlagsc_ = [];
    else
      nlagsc_ = num2str(nlagsc);
    end  
    
  end


  if prio_list{ispec} == 1
    infile01 =  strcat(spath,'/mhpriopara',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_,'Mean')
    
   elseif prio_list{ispec} == 0
    infile01 = strcat(spath,lmodel,lprior,'para',num2str(coint0),st,num2str(100*lambdas),num2str(100*ti(I)),num2str(nlags),'Mean');
  end
  

  fid01 = fopen(infile01,'r');		% output file (set to write)   
  parahat = fread(fid01,[1,inf],'single')';
  fclose(fid01);

  if prio_list{ispec} == 1
    infile1 = strcat(spath,'/mhNIpriopara',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_)
    fid1 = fopen(infile1,'r');		% input file (set to read)   
                                        %numb1 = nburn*npara*4;                  % number of bites to discard
                                        %status = fseek(fid1,numb1,'bof');       % discard nburn 
  elseif prio_list{ispec} == 0
    infile1 = strcat(spath,'/mhpara',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_,num2str(coint0),st,num2str(100*lambdas),num2str(100*ti(I)),num2str(nlags),num2str(fixparam),num2str(JustMode))		
    num1 = nblocks*nsim*npara*4;            % number of bites per file
    numb1 = nburn*npara*4;                  % number of bites to dicard


    %% get means and st dev of parameters
    fid1 = fopen(infile1,'r');		% input file (set to read)               
    status = fseek(fid1,numb1,'bof');

  end
  theta = fread(fid1,[npara,inf],'single')';
  fclose(fid1);

	thetahat = mean(theta,1)';

	thetasig = cov(theta,1);
        thetastd = sqrt(diag(thetasig));

	thetabands = hpdint(theta,percent,1)';

	Theta1 = [Theta1,thetahat];
	%Theta2 = [Theta2,thetahat,thetabands];
	Theta2 = [Theta2,thetahat,thetastd];
	ThetaB = [ThetaB,thetabands];

  
end


fprintf(1,'\n');



fprintf(fid00,'\n \\begin{table}[h] \\centering');        
fprintf(fid00,'\n \\caption{Parameter Estimates: Mean} \n\\vspace*{.5cm}');
fprintf(fid00,'\n \\begin{tabular}{c@{\\hspace*{.05cm}}');
for ispec = mspecno 
  fprintf(fid00,'ll@{\\hspace*{.5cm}}');
end
fprintf(fid00,'}\\hline \n');
fprintf(fid00,' Paramter  ');
for ispec = mspecno 
  mspec = mspeclist(ispec);
  fprintf(fid00,' &  \\multicolumn{2}{c}{%9.99s} ',char(modelnames{ispec}));
end
fprintf(fid00,'\\\\  \n');
for ispec = mspecno 
  if prio_list{ispec} == 1
    fprintf(fid00,' &  \\multicolumn{2}{c}{ Prior} ');
  elseif prio_list{ispec} == 0
    fprintf(fid00,' &  \\multicolumn{2}{c}{ Posterior} ');
  end
end
fprintf(fid00,'\\\\  \n');
for ispec = mspecno 
  mspec = mspeclist(ispec);
  fprintf(fid00,' &  \\multicolumn{2}{c}{$T^*$= %2.0f} ',100*nobsdrat_list{ispec});
end
fprintf(fid00,'\\\\  \n');
fprintf(fid00,'\\\\ \\hline \n');

for i = 1:length(para_names)
  fprintf(fid00,' \n $%4.99s$   ',para_names{i});
  L =1;
  for ispec = mspecno 

    fprintf(fid00,' & %3.2f & (%3.2f) ',Theta2(i,L:L+1));
        L=L+2;
  end
  fprintf(fid00,'\\\\ ');
end   
fprintf(fid00,'\\\\  \\hline');		    
fprintf(fid00,'\n \\end{tabular}');
fprintf(fid00,'\n \\end{table} \n\n');



fprintf(fid00,'\n \\begin{table}[h] \\centering');        
fprintf(fid00,'\n \\caption{Parameter Estimates: Mean} \n\\vspace*{.5cm}');
fprintf(fid00,'\n \\begin{tabular}{c@{\\hspace*{.05cm}}');
for ispec = mspecno 
  fprintf(fid00,'l@{\\hspace*{.5cm}}');
end
fprintf(fid00,'}\\hline \n');
fprintf(fid00,' Paramter  ');
for ispec = mspecno 
  mspec = mspeclist(ispec);
  fprintf(fid00,' &  \\multicolumn{1}{c}{%9.99s} ',char(modelnames{ispec}));
end
fprintf(fid00,'\\\\  \n');
for ispec = mspecno 
  if prio_list{ispec} == 1
    fprintf(fid00,' &  \\multicolumn{1}{c}{ Prior} ');
  elseif prio_list{ispec} == 0
    fprintf(fid00,' &  \\multicolumn{1}{c}{ Posterior} ');
  end
end
fprintf(fid00,'\\\\  \n');
for ispec = mspecno 
  mspec = mspeclist(ispec);
  fprintf(fid00,' &  \\multicolumn{1}{c}{$T^*$= %2.0f} ',100*nobsdrat_list{ispec});
end
fprintf(fid00,'\\\\  \n');
fprintf(fid00,'\\\\ \\hline \n');

for i = 1:length(para_names)
  fprintf(fid00,' \n $%4.99s$   ',para_names{i});
  L =1;
  for ispec = mspecno 

    fprintf(fid00,' & %3.2f ',Theta2(i,L));
        L=L+2;
  end
  fprintf(fid00,'\\\\[-1ex] ');
  fprintf(fid00,' \n  ');
  L =1;
  for ispec = mspecno 

    fprintf(fid00,' & {\\scriptsize (%3.2f) }',Theta2(i,L+1));
        L=L+2;
  end
  fprintf(fid00,'\\\\ ');

end   
fprintf(fid00,'\\\\  \\hline');		    
fprintf(fid00,'\n \\end{tabular}');
fprintf(fid00,'\n \\end{table} \n\n');


fprintf(fid00,'\n \\begin{table}[h] \\centering');        
fprintf(fid00,'\n \\caption{Parameter Estimates: Mean} \n\\vspace*{.5cm}');
fprintf(fid00,'\n \\begin{tabular}{c@{\\hspace*{.05cm}}');
for ispec = mspecno 
  fprintf(fid00,'l@{\\hspace*{.5cm}}');
end
fprintf(fid00,'}\\hline \n');
fprintf(fid00,' Paramter  ');
for ispec = mspecno 
  mspec = mspeclist(ispec);
  fprintf(fid00,' &  \\multicolumn{1}{c}{%9.99s} ',char(modelnames{ispec}));
end
fprintf(fid00,'\\\\  \n');
for ispec = mspecno 
  if prio_list{ispec} == 1
    fprintf(fid00,' &  \\multicolumn{1}{c}{ Prior} ');
  elseif prio_list{ispec} == 0
    fprintf(fid00,' &  \\multicolumn{1}{c}{ Posterior} ');
  end
end
fprintf(fid00,'\\\\  \n');
for ispec = mspecno 
  mspec = mspeclist(ispec);
  fprintf(fid00,' &  \\multicolumn{1}{c}{$T^*$= %2.0f} ',100*nobsdrat_list{ispec});
end
fprintf(fid00,'\\\\  \n');
fprintf(fid00,'\\\\ \\hline \n');

for i = 1:length(para_names)
  fprintf(fid00,' \n $%4.99s$   ',para_names{i});
  L =1;
  for ispec = mspecno 

    fprintf(fid00,' & %3.2f ',Theta2(i,L));
        L=L+2;
  end
  fprintf(fid00,'\\\\[-1ex] ');
  fprintf(fid00,' \n  ');
  L =1;
  for ispec = mspecno 

    fprintf(fid00,' & {\\scriptsize (%3.2f,%3.2f) }',ThetaB(i,L:L+1));
        L=L+2;
  end
  fprintf(fid00,'\\\\ ');

end   
fprintf(fid00,'\\\\  \\hline');		    
fprintf(fid00,'\n \\end{tabular}');
fprintf(fid00,'\n \\end{table} \n\n');




fprintf(fid00,'\n \\end{document}');

fclose(fid00);		% close output file


return
