%% marginal cost
GAM0(margcost,mc_t) = 1;
GAM0(margcost,w_t) = -(1-alp);
GAM0(margcost,rk_t) = -alp;


%% price setting
GAM0(prsett,pi_t) = (1+iota_p*bet)*zeta_p;
GAM0(prsett,E_pi) = -bet*zeta_p;
GAM0(prsett,mc_t) = -(1-zeta_p)*(1-bet*zeta_p);
if any(mspec == [101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16])
  GAM0(prsett,laf_t) = -1;
  %% transform laf_t, old version: -laf*(1-zeta_p)*(1-bet*zeta_p)/(1+laf);
end

GAM1(prsett,pi_t) = iota_p*zeta_p;


%% capital accumulation
GAM0(capacc,kbar_t) = 1;
GAM0(capacc,z_t) = (1-istokbarst);  
GAM0(capacc,i_t) = -istokbarst;
if any(mspec == [])
  GAM0(capacc,mu_t) = -istokbarst*(1+bet)*exp(2*zstar)*s2; 
  %% transformed mu_t; old version -istokbarst
elseif any(mspec == [])
  GAM0(capacc,mu_t) = -istokbarst*(1+bet); 
  %% transformed mu_t; old version -istokbarst
end

GAM1(capacc,kbar_t) = (1-istokbarst);


%% effective capital 
GAM0(effcap,k_t) = 1;
GAM0(effcap,u_t) = -1;
GAM0(effcap,z_t) = 1;

GAM1(effcap,kbar_t) = 1;


%% Euler
GAM0(euler,xi_t) = (exp(zstar)-h*bet)*(exp(zstar)-h);
if any(mspec == [])    
  GAM0(euler,b_t) = -(exp(2*zstar)+h^2*bet); %% old version: -(exp(zstar)-h)*exp(zstar);
  GAM0(euler,b_t) = GAM0(euler,b_t) + bet*h*rho_b*exp(-zstar)*(exp(2*zstar)+h^2*bet); 
  %% old version: GAM0(euler,b_t)+(exp(zstar)-h)*h*bet*rho_b; this is Eb_t+1
end
GAM0(euler,z_t) = h*exp(zstar);
GAM0(euler,z_t) = GAM0(euler,z_t)-h*bet*exp(zstar)*rho_z;   %% this is Ez_t+1 
GAM0(euler,c_t) = (exp(2*zstar)+h^2*bet);
GAM0(euler,E_c) = -h*bet*exp(zstar);

GAM1(euler,c_t) = h*exp(zstar);

%% money demand
GAM0(moneydem,m_t) = nu_m;
if any(mspec == [])    
  GAM0(moneydem,b_t)   = -(exp(2*zstar)+h^2*bet)*exp(-zstar)/(exp(zstar)-h);
  %% old version -1
  GAM0(moneydem,chi_t) = -nu_m; %% transformed chi_t shock, old version: -1
end
GAM0(moneydem,xi_t) = 1;
GAM0(moneydem,R_t) = 1/(Rstarn-1);


%% marginal utility
GAM0(margut,xi_t) = 1;
GAM0(margut,E_xi) = -1;
GAM0(margut,z_t) = rho_z;   %% this is Ez_t+1 
GAM0(margut,R_t) = -1;
GAM0(margut,E_pi) = 1;


%% investment FOC
if any(mspec == [])
  GAM0(invfoc,xik_t) = 1;
  GAM0(invfoc,mu_t) = (1+bet); %% old version 1/(s2*exp(2*zstar))
  GAM0(invfoc,xi_t) = -1;
else

  GAM0(invfoc,xik_t) = exp(-2*zstar)/s2;
  if any(mspec == [])
    GAM0(invfoc,mu_t) = (1+bet); %% old version 1/(s2*exp(2*zstar))
  end
  GAM0(invfoc,xi_t) = -exp(-2*zstar)/s2;
  GAM0(invfoc,i_t) = -(1+bet);
  GAM0(invfoc,E_i) = bet;
  GAM0(invfoc,z_t) = -1;
  GAM0(invfoc,z_t) = GAM0(invfoc,z_t)+bet*rho_z;  %% this is Ez_t+1 

  GAM1(invfoc,i_t) = -1;


end


%% return to capital
GAM0(rettocap,xik_t) = 1;
GAM0(rettocap,E_xi) = -rkstar/(rkstar+1-del);
GAM0(rettocap,E_rk) = -rkstar/(rkstar+1-del);
GAM0(rettocap,E_xik) = -(1-del)/(rkstar+1-del);
GAM0(rettocap,z_t) = rho_z; %% this is Ez_t+1 


%% capital utilization
if any(mspec == [110,10])
  GAM0(utcap,u_t) = 1;
  GAM0(utcap,rk_t) = 0;
else
  GAM0(utcap,u_t) = a2;
  GAM0(utcap,rk_t) = -rkstar;
end

%% optimal wage
GAM0(optwage,wtil_t) = 1+nu_l*(1+law)/law;
GAM0(optwage,w_t) = 1+zeta_w*bet*nu_l*(1+law)/law;
GAM0(optwage,E_wtil) = -zeta_w*bet*(1+nu_l*(1+law)/law);
GAM0(optwage,E_w) = -zeta_w*bet*(1+nu_l*(1+law)/law);
if any(mspec == [])
  GAM0(optwage,b_t) = -(1-zeta_w*bet)*(exp(2*zstar)+h^2*bet)*exp(-zstar)/(exp(zstar)-h);
  %% old version: -(1-zeta_w*bet)
end
if any(mspec == [101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16])
  GAM0(optwage,phi_t) = -1; %% transformed phi_t; old version: -(1-zeta_w*bet);
end
GAM0(optwage,L_t) = -(1-zeta_w*bet)*nu_l;
GAM0(optwage,xi_t) = (1-zeta_w*bet);
GAM0(optwage,E_pi) = -zeta_w*bet*(1+nu_l*(1+law)/law);
GAM0(optwage,z_t) = -zeta_w*bet*rho_z*(1+nu_l*(1+law)/law);
if any(mspec == [102,2])
  GAM0(optwage,z_t) = GAM0(optwage,z_t)+zeta_w*bet*iota_w*(1+nu_l*(1+law)/law);
end
GAM0(optwage,pi_t) = zeta_w*bet*iota_w*(1+nu_l*(1+law)/law);


%% aggregate wage evolution
GAM0(aggwage,w_t) = 1;
GAM0(aggwage,pi_t) = 1;
GAM0(aggwage,z_t) = 1;
GAM0(aggwage,wtil_t) = -(1-zeta_w)/zeta_w;

GAM1(aggwage,w_t) = 1;
GAM1(aggwage,pi_t) = iota_w;
if any(mspec == [102,2])
  GAM1(aggwage,z_t) = iota_w;
end;

%% capital labor ratio
GAM0(caplabrat,k_t) = 1;
GAM0(caplabrat,L_t) = -1;
GAM0(caplabrat,w_t) = -1;
GAM0(caplabrat,rk_t) = 1;


%% aggregate resources
GAM0(resources,y_t) = 1;
GAM0(resources,c_t) = -cstar/(cstar+istar);
GAM0(resources,i_t) = -istar/(cstar+istar);
GAM0(resources,g_t) = -1;
GAM0(resources,u_t) = -rkstar*kstar/(cstar+istar);


%% production function
GAM0(prod,y_t) = 1;
GAM0(prod,k_t) = -alp*(ystar+Bigphi)/ystar;
GAM0(prod,L_t) = -(1-alp)*(ystar+Bigphi)/ystar;


%% Taylor
GAM0(taylor,R_t) = 1;
GAM0(taylor,pi_t) = -(1-rho_r)*psi1;
if any(mspec == [1003])
  GAM0(taylor,y_t) = -(1-rho_r)*psi2;     %% targeting output 
  GAM0(taylor,y_tFP) = +(1-rho_r)*psi2;     %% targeting output gap
else
  GAM0(taylor,y_t) = -(1-rho_r)*psi2;     %% targeting output 
end

GAM1(taylor,R_t) = rho_r;

PPSI(taylor,r_sh) = 1;


if any(mspec == [1003,1004]) %% output gap model 

  %% marginal cost
  GAM0(margcostFP,mc_tFP) = 1;
  GAM0(margcostFP,w_tFP) = -(1-alp);
  GAM0(margcostFP,rk_tFP) = -alp;
  
  
  %% price setting
  GAM0(prsettFP,mc_tFP) = (1+laf);
  if any(mspec == [1,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116])
    GAM0(prsettFP,laf_t) = laf*(1+laf)/(laf*(1-zeta_p)*(1-bet*zeta_p)); 
    %% transform laf_t, old version: laf
  end
  
  %% capital accumulation
  GAM0(capaccFP,kbar_tFP) = 1;
  GAM0(capaccFP,z_t) = (1-istokbarst);  
  GAM0(capaccFP,i_tFP) = -istokbarst;
  if any(mspec == [1])
    GAM0(capaccFP,mu_t) = -istokbarst*(1+bet)*exp(2*zstar)*s2; 
    %% transformed mu_t; old version -istokbarst
  end
  
  GAM1(capaccFP,kbar_tFP) = (1-istokbarst);
  
  
  %% effective capital 
  GAM0(effcapFP,k_tFP) = 1;
  GAM0(effcapFP,u_tFP) = -1;
  GAM0(effcapFP,z_t) = 1;
  
  GAM1(effcapFP,kbar_tFP) = 1;
  
  
  %% Euler
  GAM0(eulerFP,xi_tFP) = (exp(zstar)-h*bet)*(exp(zstar)-h);
  if any(mspec == [1])    
    GAM0(eulerFP,b_t) = -(exp(2*zstar)+h^2*bet); %% old version: -(exp(zstar)-h)*exp(zstar);
    GAM0(eulerFP,b_t) = GAM0(eulerFP,b_t) + bet*h*rho_b*exp(-zstar)*(exp(2*zstar)+h^2*bet); 
    %% old version: GAM0(eulerFP,b_t)+(exp(zstar)-h)*h*bet*rho_b; this is Eb_t+1
  end
  GAM0(eulerFP,z_t) = h*exp(zstar);
  GAM0(eulerFP,z_t) = GAM0(eulerFP,z_t)-h*bet*exp(zstar)*rho_z;   %% this is Ez_t+1 
  GAM0(eulerFP,c_tFP) = (exp(2*zstar)+h^2*bet);
  GAM0(eulerFP,E_cFP) = -h*bet*exp(zstar);

  GAM1(eulerFP,c_tFP) = h*exp(zstar);
  
  
  %% investment FOC
  GAM0(invfocFP,xik_tFP) = exp(-2*zstar)/s2;
  if any(mspec == [1])
    GAM0(invfocFP,mu_t) = (1+bet); %% old version 1/(s2*exp(2*zstar))
  end
  GAM0(invfocFP,xi_tFP) = -exp(-2*zstar)/s2;
  GAM0(invfocFP,i_tFP) = -(1+bet);
  GAM0(invfocFP,E_iFP) = bet;
  GAM0(invfocFP,z_t) = -1;
  GAM0(invfocFP,z_t) = GAM0(invfocFP,z_t)+bet*rho_z;  %% this is Ez_t+1 
  
  GAM1(invfocFP,i_tFP) = -1;
  
  
  %% return to capital
  GAM0(rettocapFP,xik_tFP) = 1;
  GAM0(rettocapFP,E_xiFP) = -rkstar/(rkstar+1-del);
  GAM0(rettocapFP,E_rkFP) = -rkstar/(rkstar+1-del);
  GAM0(rettocapFP,E_xikFP) = -(1-del)/(rkstar+1-del);
  GAM0(rettocapFP,z_t) = rho_z; %% this is Ez_t+1 
  
  
  %% capital utilization
  GAM0(utcapFP,u_tFP) = a2;
  GAM0(utcapFP,rk_tFP) = -rkstar;
  
  
  %% optimal wage
  GAM0(optwageFP,w_tFP) = 1;
  if any(mspec == [1])
    GAM0(optwageFP,b_t) = -(exp(2*zstar)+h^2*bet)*exp(-zstar)/(exp(zstar)-h);
    %% old version: -1
  end
  if any(mspec == [103,104])
    GAM0(optwageFP,phi_t) = -1/(1-zeta_w*bet); %% transformed phi_t; (should be multiplied by 1/(1-zeta_w*bet), but zeta_w=0 under flex)
  end
  GAM0(optwageFP,L_tFP) = -nu_l;
  GAM0(optwageFP,xi_tFP) = 1;
  
  
  %% capital labor ratio
  GAM0(caplabratFP,k_tFP) = 1;
  GAM0(caplabratFP,L_tFP) = -1;
  GAM0(caplabratFP,w_tFP) = -1;
  GAM0(caplabratFP,rk_tFP) = 1;
  
  
  %% aggregate resources
  GAM0(resourcesFP,y_tFP) = 1;
  GAM0(resourcesFP,c_tFP) = -cstar/(cstar+istar);
  GAM0(resourcesFP,i_tFP) = -istar/(cstar+istar);
  GAM0(resourcesFP,g_t) = -1;
  GAM0(resourcesFP,u_tFP) = -rkstar*kstar/(cstar+istar);
  
  
  %% production function
  GAM0(prodFP,y_tFP) = 1;
  GAM0(prodFP,k_tFP) = -alp*(ystar+Bigphi)/ystar;
  GAM0(prodFP,L_tFP) = -(1-alp)*(ystar+Bigphi)/ystar;
  
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% exogenous equations
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% z shock
GAM0(n_eqc+z_sh,z_t) = 1;
GAM1(n_eqc+z_sh,z_t) = rho_z;
PPSI(n_eqc+z_sh,z_sh) = 1;

if any(mspec == [101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16])    
  %% phi shock
  GAM0(n_eqc+phi_sh,phi_t) = 1;
  GAM1(n_eqc+phi_sh,phi_t) = rho_phi;
  PPSI(n_eqc+phi_sh,phi_sh) = 1;
end

if any(mspec == [])    
  %% chi shock
  GAM0(n_eqc+chi_sh,chi_t) = 1;
  GAM1(n_eqc+chi_sh,chi_t) = rho_chi;
  PPSI(n_eqc+chi_sh,chi_sh) = 1;
end
if any(mspec == [])    
  %% mu shock
  GAM0(n_eqc+mu_sh,mu_t) = 1;
  GAM1(n_eqc+mu_sh,mu_t) = rho_mu;
  PPSI(n_eqc+mu_sh,mu_sh) = 1;
end

if any(mspec == [])    
  %% b shock
  GAM0(n_eqc+b_sh,b_t) = 1;
  GAM1(n_eqc+b_sh,b_t) = rho_b;
  PPSI(n_eqc+b_sh,b_sh) = 1;
end

%% g shock
GAM0(n_eqc+g_sh,g_t) = 1;
GAM1(n_eqc+g_sh,g_t) = rho_g;
PPSI(n_eqc+g_sh,g_sh) = 1;

if any(mspec == [101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16])    
  %% laf shock
  GAM0(n_eqc+laf_sh,laf_t) = 1;
  GAM1(n_eqc+laf_sh,laf_t) = rho_laf; 
  PPSI(n_eqc+laf_sh,laf_sh) = 1;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% expectational equations
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%% E_c
GAM0(n_eqc+n_exo+Ec_sh,c_t) = 1;
GAM1(n_eqc+n_exo+Ec_sh,E_c) = 1;
PPI(n_eqc+n_exo+Ec_sh,Ec_sh) = 1;

%% E_pi
GAM0(n_eqc+n_exo+Epi_sh,pi_t) = 1;
GAM1(n_eqc+n_exo+Epi_sh,E_pi) = 1;
PPI(n_eqc+n_exo+Epi_sh,Epi_sh) = 1;

%% E_rk
GAM0(n_eqc+n_exo+Erk_sh,rk_t) = 1;
GAM1(n_eqc+n_exo+Erk_sh,E_rk) = 1;
PPI(n_eqc+n_exo+Erk_sh,Erk_sh) = 1;

%% E_w
GAM0(n_eqc+n_exo+Ew_sh,w_t) = 1;
GAM1(n_eqc+n_exo+Ew_sh,E_w) = 1;
PPI(n_eqc+n_exo+Ew_sh,Ew_sh) = 1;

%% E_wtil
GAM0(n_eqc+n_exo+Ewtil_sh,wtil_t) = 1;
GAM1(n_eqc+n_exo+Ewtil_sh,E_wtil) = 1;
PPI(n_eqc+n_exo+Ewtil_sh,Ewtil_sh) = 1;

%% E_xi
GAM0(n_eqc+n_exo+Exi_sh,xi_t) = 1;
GAM1(n_eqc+n_exo+Exi_sh,E_xi) = 1;
PPI(n_eqc+n_exo+Exi_sh,Exi_sh) = 1;

%% E_xik
GAM0(n_eqc+n_exo+Exik_sh,xik_t) = 1;
GAM1(n_eqc+n_exo+Exik_sh,E_xik) = 1;
PPI(n_eqc+n_exo+Exik_sh,Exik_sh) = 1;

%% E_i
GAM0(n_eqc+n_exo+Ei_sh,i_t) = 1;
GAM1(n_eqc+n_exo+Ei_sh,E_i) = 1;
PPI(n_eqc+n_exo+Ei_sh,Ei_sh) = 1;

if any(mspec == [1003,1004]) %% output gap model

  %% E_c
  GAM0(n_eqc+n_exo+Ec_shFP,c_tFP) = 1;
  GAM1(n_eqc+n_exo+Ec_shFP,E_cFP) = 1;
  PPI(n_eqc+n_exo+Ec_shFP,Ec_shFP) = 1;
  
  %% E_rk
  GAM0(n_eqc+n_exo+Erk_shFP,rk_tFP) = 1;
  GAM1(n_eqc+n_exo+Erk_shFP,E_rkFP) = 1;
  PPI(n_eqc+n_exo+Erk_shFP,Erk_shFP) = 1;
  
  %% E_xi
  GAM0(n_eqc+n_exo+Exi_shFP,xi_tFP) = 1;
  GAM1(n_eqc+n_exo+Exi_shFP,E_xiFP) = 1;
  PPI(n_eqc+n_exo+Exi_shFP,Exi_shFP) = 1;
  
  %% E_xik
  GAM0(n_eqc+n_exo+Exik_shFP,xik_tFP) = 1;
  GAM1(n_eqc+n_exo+Exik_shFP,E_xikFP) = 1;
  PPI(n_eqc+n_exo+Exik_shFP,Exik_shFP) = 1;
  
  %% E_i
  GAM0(n_eqc+n_exo+Ei_shFP,i_tFP) = 1;
  GAM1(n_eqc+n_exo+Ei_shFP,E_iFP) = 1;
  PPI(n_eqc+n_exo+Ei_shFP,Ei_shFP) = 1;
  
end
