% HP: y=hp(x,lam);
% x=TxN matrix, original data
% lam= "smoothing parameter" (quarterly data: lam=1600, annual: lam=10
% see Baxter-King NBER WP #5022)
% y=TxN hodrick-prescott detrended data

function y = hp(x,lam);

if isempty(find(isnan(x)))
	t = size(x,1);
	%construct the A matrix
	A=[1,-2,1,zeros(1,t-3)];
	ro=[1,-2,1,zeros(1,t-3)];
	j=2;
	while j<=t-2,
		ro=shiftr(ro,1,0);
		A=[A;ro];
	j=j+1;
	end
	y=(eye(t)-inv(eye(t)+lam*A.'*A))*x;
else
    y = [];
    for I = 1:size(x,2)
        iN = find(isnan(x(:,I)));
        yadd = x(:,I);
        xadd = x(:,I);
        nn = 1:1:size(x(:,I),1);
        xadd(iN) = [];
        nn(iN) = [];
        
		t = size(xadd,1);
		%construct the A matrix
		A=[1,-2,1,zeros(1,t-3)];
		ro=[1,-2,1,zeros(1,t-3)];
		j=2;
		while j<=t-2,
			ro=shiftr(ro,1,0);
			A=[A;ro];
		j=j+1;
		end
		yadd(nn) = (eye(t)-inv(eye(t)+lam*A.'*A))*xadd;
        y = [y,yadd];
    end
    
end
    
    
