% HP: y=hp(x,lam);
% x=TxN matrix, original data
% lam= "smoothing parameter" (quarterly data: lam=1600, annual: lam=10
% see Baxter-King NBER WP #5022)
% y=TxN hodrick-prescott detrended data

function [y,tr]=hp2(x,lam);

t=rows(x);
	%construct the A matrix
	A=[1,-2,1,zeros(1,t-3)];
	ro=[1,-2,1,zeros(1,t-3)];
	j=2;
	while j<=t-2,
		ro=shiftr(ro,1,0);
		A=[A;ro];
	j=j+1;
end
tr=inv(eye(t)+lam*A.'*A)*x;
y=(eye(t)-inv(eye(t)+lam*A.'*A))*x;
