% this function performs the inverse of the kxk SYMMETRIC square matrix S, 
% after partitioning S is into 4 nxn blocks, (ie, S11,..S22), the partitioned 
% matrix inverse formula is used. 
% of course k must be a multiple of 2
function F=V2(S,n);
D=inv(Sp(2,2,S,n));
E=Sp(1,1,S,n)-Sp(1,2,S,n)*D*Sp(2,1,S,n);

F11=inv(E);
F12=-F11*Sp(1,2,S,n)*D;
F22=D*(eye(n)-Sp(2,1,S,n)*F12);

F=[ [F11,F12];[F12.',F22] ];
