% this function performs the inverse of the kxk SYMMETRIC square matrix S, 
% after partitioning S is into 9 nxn blocks, (ie, S11,..S33), the partitioned 
% matrix inverse formula is used. 
% of course k must be a multiple of 3
function F=V3(S,n);
D=inv(Sp(3,3,S,n));

E11=Sp(1,1,S,n)-Sp(1,3,S,n)*D*Sp(3,1,S,n);
E12=Sp(1,2,S,n)-Sp(1,3,S,n)*D*Sp(3,2,S,n);
E22=Sp(2,2,S,n)-Sp(2,3,S,n)*D*Sp(3,2,S,n);

F11=inv(E11-E12*inv(E22)*E12.');
F22=inv(E22-E12.'*inv(E11)*E12);
F12=-inv(E11)*E12*F22;

F13=-(F11*Sp(1,3,S,n)+F12*Sp(2,3,S,n))*D;
F23=-(F12.'*Sp(1,3,S,n)+F22*Sp(2,3,S,n))*D;
F33=D*(eye(n)-Sp(3,1,S,n)*F13-Sp(3,2,S,n)*F23);

F=[ [F11,F12,F13];[F12.',F22,F23];[F13.',F23.',F33] ];
