function [b,bst,tst,yhat] = ols1(y,x,c)
% INPUT:
% y : independent variable
% x : dependent variable
% c : = 0 if you do NOT want to add constant
% OUPUT
% b : estimate of the coefficients
% bst : associated standard errors
% tst : t-ratios

if size(y,1) ~= size(x,1)
    disp('function ols1: T does not match');
    stop;
end

T = size(y,1);
if c
    x = [ones(T,1),x];
end

b = inv(x'*x)*x'*y;
yhat = x*b;
e = y-x*b;
sig = e'*e/(T-1);
bst = sqrt(diag(sig*inv(x.'*x)));
tst = b./bst;

    