function [alp,zeta_p,iota_p,del,ups,Bigphi,s2,h,a2,nu_l,nu_m,zeta_w,iota_w,law,rstar,psi1,psi2,rho_r,pistar,...
    gam,Lstar,chi,laf,gstar,Ladj,rho_z,rho_phi,rho_chi,rho_laf,rho_mu,rho_b,rho_g,...
    sig_z,sig_phi,sig_chi,sig_laf,sig_mu,sig_b,sig_g,sig_r,...
    bet,zstar,phi,istokbarst,rkstar,cstar,ystar,istar,kstar,kbarstar,Rstarn,wstar,wadj,mstar] = getpara(para,mspec);


alp = para(1);
zeta_p = para(2);
iota_p = para(3);
del = para(4);
ups = exp(para(5)/400);
Bigphi = para(6);
s2 = para(7);
h = para(8);
a2 = para(9);
nu_l = para(10);
nu_m = para(11);
zeta_w = para(12);
iota_w = para(13);
law = para(14);
bet  = exp(-para(15)/400);  %% (determines bet)
psi1 = para(16);
psi2 = para(17);
rho_r = para(18);
pistar = exp(para(19)/400);

npara = 19;

%% exogenous processes - level

gam = para(npara+1)/400;        
wadj = para(npara+2);
Lstar = 1;
chi = para(npara+3);
laf = para(npara+4);
gstar = 1+para(npara+5);
Ladj = para(npara+6);

npara = npara+6;    


%% exogenous processes - autocorrelation

rho_z = para(npara+1);
rho_phi = para(npara+2);
rho_chi = para(npara+3);
rho_laf = para(npara+4);
rho_mu = para(npara+5);
rho_b = para(npara+6);
rho_g = para(npara+7);

npara = npara+7;    


%% exogenous processes - standard deviation

sig_z = para(npara+1);
sig_phi = para(npara+2);
sig_chi = para(npara+3);
sig_laf = para(npara+4);
sig_mu = para(npara+5);
sig_b = para(npara+6);
sig_g = para(npara+7);
sig_r = para(npara+8);

npara = npara+8;    


%% Parameters (implicit) -- from steady state

zstar = gam+(alp\(1-alp))*log(ups); 

rstar = (1/bet)*exp(gam)*ups^(alp/(1-alp)); 

rkstar = (1/bet)*exp(gam)*ups^(1/(1-alp))-(1-del);

omegastar = (alp^(alp)*(1-alp)^(1-alp)*rkstar^(-alp)/(1+laf))^(1/(1-alp));

%if any(mspec == [105]) 
 %Bigphi = laf*omegastar*Lstar/(1-alp);
 %end

kstar = (alp/(1-alp))*omegastar*Lstar/rkstar;

kbarstar = kstar*exp(gam)*ups^(1/(1-alp));

istokbarst = 1-((1-del)/(exp(gam)*ups^(1/(1-alp))));

istar = kbarstar*istokbarst;

ystar = (kstar^alp)*(Lstar^(1-alp))-Bigphi;
if ystar <= 0

    disp([alp,  bet, kstar,Lstar])
    dm([ystar,Lstar,kstar,Bigphi])
    %keyboard;
end
cstar = (ystar/gstar)-istar;

xistar = (1/cstar)*((1/(1-h*exp(-gam)*ups^(-alp/(1-alp))))-(h*bet/(exp(gam)*ups^(alp/(1-alp))-h)));

phi = Lstar^(-nu_l)*omegastar*xistar/(1+law);

Rstarn = pistar*rstar;

wstar = ( 1/(1+laf) * (alp^alp) * (1-alp)^(1-alp) * rkstar^(-alp) )^(1/(1-alp));

mstar = [];%( chi * Rstarn/(1-Rstarn) * xistar^(-1) )^(1 / nu_m);

