function [M_vec] = getparaM(para,mspec);


alp = para(1);
del = para(4);
ups = exp(para(5)/400);
Bigphi = para(6);
bet  = exp(-para(15)/400);  %% (determines bet)

npara = 19;

%% exogenous processes - level

gam = para(npara+1)/400;        
Lstar = 1;
laf = para(npara+4);
gstar = 1+para(npara+5);


npara = npara+6;    


%% Parameters (implicit) -- from steady state

zstar = gam+(alp\(1-alp))*log(ups); 

rstar = (1/bet)*exp(gam)*ups^(alp/(1-alp)); 

rkstar = (1/bet)*exp(gam)*ups^(1/(1-alp))-(1-del);

omegastar = (alp^(alp)*(1-alp)^(1-alp)*rkstar^(-alp)/(1+laf))^(1/(1-alp));

%if any(mspec == [105]) 
 %Bigphi = laf*omegastar*Lstar/(1-alp);
 %end

kstar = (alp/(1-alp))*omegastar*Lstar/rkstar;

kbarstar = kstar*exp(gam)*ups^(1/(1-alp));

istokbarst = 1-((1-del)/(exp(gam)*ups^(1/(1-alp))));

istar = kbarstar*istokbarst;

ystar = (kstar^alp)*(Lstar^(1-alp))-Bigphi;
if ystar <= 0

    disp([alp,  bet, kstar,Lstar])
    dm([ystar,Lstar,kstar,Bigphi])
    %keyboard;
end
cstar = (ystar/gstar)-istar;


  M_vec = [((1-alp)/(1+laf)); ... %% labor share
              kbarstar/(4*ystar);  ... %% K/Y ratio (annualized)
              4*istokbarst;   ... %% I/K ratio (annualized)
              (cstar+istar)/ystar   ... %% (I+C)/Y ratio
                  ];
