close all;
clear all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% PRELIMINARY STUFF
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
run startdsswfed;
!hostname;
!ps -C matlab;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%      paths & parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
varspec;

[fpath,spath,gpath] = pathspec(num2str(floor(dataset)));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%*
% Load information for prior distribution

lprior    = num2str(mprior);
lmodel    = strcat('m',num2str(mspec));
priorfile = strcat('pri',lprior)
prior = feval(priorfile);

pmean  = prior(1:npara,1);
pstdd  = prior(1:npara,2);
pshape = prior(1:npara,3);

pshape = pshape.*(1-para_mask);


nonpolipar = [1:1:npara];
nonpolipar(polipar) = [];

% Load transformation scheme for parameters
trspec = feval('transp',mspec);

trspec(:,1) = trspec(:,1).*(1-para_mask);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% load data
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[YYall,XXall,ti,nobsall] = loaddata(dataset,fpath,T0,Tend,coint,cointadd,cointall,nvar,nlags,mspec);

dataset = num2str(10*dataset);

Iseq = find(ti == dates);
I = Iseq;
if stime                           
  YY = YYall(I-stime+1:I,:);
  XX = XXall(I-stime+1:I,:);             
  tiI = ti(I-stime+1:I);
  
  YY_p = YYall(1:I-stime,:);
  XX_p = XXall(1:I-stime,:);             
  nobs_p = size(YY_p,1)
  
else
  YY     = YYall(1:I,:);
  XX     = XXall(1:I,:);                   
  tiI = ti(1:I);
end
nobs = size(YY,1);

k     = nlags*nvar;

YYYY = YY'*YY;
XXYY = XX'*YY;
XXXX = XX'*XX;

MeY_0 = XXYY(1+cointall,:)'/nobs
VaY_0 = (YYYY/nobs)-MeY_0*MeY_0';
stdY_0 = sqrt(diag(VaY_0));
CorY_0 = VaY_0./(stdY_0*stdY_0');
%CoY_0 = (XXYY(1+cointall+1:1+cointall+nvar,:)/nobs)-MeY_0*MeY_0'
%ACorY_0 = diag(CoY_0)./diag(VaY_0)
ACorY_0 = zeros(nvar,1);
for ii = 1:nvar;
  ACorY_0(ii) = corr(YY(:,ii),XX(:,1+cointall+ii));
end
ACorY_0

stats_0 = [MeY_0' stdY_0' ACorY_0' CorY_0(:)'];

infile200 = strcat(spath,'/stats');		
fid200 = fopen(infile200,'r');		% output file (set to write)   
stats_0 = fread(fid200,[1 inf],'single'); 
fclose(fid200);

infile200 = strcat(spath,'/statsPre');		
fid200 = fopen(infile200,'r');		% output file (set to write)   
stats_0b = fread(fid200,[1 inf],'single'); 
fclose(fid200);

ICUM = find(cum_for);
INCUM = find(cum_for == 0);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Set parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% WANT POPULATION OR SAMPLE MOMENTS?
POPUL = 0
if POPUL 
  POP_ = '';
else
  POP_ = 'P';
end

percent = .90;

dobench = 2%inf;


mspecno = [ 2 3];
mspeclist = [104,113,105,106];
mspec_ref_list = cell(length(mspeclist),1);
mspec_ref_list(1) = {[NaN]};
mspec_ref_list(2) = {[NaN]};
mspec_ref_list(3) = {[NaN]};
mspec_ref_list(4) = {[NaN]};

nobsdrat_list = cell(length(mspeclist),1);
nobsdrat_list(1) = {[10/100]};
nobsdrat_list(2) = {[10/100]};
nobsdrat_list(3) = {[10/100]};
nobsdrat_list(4) = {[10/100]};

nlagsc_list = cell(length(mspeclist),1);
nlagsc_list(1) = {[1]};
nlagsc_list(2) = {[1]};
nlagsc_list(3) = {[1]};
nlagsc_list(4) = {[1]};

mprior_list = cell(length(mspeclist),1);
mprior_list(1) = {[11]};
mprior_list(2) = {[11]};
mprior_list(3) = {[11]};
mprior_list(4) = {[11]};

n_s_list = cell(length(mspeclist),1);
n_s_list(1) = {[]};
n_s_list(2) = {[]};
n_s_list(3) = {[]};
n_s_list(4) = {[]};

Acolor = zeros(length(mspeclist),3);
Acolor(1,:) = [0 1 0]%[0 .2 .2];
Acolor(2,:) = [0 0 1]%[0 .2 .2];
Acolor(3,:) = [1 0 0]%[0 .2 .2];
Acolor(4,:) = [0 0 0]%[0 .2 .2];


modls = 'm';
for ispec = mspecno 
  mspec = mspeclist(ispec);
  modls = strcat(modls,num2str(mspec));
  modls = strcat(modls,num2str(mprior_list{ispec}));  
  if ~isempty(mspec_ref_list{ispec})
    modls = strcat(modls,'-',num2str(mspec_ref_list{ispec}));
    modls = strcat(modls,'n',num2str(100*nobsdrat_list{ispec}));
    modls = strcat(modls,'l',num2str(nlagsc_list{ispec}));
    %modls = strcat(modls,'n_s',num2str(n_s_list{ispec}));
  end    
  modls = strcat(modls,'---');  
end


Fcolor = zeros(length(mspeclist),3);
Lstyle = cell(length(mspeclist),1);
Mstyle = cell(length(mspeclist),1);
Lstyle(1) = {'-'};
Mstyle(1) = {'+'};
Fcolor(1,:) = [.2 .2 .2];
Fcolor(2,:) = [.5 .5 .5];
Lstyle(2) = {'--'};
Mstyle(2) = {'+'};%^
Fcolor(3,:) = [.9 .9 .9];
Lstyle(3) = {'-.'};
Mstyle(3) = {'+'};%o
Lstyle(4) = {'-'};
Mstyle(4) = {'+'};
Fcolor(4,:) = [.2 .2 .2];



percent = .90
nirf = 20;

N1all = [];

for ispec = mspecno 
  mspec = mspeclist(ispec)
  lmodel    = strcat('m',num2str(mspec));

  mprior = mprior_list{ispec}
  lprior    = num2str(mprior);
  
  mspec_ref = mspec_ref_list{ispec}
  nobsdrat = nobsdrat_list{ispec}
  nlagsc = nlagsc_list{ispec}
  n_s = n_s_list{ispec}
  if isempty(mspec_ref)
    lmodel_ref = [];
    nobsdrat_ = [];
    nlagsc_ = [];
    n_s_ = [];
    
    %lprior    = strcat(lprior,'2');
    
  else
    lmodel_ref = strcat('m',num2str(mspec_ref));
    nobsdrat_ = num2str(100*nobsdrat);
    n_s_ = num2str(n_s);
    if nlagsc == 4
      nlagsc_ = [];
    else
      nlagsc_ = num2str(nlagsc);
    end  
    
  end


  

  infile400 = strcat(spath,'/IrfsMean',lmodel,lprior,dataset,lmodel_ref,nobsdrat_,nlagsc_);
  fid400 = fopen(infile400,'r');		% input file (set to write)   
  aairf1 = fread(fid400,[nirf,nvar*length(names_shocks)],'single');
  fclose(fid400);
  

  
  titlenames = varnames;
  titlenames(cum_irf) = strcat(titlenames(cum_irf),' - cum');

  tirf = (1:1:10)';
  
  vlist = [3 4]
  for Iirf = 1:nvar
    Vnum = 0;
    for V = vlist
      Vnum = Vnum+1;
      figure(1001);
      subplot(nvar,length(vlist),Vnum+length(vlist)*(Iirf-1));   
      m = aairf1(:,V+nvar*(Iirf-1));
      P = plot(tirf,m(tirf));
      set(P,'LineWidth',2);
      set(P,'Color',Acolor(ispec,:));
      set(P,'LineStyle',Lstyle{ispec});

      hold on;
      
      if Iirf == 1
        title(titlenames(V));
      end
      if V == vlist(1) 
        P = ylabel(names_shocks(Iirf));
        set(P,'FontSize',12);
      end

      if V == 3        
      %set(gca,'YLim',[-1.25 1.25]);
      elseif V == 4
      %set(gca,'YLim',[-3 3.75]);
      end
      
      set(gca,'XLim',[min(tirf),max(tirf)]);
      set(gca,'XTick',tirf([1:4:end]));
      if Iirf == nvar
        set(gca,'XTickLabel',num2str(tirf([1:4:end])-1));       
      else 
        set(gca,'XTickLabel',[]);
      end
      
    end                                                
  end	



  tirf = (1:1:nirf)';

  for Iirf = 1:nvar
    for V = 1:nvar
      figure(1000);
      subplot(nvar,nvar,V+nvar*(Iirf-1));   
      m = aairf1(:,V+nvar*(Iirf-1));
      P = plot(tirf,m);
      set(P,'LineWidth',2);
      set(P,'Color',Acolor(ispec,:));
      set(P,'LineStyle',Lstyle{ispec});

      hold on;
      
      if Iirf == 1
        title(titlenames(V));
      end
      if V == 1 
        P = ylabel(names_shocks(Iirf));
        set(P,'FontSize',12);
      end
      
      set(gca,'XLim',[min(tirf),max(tirf)]);
      set(gca,'XTick',tirf([1:10:end]));
      if Iirf == nvar
        set(gca,'XTickLabel',num2str(tirf([1:10:end])-1));       
      else 
        set(gca,'XTickLabel',[]);
      end
      
    end                                                
  end	

  
end


ng = strcat(gpath,modls,'-IrfCompSel');  
figure(1001);     print(char(strcat(ng,'.eps')),'-depsc2');   %print(char(strcat(ng,'.pdf')),'-dpdf');   % 

ng = strcat(gpath,modls,'-IrfCompall');  
figure(1000);     print(char(strcat(ng,'.eps')),'-depsc2');   %print(char(strcat(ng,'.pdf')),'-dpdf');   % 
