function aairf = irfdsge(TTT,RRR,params,nvar,mspec,npara,nirf,cum_irf,valid,nlags,coint,cointadd,cointall);

%% construct measurement equation
[ZZ,DD,DDcoint,QQ,EE,MM,retcode] = measur(TTT,RRR,valid,params,nvar,nlags,mspec,npara,coint,cointadd,cointall);

%if coint > 0
%   DDcoint = DD(nvar+1:nvar+coint,:);
%   ZZcoint = ZZ(nvar+1:nvar+coint,:);
%end

%% Remove cointegration component from ZZ, DD, EE, MM

ZZ = ZZ(1:nvar,:);
DD = DD(1:nvar,:);
EE = EE(1:nvar,1:nvar);
MM = MM(1:nvar,:);

impact = diag(sqrt(diag(QQ))); %%only if QQ is diagonal, otherwise impact = chol(QQ)';

nstate = size(TTT,1);
nex = size(QQ,1);

%% compute irf
aairf = [];

for I = 1:nex

    imp = impact(:,I);
    ssirf = zeros(nstate,nirf);
    yyirf = zeros(nvar,nirf);

    ssirf(:,1) = RRR*imp;
    yyirf(:,1) = ZZ*ssirf(:,1) + MM*imp;
    for t = 2:nirf;
        ssirf(:,t) = TTT*ssirf(:,t-1);
        yyirf(:,t) = ZZ*ssirf(:,t);
    end;
    yyirf(cum_irf,:) = cumsum(yyirf(cum_irf,:),2);
    aairf = [aairf,yyirf'];
end
