y = [ 116.8 120.1 123.2 130.2 131.4 125.6 124.5 134.3 ...
          135.2 151.8 146.4 139.0 127.8 147.0 165.9 165.5 ...
          179.4 190.0 189.8 190.9 203.6 183.5 169.3 144.2 ...
          141.5 154.3 169.5 193.0 203.2 192.9 209.4 227.2 ...
          263.7 297.8 337.1 361.3 355.2 312.6 309.9 323.7 ...
          324.1 355.3 383.4 395.1 412.8 406.0 438.0 446.1 ...
          452.5 447.3 475.9 487.7 497.2 529.8 551.0 581.1 ...
          617.8 658.1 675.2 706.6 724.7 ];
T = size(y,2);
lead = 0;
Nz = 2;
a = zeros(Nz,1);
F = [1 1; 0 1];
Ny = 1;
b = zeros(Ny,1);
H = [1 0];
var = eye(Ny+Nz)*1e-3;

fprintf('\nLikelihood Evaluation of SSM\n');
fprintf('DATA: Annual Real GNP 1909-1969\n\n');

logl = kalcvf(y, lead, a, F, b, H, var);
fprintf('No initial values are given\n');
fprintf('LOGL = %.2f\n\n', logl);

z0 = a;
vz0 = eye(Nz)*1e-3;
logl = kalcvf(y, lead, a, F, b, H, var, z0, vz0);
fprintf('Initial values are given\n');
fprintf('LOGL = %.2f\n\n', logl);

lead = 1;
z0 = a;
vz0 = eye(Nz)*10;
[logl, pred, vpred, filt, vfilt] = kalcvf(y, lead, a, F, b, H, var, z0, vz0);
fprintf('Filtering and One-Step Prediction\n');
fprintf('  Y         PRED                FILT\n')
format,disp([y(1:16); pred(:,1:16); filt(:,1:16)]')