%% read from xls matrices -- remember to update cell positions (Beg_A,End_A,Beg_Q,End_Q) you want to read from
%% ALWAYS CHECK THE DATA

Beg_A = 3
End_A = 59

[Cont,x,y] = xlsread('/home/f1mdn14/amdn/wk/dsgeprio/euro/usdata.xls','Annual');
dataNIPA = Cont(Beg_A:End_A,3)

 
Beg_Q = 37 %% remember: start from previous quarter
End_Q = 265%
lxnfh = zeros(End_Q-Beg_Q,1);

[Cont,x,y] = xlsread('/home/f1mdn14/amdn/wk/dsgeprio/euro/usdata.xls','Quarterly');
lxnfh = Cont(Beg_Q:End_Q,23)



%% check
if  (size(lxnfh,1)-1)/size(dataNIPA,1) ~= 4
  disp('Error: probably forgot to update (Beg_A,End_A,Beg_Q,End_Q)')
end

%% compute growth rates for Q data
g_lxnfh = lxnfh(2:end)./lxnfh(1:end-1);
lxnfh = lxnfh(2:end);

%% initial value
output_0 = 1;

%% construct data (first method -- benchmark adjustment is all in first quarter) 
output_1 = zeros(size(lxnfh,1)-1,1);
for Y = 1:size(dataNIPA,1);

  ind = (1:4)+4*(Y-1); 
  unadj =  output_0*cumprod(g_lxnfh(ind));

  adj = unadj*dataNIPA(Y)/mean(unadj);
  
  output_1(ind) = adj;
  output_0 = adj(end);
   
end

%% construct data (second method -- benchmark adjustment is spread out across all quarters) 
output_2 = zeros(size(lxnfh,1)-1,1);
for Y = 1:size(dataNIPA,1);

  ind = (1:4)+4*(Y-1); 

  if Y > 1
    
    ybar1 = ybar;
    xbar1 = xbar;
    ybar = mean(lxnfh(ind));
    xbar = dataNIPA(Y);
    
    g_diff = ones(4,1)*((xbar/xbar1)*(ybar1/ybar))^(1/4);
    
    unadj =  output_0*cumprod(g_lxnfh(ind).*g_diff);

  elseif Y == 1

    ybar = mean(lxnfh(ind));
    xbar = dataNIPA(Y);

    unadj =  output_0*cumprod(g_lxnfh(ind));
    
  end
  
  adj = unadj*dataNIPA(Y)/mean(unadj);

  output_2(ind) = adj;
  output_0 = adj(end);
  
  
end

output = [output_1,output_2];
save('/home/f1mdn14/amdn/wk/dsgeprio/euro/out1.txt','output','-ascii','-tabs')
%[succ,msg] = xlswrite('/home/f1mdn14/amdn/wk/dsgeprio/euro/usdata.xls',output_1,'Quarterly','AA39:AA262');


