function [lnpy] = likmh(para,bounds,yyyy,xxyy,xxxx,nobs,lambda,nlags,nvar,mspec,npara,trspec,pmean,pstdd,pshape,yyyyd,xxyyd,xxxxd,retcode,para_mask,coint,cointadd,cointall);

ind1 = (para > bounds(:,2));
ind1(find(para_mask)) = [];
ind2 = (para < bounds(:,1));
ind2(find(para_mask)) = [];

if any(ind1) | any(ind2)

	lnpy   = -1E20;

else
    if retcode == 0
		% inderterminacy
		lnpy = -1E10;
	else

	    LAMinv = eye(size(xxxxd,1));
	    LAMinv(1:cointadd,1:cointadd) = LAMinv(1:cointadd,1:cointadd)/lambda; 
	
	    yyyyc = yyyy + lambda*yyyyd;
	    xxyyc = LAMinv*xxyy + lambda*xxyyd;
	    xxxxc = LAMinv*xxxx*LAMinv + lambda*xxxxd;
	    
	    nobsc = nobs + lambda;    
	    k     = size(xxxx,1);
	    
	    % Compute OLS estimates
	    
	    Sig_hat = (yyyyc - xxyyc'*( xxxxc \ xxyyc ))/nobsc;
	   
	    Sig_hatd = yyyyd - xxyyd'*( xxxxd \ xxyyd );    
	
	    lnkapt = (-nvar*(nobs)/2)*log(2*pi) + ((nobs)*nvar/2)*log(2);
	    for i = 1:nvar
	        lnkapt = lnkapt+gammaln((nobsc-k+1-i)/2)-gammaln((lambda-k+1-i)/2);
	    end
	    
	    lnpy  = lnkapt  - ((nobsc-k)/2)*log(det(nobsc*Sig_hat)) + ((lambda-k)/2)*log(det(lambda*Sig_hatd)) ...
	         - (nvar/2)*log(det(xxxxc)/det(lambda*xxxxd));
	
			
	end;

	lnpy    = real(lnpy);
end

