
% filename: loaddata
% description: reads time series data from ASCII 
function [YYall,XXall,ti,nobs] = loaddata(dataset,fpath,T0,Tend,coint,cointadd,cointall,nvar,nlags,mspec);

  
  if ( dataset == 6 ) & any(mspec == [101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116])
    
    start_date = 1954.50;

    fname = strcat(fpath,'data',num2str(floor(dataset)),'.txt')
    data = importdata(fname);
    
    nobs   = size(data,1);
    ti     = (start_date:0.25:(start_date+.25*(nobs-1)))';   
    
    %% Compute growth rates
    series  = zeros(nobs-1,nvar);
    
    nobs = nobs -1;
    ti = ti(2:end);
    
    %% lgdprpc: log real GDP per capita
    series(:,1) = 100*(log(data(2:end,1))-log(data(1:end-1,1)));
    
    %% lhoursuppc: log hours worked per capita
    series(:,2) = 100*log(data(2:end,4));
    
    %% lhoursuppc: log labor income share
    series(:,3) = 100*log(data(2:end,6));

    %% lyed: log GDP deflator
    series(:,4) = 400*(log(data(2:end,7))-log(data(1:end-1,7)));
    
    %% stn : nominal short-term interest rate (Fed Fund)
    series(:,5) = data(2:end,8);

    
    YYall     = series(1+T0:nobs,:);
    XXall     = ones(nobs-T0, cointall+1+nvar*nlags);
    ti        = ti(1+T0:nobs,:);

    for i = 1:1:nlags;
      XXall(:,1+cointall+(i-1)*nvar+1:1+cointall+i*nvar) = series(T0-i+1:nobs-i,:);
    end

    nobs = size(YYall,1)
    
    VIEW = 0;
    if VIEW

      datt = [ti,YYall];
      FORMAT = '\n %2.2f  '; 
      for i = 1:nvar
        FORMAT = strcat(FORMAT,' %2.2f ');
      end
      fprintf(1,'\n\n Actual data  \n\n');
      fprintf(1,FORMAT,datt');
      
      for I = 1:size(YYall,2)
        plot(ti,YYall(:,I)); title(num2str(I));                      
        print(char(strcat(fpath,'data',num2str(I),'.eps')),'-depsc');
        
        close all;
      end

      
    end     

  elseif ( dataset == 6 ) & any(mspec == [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16])
    
    start_date = 1954.50;

    fname = strcat(fpath,'data',num2str(floor(dataset)),'.txt')
    data = importdata(fname);
    
    nobs   = size(data,1);
    ti     = (start_date:0.25:(start_date+.25*(nobs-1)))';   
    
    %% Compute growth rates
    series  = zeros(nobs-1,nvar);
    
    nobs = nobs -1;
    ti = ti(2:end);
    
    %% lgdprpc: log real GDP per capita
    series(:,1) = 100*(log(data(2:end,1))-log(data(1:end-1,1)));
    
    %% lhoursuppc: log hours worked per capita
    series(:,2) = 100*log(data(2:end,4));
    
    %% lyed: log GDP deflator
    series(:,3) = 400*(log(data(2:end,7))-log(data(1:end-1,7)));
    
    %% stn : nominal short-term interest rate (Fed Fund)
    series(:,4) = data(2:end,8);


    YYall     = series(1+T0:nobs,:);
    XXall     = ones(nobs-T0, cointall+1+nvar*nlags);
    ti        = ti(1+T0:nobs,:);

    for i = 1:1:nlags;
      XXall(:,1+cointall+(i-1)*nvar+1:1+cointall+i*nvar) = series(T0-i+1:nobs-i,:);
    end

    nobs = size(YYall,1)
    
    VIEW = 0;
    if VIEW

      datt = [ti,YYall];
      FORMAT = '\n %2.2f  '; 
      for i = 1:nvar
        FORMAT = strcat(FORMAT,' %2.2f ');
      end
      fprintf(1,'\n\n Actual data  \n\n');
      fprintf(1,FORMAT,datt');
      
      for I = 1:size(YYall,2)
        plot(ti,YYall(:,I)); title(num2str(I));                      
        print(char(strcat(fpath,'data',num2str(I),'.eps')),'-depsc');
        
        close all;
      end

      
    end     

  end 
  
