close all;
clear all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% PRELIMINARY STUFF
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
run startdsswfed;
!hostname;
!ps -C matlab;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%      paths & parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
varspec;

[fpath,spath,gpath] = pathspec(num2str(floor(dataset)));


fprintf(1,'model: %2.0f, dataset: %2.1f, prior: %2.0f, cointall: %2.0f,',[mspec,dataset,mprior,cointall]);


if isempty(mspec_ref)
  lmodel_ref = [];
  nobsdrat_ = [];
  lambdac_ = [];
  nlagsc_ = [];
  n_s_ = [];

else
  lmodel_ref = strcat('m',num2str(mspec_ref));
  nobsdrat_ = num2str(100*nobsdrat);
  lambdac_ = [];
  n_s_ = num2str(n_s);
  if nlagsc == 4
    nlagsc_ = [];
  else
    nlagsc_ = num2str(nlagsc);
  end  
  
end
stup_ = num2str(stup);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% load data
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[YYall,XXall,ti,nobsall] = loaddata(dataset,fpath,T0,Tend,coint,cointadd,cointall,nvar,nlags,mspec);

dataset = num2str(10*dataset);

ICUM = find(cum_for);
INCUM = find(cum_for == 0);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%*
% Load information for prior distribution

lprior    = num2str(mprior);
lmodel    = strcat('m',num2str(mspec));
priorfile = strcat('pri',lprior);
prior = feval(priorfile);

pmean  = prior(1:npara,1);
pstdd  = prior(1:npara,2);
pshape = prior(1:npara,3);

pshape = pshape.*(1-para_mask);


nonpolipar = [1:1:npara];
nonpolipar(polipar) = [];

% Load transformation scheme for parameters
trspec = feval('transp',mspec);

trspec(:,1) = trspec(:,1).*(1-para_mask);


fpath2 = strcat(fpath,'/',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_,'/');
mkdir(fpath2);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Set parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% doing rolling sample estimation?
ROLL = 0
SAVEALL = 0
DOFORECAST = 1
if ROLL 
  DOFORECAST = 1;
  SAVEALL = 0;
end
start_period = stime;                               % minimum # quarters to compute VAR estimates 


%mkdir(spath,'/2/');
%spath = strcat(spath,'/1/');
%start_period = nobsall-qahead+1-3

trial_period = nobsall-start_period-qahead+1;      % # quarters to compute RMSE

Verbose = 0;

fixparam = fixparamseq(1);
if fixparam ~= 0 
  fixparam
  break
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% do Lambda loop
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Mh = zeros(1,length(lambdaseq));
percent = .90;

  Iseq = find(ti == dates);

  outfile00 = strcat(fpath2,lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_,num2str(cointall),st,num2str(100*ti(Iseq)),num2str(nlags),'-',num2str(JustMode),'Mh.tex');	% output file name 

fid00 = fopen(outfile00,'w');		% output file (set to write)

for I = Iseq;
  if ~ROLL
    start_period = I-1;
  end


  L = 0;
  for lambdas = lambdaseq     
    
    L = L+1;
    
    
    %% set params for MH evaluation 
    nfnpara = npara-length(find(para_mask));

    hmax = 5;
    p = (.1:.1:(9-1)*.1)';
    pcrit = chi2inv(p,nfnpara);
if ~JustMode
    densfac = -1000;
elseif JustMode
    densfac = -1200;%-2200%
end    
    
    fprintf(1,'\n Lambda = %2.3f',[lambdas]);
    fprintf(1,'\n Time %3.2f ',[ti(I)]);
    
    fprintf(fid00,'\n Lambda = %2.3f',[lambdas]);
    
    %% open read files
    %% params file
    infile1 = strcat(spath,'/mhpara',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_,num2str(cointall),st,num2str(100*lambdas),num2str(100*ti(I)),num2str(nlags),num2str(fixparam),num2str(JustMode));		

    num1 = nblocks*nsim*npara*4;            % number of bites per file
    numb1 = nburn*npara*4;                  % number of bites to dicard
    
    %% Posterior file
    infile2 = strcat(spath,'/post',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_,num2str(cointall),st,num2str(100*lambdas),num2str(100*ti(I)),num2str(nlags),num2str(fixparam),num2str(JustMode));		
    num2 = nblocks*nsim*1*4;            % number of bites per file
    numb2 = nburn*1*4;                  % number of bites to dicard
    
    
    %% get means and st dev of parameters
    fid1 = fopen(infile1,'r');		% input file (set to read)               
    status = fseek(fid1,numb1,'bof');
    %infile1
    %fid1		
    theta = [];
    it =0;
    it0=-inf;
    while ( ftell(fid1) < num1 ) & (it > it0)
      it0 = it;
      it=ftell(fid1);
      % Read blocks of size nsim
      thetadd = fread(fid1,[npara,nsim],'single')';
      if all(size(thetadd,2) == [npara])
        theta = [theta;thetadd];
      else
        %		fclose(fid1);
      end
      clear thetadd;
      
    end;
    fclose(fid1);
    ndraws = size(theta,1)
    
    
    %% delete rows for fixed parameters
    theta(:,find(para_mask)) = [];
    
    %%%%%%%%%%% Compute posterior moments of the parameters
    thetahat = mean(theta,1)';
    thetasig = cov(theta,1);
    
    [u,s,v] = svd(thetasig);
    md = min(size(s)); 
    bigev = find(diag(s(1:md,1:md))>1e-6);
    thetasigdim = length(bigev);
    %[rank(thetasig),nfnpara,thetasigdim]		
    thetasiglndet = 0;
    for i = 1:nfnpara
      
      if i > thetasigdim
        s(i,i) = 0;
      else
        
        thetasiglndet = thetasiglndet+log(s(i,i));             
        s(i,i)    = 1/s(i,i);
      end
    end
    thetasiginv  = u*s*u';

    
    %thetasiginv = inv(thetasig);
    %thetasiglndet = log(det(thetasig))];
    
    %%%%%%%%%%% Compute density estimates
    suminvlike = zeros(length(p),1);
    laginvlike = zeros(hmax,length(p));
    gaminvlike = zeros(hmax,length(p));
    
    
    fid1 = fopen(infile1,'r');		% input file (set to read)               
    status = fseek(fid1,numb1,'bof');
    fid2 = fopen(infile2,'r');		% input file (set to read)               
    status = fseek(fid2,numb2,'bof');
    
    iblock = 0;
    ndraws = 0;            
    it =0
    it0=-inf;
    
    while ( ftell(fid1) < num1 ) & ( ftell(fid2) < num2 )  & (it > it0)
      it0 = it;
      it=ftell(fid1);
      iblock = iblock+1;  
      parasimm = fread(fid1,[npara,nsim],'single')';
      postsim = fread(fid2,[nsim,1],'single');

      %[max(postsim),min(postsim)]
      if any(size(parasimm) ~= [nsim,npara]) | any(size(postsim) ~= [nsim,1]) 
        %fclose(fid1);
        %fclose(fid2);
        %break;
      else
        
        parasimm(:,find(para_mask)) = [];
        
        for j = 1:size(parasimm,1)
          thetasim = parasimm(j,:)';
          
          post = postsim(j);
          
          lnftheta = -log(p)-.5*nfnpara*log(2*pi)-.5*thetasiglndet-.5*(thetasim-thetahat)'*thetasiginv*(thetasim-thetahat);
          %					lnftheta = -.5*nfnpara*log(2*pi)-.5*thetasiglndet-.5*(thetasim-thetahat)'*thetasiginv*(thetasim-thetahat);
          
          indtheta = ( (thetasim-thetahat)'*thetasiginv*(thetasim-thetahat) < pcrit );
          invlike = exp(lnftheta-post+densfac).*indtheta;
          %                   invlike = repmat(exp(-post+densfac),size(indtheta));
          % invlike = repmat(exp(lnftheta-post+densfac),size(indtheta));
          if ~isinf(invlike) & ~isnan(invlike)
            laginvlike = [invlike';laginvlike(1:hmax-1,:)];
            gaminvlike = gaminvlike + laginvlike.*(ones(hmax,1)*invlike');
            suminvlike = suminvlike+invlike;
            
            ndraws = ndraws+1;
          end
        end
      end
      clear parasimm postsim;
    end
    fclose(fid1);
    fclose(fid2);
    
    ndraws
    meaninvlike = suminvlike/ndraws;
    gaminvlike = gaminvlike/ndraws -ones(hmax,1)*(meaninvlike.^2)';
    
    %%% compute standard errors
    suminvlikeerror = gaminvlike(1,:);
    for j = 2:hmax;
      suminvlikeerror = suminvlikeerror+2*gaminvlike(j,:)*(1-((j-1)/hmax));
    end
    suminvlikeerror = 100*sqrt(suminvlikeerror/ndraws)./meaninvlike';
    
    pint = densfac-log(meaninvlike);
    
    pint0 = mean(pint(~isnan(pint) & ~isinf(pint)));
    
    fprintf(1,'\n marginal data density : %4.7f',pint);
    fprintf(1,'\n average across p : %4.7f',pint0)
    fprintf(1,'\n simulation error (percent) : %4.7f',suminvlikeerror);
    
    Mh(L) = pint0;

    outfile0 = strcat(spath,'Mh',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_,num2str(cointall),st,num2str(fixparam),num2str(JustMode),num2str(100*lambdas),num2str(100*ti(I)))
    

    fid0 = fopen(outfile0,'w');     % output file (set to write)   
    fwrite(fid0,pint0,'single');
    fclose(fid0);

    if ROLL
      %      save(strcat(spath,'Mh',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_,num2str(cointall),st,num2str(fixparam),num2str(JustMode),num2str(100*lambdas),num2str(100*ti(I))),'pint0');

    end		
    
  end         % end lambdaseq
  fprintf(1,'\n\n\n ');
  fprintf(1,'\n lambda: %2.2f marg lik: %9.9f',[lambdaseq;Mh]);
  
  fprintf(fid00,'\n lambda: %2.2f marg lik: %9.9f',[lambdaseq;Mh]);
  
end %% end rolling sample

%if ~isempty(mspec_ref)
  infile01 = strcat(spath,'MhPrio',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_);
  
  fid01 = fopen(infile01,'r');     % output file (set to write)   
  pintpr =fread(fid01,1,'single');
  fclose(fid01);

  Mh = Mh-pintpr;
  fprintf(1,'\n\n\n ');
  fprintf(1,'\n lambda: %2.2f corrected marg lik: %9.9f',[lambdaseq;Mh]);
  
  fprintf(fid00,'\n lambda: %2.2f corrected marg lik: %9.9f',[lambdaseq;Mh]);
  
%end

fclose(fid00);		% close output file
