function pyt = marglh(para,yyyy,xxyy,xxxx,nobs,lambda,nlags,nvar,mspec,npara,coint,cointadd,cointall);

% Compute cross product matrices for DSGE dummy observations
[TTT,RRR,valid] = dsgesolv(para,mspec);
[yyyyd,xxyyd,xxxxd,retcode] = varprio(TTT,RRR,valid,para,nvar,nlags,mspec,npara,coint,cointadd,cointall);

if retcode == 0
    % inderterminacy
    pyt = -1E10;
else

    LAMinv = eye(size(xxxxd,1));
    LAMinv(1:cointadd,1:cointadd) = LAMinv(1:cointadd,1:cointadd)/lambda; 

    yyyyc = yyyy + lambda*yyyyd;
    xxyyc = LAMinv*xxyy + lambda*xxyyd;
    xxxxc = LAMinv*xxxx*LAMinv + lambda*xxxxd;
    
    nobsc = nobs + lambda;    
    k     = size(xxxx,1);
    
    % Compute OLS estimates
    
    Sig_hat = (yyyyc - xxyyc'*( xxxxc \ xxyyc ))/nobsc;
%    Sig_hat = (yyyyc - xxyyc'*( (xxxxc/nobsc) \ (xxyyc/nobsc) ))/nobsc;
   
    Sig_hatd = yyyyd - xxyyd'*( xxxxd \ xxyyd );    

    lnkapt = (-nvar*(nobs)/2)*log(2*pi) + ((nobs)*nvar/2)*log(2);
    for i = 1:nvar
        lnkapt = lnkapt+gammaln((nobsc-k+1-i)/2)-gammaln((lambda-k+1-i)/2);
    end
    
    pyt  = lnkapt  - ((nobsc-k)/2)*log(det(nobsc*Sig_hat)) + ((lambda-k)/2)*log(det(lambda*Sig_hatd)) ...
         - (nvar/2)*log(det(xxxxc)/det(lambda*xxxxd));

end;
