close all;
clear all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% PRELIMINARY STUFF
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

run startdsgeprioeuro;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%      paths & parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
chdata = choosedata;
[mspec,mprior,dataset,dates,nvar,nlags,T0,Tend,npara,lambdaseq,para_names,bounds,para, ...
 varnames,cum_for,polipar,polivalue,cum_irf,names_shocks,fixparamseq,coint,cointadd,cointall,cointvec,cointaddvec,JustMode, ...
 stime,st,nblocks,nsim,nburn,qahead,para_mask,para_fix] = varspec(chdata);


%[fpath,spath,gpath] = pathspecmh(num2str(floor(dataset)),chdata,coint);
[fpath,spath,gpath] = pathspec(num2str(floor(dataset)),chdata);


fprintf(1,'model: %2.0f, dataset: %2.1f, prior: %2.0f',[mspec,dataset,mprior]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% load data
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[YYall,XXall,ti,nobsall] = loaddata(dataset,fpath,T0,Tend,coint,cointadd,cointall,nvar,nlags,chdata,mspec);

dataset = num2str(10*dataset);

ICUM = find(cum_for);
INCUM = find(cum_for == 0);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%*
% Load information for prior distribution
lmodel    = strcat('m',num2str(mspec));
lprior    = num2str(mprior);
priorfile = strcat(lmodel,lprior,'pri');
prior = feval(priorfile);

pmean  = prior(1:npara,1);
pstdd  = prior(1:npara,2);
pshape = prior(1:npara,3);

pshape = pshape.*(1-para_mask);


nonpolipar = [1:1:npara];
nonpolipar(polipar) = [];

% Load transformation scheme for parameters
trspec = feval('transp',mspec);

trspec(:,1) = trspec(:,1).*(1-para_mask);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Set parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% doing rolling sample estimation?
ROLL = 0
SAVEALL = 0
DOFORECAST = 1
if ROLL 
  DOFORECAST = 1;
  SAVEALL = 0;
end
start_period = stime;                               % minimum # quarters to compute VAR estimates 


%mkdir(spath,'/2/');
%spath = strcat(spath,'/1/');
%start_period = nobsall-qahead+1-3

trial_period = nobsall-start_period-qahead+1;      % # quarters to compute RMSE

Verbose = 0;

fixparam = fixparamseq(1);
if fixparam ~= 0 
  fixparam
  break
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% do Lambda loop
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
lambdaseq = [ceil(100*((7*4+3+1)+7)/120)/100 .5 .75 1 1.25  1.5 2 5 Inf NaN];

lambdaseq = [ceil(100*((7*4+3+1)+7)/120)/100 .5 .75 1 1.25  1.5 2 5 Inf];

mspecseq = [106,101,108];


allmodelnames = cell(20,1);
allmodelnames(1) = {'No Indexation'};
allmodelnames(6) = {'Baseline'};
allmodelnames(4) = {'No Price and Wage Stickiness'};
allmodelnames(5) = {'No Wage Stickiness'};
allmodelnames(8) = {'No Habit'};
allmodelnames(9) = {'No Investment Adj. Costs'};
allmodelnames(10) = {'No Capital Adj. Costs'};


%% 101 - baseline - no indexation
%% 102 - partial indexation w/ tech update
%% 106 - partial indexation w/o tech update
%% 107 - full indexation w/o tech update
%% 103 - output gap targeting (partial indexation w/o tech update)
%% 104 - No price and wage rigidity
%% 105 - No wage rigidity (OLD: \Bigphi (full indexation w/o tech update))
%% 108 - No habit persistence
%% 109 - No inv adj cost
%% 110 - No cap utilization
%% 111 - No persistence mu and b
%% 112 - No persistence phi
modelnames = cell(length(mspecseq),1);
for ii = 1:length(mspecseq)
  modelnames{ii} = {allmodelnames{mspecseq(ii)-100}};
end




  
Mh = zeros(length(mspecseq),length(lambdaseq));
Iseq = find(ti == dates);




tirf = lambdaseq./(1+lambdaseq)
if isnan(lambdaseq(end))
  tirf(end-1) = 1;
else
  tirf(end) = 1;
end
sirf = tirf;
if isnan(lambdaseq(end)); sirf(end) = 1.1; end;
tirf = num2str(tirf',2);
if isnan(lambdaseq(end))
 tirf(end,:) = 'DSGE';
end


Acolor = zeros(size(Mh,1),3);
Lstyle = cell(size(Mh,1),1);
Mstyle = cell(size(Mh,1),1);
Lstyle(1) = {'-'};
Mstyle(1) = {'x'};
Acolor(2,:) = [1 0 0];
Lstyle(2) = {'--'};
Mstyle(2) = {'*'};
Acolor(3,:) = [0 1 0];
Lstyle(3) = {'-.'};
Mstyle(3) = {'o'};


tirf1 = tirf; 
tirf1(1:end-1,1) = ' '; 
tirf1([4 6],2) = ' ';


mod = num2str(106);
fname = strcat('/mnt/nas02/f1mdn14/amdn/wk/dsgeprio/fed/404/4/',mod,'t.txt')
Mht = importdata(fname);
datt = Mht(2:end,1);
Mht106 = Mht(2:end,3:end-1);
if ~isnan(lambdaseq(end))
 Mht106(:,end) = [];
end
lahat106 = Mht(2:end,end);
 
mod = num2str(101);
fname = strcat('/mnt/nas02/f1mdn14/amdn/wk/dsgeprio/fed/404/4/',mod,'t.txt')
Mht = importdata(fname);
Mht101 = Mht(2:end,3:end-1);
if ~isnan(lambdaseq(end))
 Mht101(:,end) = [];
end
lahat101 = Mht(2:end,end);

mod = num2str(108);
fname = strcat('/mnt/nas02/f1mdn14/amdn/wk/dsgeprio/fed/404/4/',mod,'t.txt')
Mht = importdata(fname);
Mht108 = Mht(2:end,3:end-1);
if ~isnan(lambdaseq(end))
 Mht108(:,end) = [];
end
lahat108 = Mht(2:end,end);

datte = ti(start_period+datt);
tiseq = 2:8:datt(end);

datesall = strcat(num2str(floor(datte)),'-',num2str(round(1+4*(datte-floor(datte)))));  

figure(102);

Q = Mht106;%flipdim(Mht106,2);
mesh(sirf,datt,Q,'FaceColor','none','LineWidth',1,'LineStyle','-','EdgeColor',[0 0 0]);
hold off;
%ylabel('years');
set(gca,'YTick',datt(tiseq));
set(gca,'YTickLabel',num2str(datte(tiseq)));
%set(gca,'YTickLabel',datesall(tiseq,:));
%set(gca,'YTickLabel',[]);

xlabel('\lambda / (1+ \lambda)')
set(gca,'XTick',sirf');
set(gca,'XTickLabel',tirf1);

%zlabel('%');
%set(gca,'ZLim',[0  30])

lmodel    = strcat('m',num2str(106));
runn = strcat('lambdaotime',lmodel,lprior,dataset,num2str(coint),st);


figure(102)
%set(figure(1),'PaperPosition',[0 0 8 6])
print(char(strcat(gpath,runn,'.eps')),'-depsc'); 
print(char(strcat(gpath,runn,'.pdf')),'-dpdf');


figure(103);

Q = Mht106;%Q = flipdim(Mht106,2);
mesh(sirf,datt,Q,'FaceColor','none','LineWidth',1,'LineStyle','-','EdgeColor',[0 0 0]);
hold on;
Q = Mht101;%Q = flipdim(Mht101,2);
mesh(sirf,datt,Q,'FaceColor','none','LineWidth',1,'LineStyle','-','EdgeColor',[0 0 1]);
hold on;
Q = Mht108;%Q = flipdim(Mht108,2);
mesh(sirf,datt,Q,'FaceColor','none','LineWidth',1,'LineStyle','-','EdgeColor',[0 0 1]);
hold off;
%ylabel('quarters ahead');
set(gca,'YTick',datt(tiseq));
set(gca,'YTickLabel',num2str(datte(tiseq)));
%set(gca,'YTickLabel',[]);

xlabel('\lambda / (1+ \lambda)')
set(gca,'XTick',sirf');
set(gca,'XTickLabel',tirf1);

%zlabel('%');
%set(gca,'ZLim',[0  30])


runn = strcat('3models-lambdaotime',lmodel,lprior,dataset,num2str(coint),st);
figure(103)
%set(figure(1),'PaperPosition',[0 0 8 6])
%print(char(strcat(gpath,runn,'.eps')),'-depsc'); 
%print(char(strcat(gpath,runn,'.pdf')),'-dpdf');



figure(104);
Mh = [lahat106';lahat101';lahat108'];  

M = 0;
mspecname = [];
for mspec = mspecseq;
  mspecname = strcat(mspecname,'-',num2str(mspec));
  M = M+1;

  P = plot(datt,Mh(M,:));
  set(P,'Color',Acolor(M,:));
  set(P,'LineStyle',Lstyle{M});
  set(P,'Marker',Mstyle{M});
  set(P,'MarkerSize',8);
  set(P,'LineWidth',1.5);

  T =text(.99*datt(end),Mh(M,end),modelnames{M});
  set(T,'VerticalAlignment','top');
  set(T,'HorizontalAlignment','right');
  set(T,'FontSize',12);
  set(T,'FontWeight','bold');
 
  
  
  hold on;


%set(gca,'YLim',[min(min(Mh(1:M,:)))-20,max(max(Mh(1:M,:)))+20]);

end
hold off;
set(gca,'XTick',datt(tiseq));
set(gca,'XTickLabel',num2str(datte(tiseq)));

runn = strcat('lambdahatotime',lmodel,lprior,dataset,num2str(coint),st);
figure(104)
print(char(strcat(gpath,runn,'.pdf')),'-dpdf');

for i_dat = [1 datt(end)]
  
  Mh = [Mht106(i_dat,:);Mht101(i_dat,:);Mht108(i_dat,:)];  
  figure(101);
  M = 0;
  mspecname = [];
  for mspec = mspecseq;
    mspecname = strcat(mspecname,'-',num2str(mspec));
    M = M+1;

    P = plot(sirf,Mh(M,:));
    set(P,'Color',Acolor(M,:));
    set(P,'LineStyle',Lstyle{M});
    set(P,'Marker',Mstyle{M});
    set(P,'MarkerSize',8);
    set(P,'LineWidth',1.5);

    T =text(.99*sirf(end),Mh(M,end),modelnames{M});
    set(T,'VerticalAlignment','top');
    set(T,'HorizontalAlignment','right');
    set(T,'FontSize',12);
    set(T,'FontWeight','bold');
    
    if M == 1
      T =text(.99*sirf(end),Mh(M,end),modelnames{M});
      set(T,'VerticalAlignment','top');
      set(T,'HorizontalAlignment','right');
      set(T,'FontSize',12);
      set(T,'FontWeight','bold');
      
      T =text(sirf(end),Mh(M,end),num2str(Mh(M,end),'%5.0f'));
      set(T,'VerticalAlignment','bottom');
      set(T,'HorizontalAlignment','left');
      set(T,'FontSize',11);
      set(T,'FontWeight','bold');
      set(T,'Color',Acolor(M,:));
      
      T =text(sirf(1),Mh(M,1),num2str(Mh(M,1),'%5.0f'));
      set(T,'VerticalAlignment','bottom');
      set(T,'HorizontalAlignment','left');
      set(T,'FontSize',11);
      set(T,'FontWeight','bold');
      set(T,'Color',Acolor(M,:));
      
      [ym,im] = max(Mh(M,:));
      T =text(sirf(im),Mh(M,im),num2str(Mh(M,im),'%5.0f'));
      set(T,'VerticalAlignment','bottom');
      set(T,'HorizontalAlignment','left');
      set(T,'FontSize',11);
      set(T,'FontWeight','bold');
      set(T,'Color',Acolor(M,:));
      
    end
    
    hold on;

    set(gca,'YLim',[min(min(Mh(1:M,:)))-20,max(max(Mh(1:M,:)))+20]);
    set(gca,'XLim',[min(sirf),max(sirf)]);
    set(gca,'XTick',sirf');
    set(gca,'XTickLabel',tirf1);

    xlabel('\lambda / (1+ \lambda)')
    T = title(datesall(i_dat,:));
    set(T,'FontSize',12);

  end
  hold off;
  figure(101);
  %set(figure(101),'PaperPosition',[0 0 7 9])
  ng=strcat(gpath,'lambdaplot',mspecname,num2str(i_dat));

  %saveas(figure(101),char(ng),'fig');
  figure(101);
  %  print(char(strcat(ng,'.eps')),'-depsc2');
  print(char(strcat(ng,'.pdf')),'-dpdf');
end


