close all;
clear all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% PRELIMINARY STUFF
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
run startdsswfed;
!hostname;
!ps -C matlab;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%      paths & parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
varspec;

[fpath,spath,gpath] = pathspec(num2str(floor(dataset)));


fprintf(1,'model: %2.0f, dataset: %2.1f, prior: %2.0f, cointall: %2.0f,',[mspec,dataset,mprior,cointall]);

if isempty(mspec_ref)
  lmodel_ref = [];
  nobsdrat_ = [];
  lambdac_ = [];
  nlagsc_ = [];
  n_s_ = [];

  disp('NO reference model set in varspec.m')

else
  lmodel_ref = strcat('m',num2str(mspec_ref));
  nobsdrat_ = num2str(100*nobsdrat);
  lambdac_ = [];
  n_s_ = num2str(n_s);
  if nlagsc == 4
    nlagsc_ = [];
  else
    nlagsc_ = num2str(nlagsc);
  end  
  addc = 'inf';
  
end



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% load data
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[YYall,XXall,ti,nobsall] = loaddata(dataset,fpath,T0,Tend,coint,cointadd,cointall,nvar,nlags,mspec);

dataset = num2str(10*dataset);

ICUM = find(cum_for);
INCUM = find(cum_for == 0);

I = find(ti == dates);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%*
% Load information for prior distribution
lmodel    = strcat('m',num2str(mspec));
lprior    = num2str(mprior);
priorfile = strcat('pri',lprior);
prior = feval(priorfile);

pmean  = prior(1:npara,1);
pstdd  = prior(1:npara,2);
pshape = prior(1:npara,3);

pshape = pshape.*(1-para_mask);


nonpolipar = [1:1:npara];
nonpolipar(polipar) = [];

% Load transformation scheme for parameters
trspec = feval('transp',mspec);

trspec(:,1) = trspec(:,1).*(1-para_mask);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Set parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% doing rolling sample estimation?
ROLL = 0
SAVEALL = 0
DOFORECAST = 1
if ROLL 
  DOFORECAST = 1;
  SAVEALL = 0;
end
start_period = stime;                               % minimum # quarters to compute VAR estimates 


%mkdir(spath,'/2/');
%spath = strcat(spath,'/1/');
%start_period = nobsall-qahead+1-3

trial_period = nobsall-start_period-qahead+1;      % # quarters to compute RMSE

Verbose = 0;

fixparam = fixparamseq(1);
if fixparam ~= 0 
  fixparam
  break
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% do Lambda loop
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
lambdas = NaN%[ceil(100*((4*4+1)+4)/100)/100 .5 .75 1 1.25 1.5 2 5 Inf NaN];
nobsdratseq = [0 4/100 6/100 10/100]%[Inf 25 4 ]
%nobsdratseq = [0 6/100]% [0 6/100 10/100]%[Inf 25 4 ]
%nobsdratseq = 0

%JustMode = 1
  mspecseq = [101,104,105,106,107,111,112,113,114,5,6,13];
mspec_ref_list = cell(length(mspecseq),1);
mspec_ref_list(1) = {['']};
mspec_ref_list(2) = {[NaN]};
mspec_ref_list(3) = {[106]};
mspec_ref_list(4) = {['']};
mspec_ref_list(5) = {[NaN]};
mspec_ref_list(6) = {[106]};
mspec_ref_list(7) = {['']};
mspec_ref_list(8) = {[NaN]};
mspec_ref_list(9) = {[106]};
mspec_ref_list(10) = {['']};
mspec_ref_list(11) = {[NaN]};
mspec_ref_list(12) = {[106]};
mspec_ref_list(13) = {['']};
mspec_ref_list(14) = {[NaN]};
mspec_ref_list(15) = {[106]};
mspec_ref_list(16) = {['']};
mspec_ref_list(17) = {[NaN]};
mspec_ref_list(18) = {[106]};
mspec_ref_list(19) = {['']};
mspec_ref_list(20) = {[NaN]};
mspec_ref_list(21) = {[106]};

Mspec_Ref = NaN
stup = 1
stup_ = num2str(stup);
nlagsc = 1
n_s = []

mspecno = [4 3];
%mspecno = [4 3 8];
%mspecno = [11 10 12];
%mspecno = [1  3 4  6  10 12];



allmodelnames = cell(20,1);
allmodelnames(1) = {'No Dynamic Indexation'};
allmodelnames(6) = {'Baseline'};
allmodelnames(4) = {'Flex Wages and  Prices'};
allmodelnames(5) = {'Flex Wages'};
allmodelnames(7) = {'Full Indexation'};
allmodelnames(8) = {'No Habit'};
allmodelnames(9) = {'No Investment Adj. Costs'};
allmodelnames(10) = {'No Capital Adj. Costs'};
allmodelnames(11) = {'No Wage Stickiness and No Indexation'};
allmodelnames(12) = {'Uncorrelated Mark-up Shocks'};
allmodelnames(13) = {'Flex Prices'};
allmodelnames(14) = {'Uncorrelated Mark-up Shocks and No Indexation'};

modelnames = cell(length(mspecseq),1);
for ii = 1:length(mspecseq)
  if mspecseq(ii) > 100
  modelnames{ii} = {allmodelnames{mspecseq(ii)-100}};
  else
  modelnames{ii} = {allmodelnames{mspecseq(ii)}};
  end
end

modls = 'm-';
for ispec = mspecno 
  ispec
  mspec = mspecseq(ispec)
  modls = strcat(modls,num2str(mspec));
  modelnames{ispec}
end

outfile00 = strcat(fpath,modls,lprior,'-',num2str(JustMode),'-',stup_,'--ALL','MhAll.tex');		% output file name 
fid00 = fopen(outfile00,'w');		% output file (set to write)
fprintf(fid00,'\n \\documentclass[12pt]{article} \n \\usepackage[dvips]{color}\n ');
fprintf(fid00,'\n \\begin{document}');
Fortab = '\n \\begin{tabular}{l';
Heads = ' ';
Fornum = ' ';
for nobsdrat = nobsdratseq     
  Fortab = strcat(Fortab,'l');
  Fornum = strcat(Fornum,' & %2.2f ');
  Heads = strcat(Heads,'&  \\multicolumn{1}{c}{$T^*$=%2.0f}  ',100*nobsdrat);
end
%% finish up
Fortab = strcat(Fortab,'}\\hline \n');
Fornum = strcat(Fornum,' \\\\[1ex] \n ');
Heads = strcat(Heads,'\\\\[1ex] \n');



Mh = zeros(length(mspecno),length(nobsdratseq));
Iseq = find(ti == dates);

M = 0;
for ispec = mspecno 
  mspec = mspecseq(ispec);
  M = M+1;
  L = 0;
  fprintf(fid00,'\n %9.99s ',char(modelnames{ispec}));
  fprintf(fid00,'%2.0f \\\\',mspec);
  
  
  for nobsdrat = nobsdratseq     


    if nobsdrat == 0
      lmodel_ref = [];
      nobsdrat_ = [];
      lambdac_ = [];
      mspec_ref = [];
      nlagsc_ = [];
      stup_ = [];

      
      mprior_ = 10*str2num(lprior(1))+2;
      lprior_    = num2str(mprior_);

    else
      mspec_ref = Mspec_Ref;
      lmodel_ref = strcat('m',num2str(mspec_ref));
      nobsdrat_ = num2str(100*nobsdrat);
      if nlagsc == 4
        nlagsc_ = [];
      else
        nlagsc_ = num2str(nlagsc);
      end  
    n_s_ = num2str(n_s);
   stup_ = num2str(stup);

      mprior_ = 10*str2num(lprior(1))+3;
      lprior_    = num2str(mprior_);
    end

    fprintf(fid00,'\n %2.2f ',nobsdrat);
    L = L+1;
    
    lmodel    = strcat('m',num2str(mspec));

    infile0 = strcat(spath,'Mh',lmodel,lprior_,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_,num2str(cointall),st,num2str(fixparam),num2str(JustMode),num2str(100*lambdas),num2str(100*ti(I)))


    fid0 = fopen(infile0,'r');     % output file (set to write)   
    pint0 = fread(fid0,[1,1],'single');
    fclose(fid0);
    
    fprintf(fid00,'Marg Lik: %2.2f ;',pint0);
    if ~isempty(mspec_ref)
      fprintf(fid00,'Reference: %2.0f ;',mspec_ref);

      infile0 = strcat(spath,'MhPrio',lmodel,lprior_,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_);
      fid0 = fopen(infile0,'r');     % output file (set to write)   
      pintpr = fread(fid0,[1,1],'single');
      fclose(fid0);

      fprintf(fid00,'Correction: %2.2f ;',pintpr);
      fprintf(fid00,'Corrected Marg Lik: %2.2f ;',pint0-pintpr);
      Mh(M,L) = pint0-pintpr;
      
    else
      Mh(M,L) = pint0;
    end
    fprintf(fid00,' \\\\');
    
  end         % end nobsdratseq
  
end %% end model


Mh = Mh-Mh(1,1);
Mh2 = Mh - repmat(Mh(1,:),[length(mspecno) 1]);

%Mh = Mh2;
Mh2 = Mh

tirf = 100*nobsdratseq;
sirf = (1:1:length(tirf));

tirf = num2str(tirf',2);

tirf

Acolor = zeros(size(Mh,1),3);
Lstyle = cell(size(Mh,1),1);
Mstyle = cell(size(Mh,1),1);
Lstyle(1) = {'-'};
Mstyle(1) = {'x'};
Acolor(2,:) = [.2 0 0];
Lstyle(2) = {'--'};
Mstyle(2) = {'*'};
Acolor(3,:) = [0 .35 .35];
Lstyle(3) = {'-.'};
Mstyle(3) = {'o'};
Acolor(4,:) = [0 0 1];
Lstyle(4) = {':'};
Mstyle(4) = {'^'};
Acolor(5,:) = [.2 .2 .2];
Lstyle(5) = {'-.'};
Mstyle(5) = {'.'};
Acolor(6,:) = [.2 .2 .2];
Lstyle(6) = {'-'};
Mstyle(6) = {'s'};

Acolor(1,:) = [0 0 0]%[0 .2 .2];
Acolor(2,:) = [0 0 1]%[0 .2 .2];
Acolor(3,:) = [1 0 0]%[0 .2 .2];
Acolor(4,:) = [0 1 0]%[0 .2 .2];

fprintf(fid00,'\n \\begin{table}[h] \\centering');        
fprintf(fid00,'\n \\caption{Marginal Likelihood} \n\\vspace*{.5cm}');
fprintf(fid00,Fortab);
fprintf(fid00,Heads);

if length(nobsdratseq) >1 

  figure(101);
  M = 0;
  mspecname = [];
  for  ispec = mspecno(M+1:end)
    mspec = mspecseq(ispec);
    mspecname = strcat(mspecname,'-',num2str(mspec));
    M = M+1;

    fprintf(fid00,'%9.99s ',char(modelnames{ispec}));
    fprintf(fid00,Fornum,Mh2(M,:));

    P = plot(sirf,Mh2(M,:));
    set(P,'Color',Acolor(M,:));
    set(P,'LineStyle',Lstyle{M});
    set(P,'Marker',Mstyle{M});
    set(P,'MarkerSize',8);
    set(P,'LineWidth',1.5);

    T =text(.99*sirf(end),1.05*Mh2(M,end),modelnames{ispec});
    set(T,'VerticalAlignment','top');
    set(T,'HorizontalAlignment','right');
    set(T,'FontSize',12);
    set(T,'FontWeight','bold');
    
    %  T =text(sirf(end),Mh2(M,end),num2str(Mh(M,end),'%5.0f'));
    %  set(T,'VerticalAlignment','bottom');
    %  set(T,'HorizontalAlignment','left');
    %  set(T,'FontSize',11);
    %  set(T,'FontWeight','bold');
    %  set(T,'Color',Acolor(M,:));
    
    %  T =text(sirf(1),Mh2(M,1),num2str(Mh(M,1),'%5.0f'));
    %  set(T,'VerticalAlignment','bottom');
    %  set(T,'HorizontalAlignment','left');
    %  set(T,'FontSize',11);
    %  set(T,'FontWeight','bold');
    %  set(T,'Color',Acolor(M,:));

    %  [ym,im] = max(Mh2(M,:));
    %  T =text(sirf(im),Mh2(M,im),num2str(Mh2(M,im),'%5.0f'));
    %  set(T,'VerticalAlignment','bottom');
    %  set(T,'HorizontalAlignment','left');
    %  set(T,'FontSize',11);
    %  set(T,'FontWeight','bold');
    %  set(T,'Color',Acolor(M,:));

    hold on;

    set(gca,'YLim',[min(min(Mh2(1:M,:)))-.2,max(max(Mh2(1:M,:)))+.2]);
    set(gca,'XLim',[min(sirf),max(sirf)]);
    set(gca,'XTick',sirf');
    set(gca,'XTickLabel',tirf);

    xlabel('T^*')
    figure(101);
    %set(figure(101),'PaperPosition',[0 0 7 9])
    ng=strcat(fpath,'lambdaplot',mspecname);

    if ispec == mspecno(end)
      %saveas(figure(101),char(ng),'fig');
      figure(101);
      print(char(strcat(ng,'.eps')),'-depsc2'); %print(char(strcat(ng,'.pdf')),'-dpdf');
    end

  end
  hold off;

end

fprintf(fid00,'\n \\end{document}');

fclose(fid00);		% close output file

