close all;
clear all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% PRELIMINARY STUFF
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
run startdsswfed;
!hostname;
!ps -C matlab;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%      paths & parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
varspec;

[fpath,spath,gpath] = pathspec(num2str(floor(dataset)));


fprintf(1,'model: %2.0f, dataset: %2.1f, prior: %2.0f, cointall: %2.0f,',[mspec,dataset,mprior,cointall]);

if isempty(mspec_ref)
  lmodel_ref = [];
  nobsdrat_ = [];
  lambdac_ = [];
  nlagsc_ = [];
  n_s_ = [];

 disp('NO reference model set in varspec.m')

else
  lmodel_ref = strcat('m',num2str(mspec_ref));
  nobsdrat_ = num2str(100*nobsdrat);
  lambdac_ = [];
  n_s_ = num2str(n_s);
  if nlagsc == 4
    nlagsc_ = [];
  else
    nlagsc_ = num2str(nlagsc);
  end  
    addc = 'inf';
    
end
  stup_ = num2str(stup);

  %% set of parameters that are subject to this procedure
  list_t1 = find(para_type == 1);
  npara1 = length(list_t1)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% load data
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[YYall,XXall,ti,nobsall] = loaddata(dataset,fpath,T0,Tend,coint,cointadd,cointall,nvar,nlags,mspec);
Iseq = find(ti == dates);
I = Iseq;
size(YYall)
%%%% presample
nlagsc2 = max(nlagsc,1);
T0_p = nlagsc2;
[YYall_p,XXall_p,ti_p,nobsall_p] = loaddata(dataset,fpath,T0_p,Tend,coint,cointadd,cointall,nvar,nlagsc2,mspec);
I_p = find(ti_p == dates);
dataset = num2str(10*dataset);

if stime                           
  YY = YYall(I-stime+1:I,:);
  XX = XXall(I-stime+1:I,:);             
  tiI = ti(I-stime+1:I);  
else
  YY     = YYall(1:I,:);
  XX     = XXall(1:I,:);                   
  tiI = ti(1:I);
end
nobs = size(YY,1);

YYYY = YY'*YY;
XXYY = XX'*YY;
XXXX = XX'*XX;

MeY_0 = mean(YY,1)'
VaY_0 = cov(YY,1);
stdY_0 = sqrt(diag(VaY_0));
CorY_0 = VaY_0./(stdY_0*stdY_0');
ACorY_0 = zeros(nvar,1);
for ii = 1:nvar;
  ACorY_0(ii) = corr(YY(:,ii),XX(:,1+cointall+ii));
end
stats_0 = [MeY_0' stdY_0' ACorY_0' CorY_0(:)'];


outfile200 = strcat(spath,'/stats');		
fid200 = fopen(outfile200,'w');		% output file (set to write)   
fwrite(fid200,stats_0,'single');
fclose(fid200);


CorLsPi = zeros(1,2*k_l+1);
for il = -k_l:k_l;
  if il < 0
    CorLsPi(k_l+1+il) = corr(YY(1:end+il,4),YY(1-il:end,3));
  else
    CorLsPi(k_l+1+il) = corr(YY(1+il:end,4),YY(1:end-il,3));
  end
end

outfile201 = strcat(spath,'/CorLsPi');		
fid201 = fopen(outfile201,'w');		% output file (set to write)   
fwrite(fid201,CorLsPi,'single');
fclose(fid201);

CorLsY = zeros(1,2*k_l+1);
for il = -k_l:k_l;
  if il < 0
    CorLsY(k_l+1+il) = corr(YY(1:end+il,3),YY(1-il:end,1));
  else
    CorLsY(k_l+1+il) = corr(YY(1+il:end,3),YY(1:end-il,1));
  end
end

outfile201 = strcat(spath,'/CorLsY');		
fid201 = fopen(outfile201,'w');		% output file (set to write)   
fwrite(fid201,CorLsY,'single');
fclose(fid201);

AcorLs = zeros(1,k_l);
for il = 1:k_l;
    AcorLs(il) = corr(YY(1:end-il,3),YY(1+il:end,3));
end

outfile201 = strcat(spath,'/AcorLs');		
fid201 = fopen(outfile201,'w');		% output file (set to write)   
fwrite(fid201,AcorLs,'single');
fclose(fid201);

AcorPi = zeros(1,k_l);
for il = 1:k_l;
    AcorPi(il) = corr(YY(1:end-il,4),YY(1+il:end,4));
end

outfile201 = strcat(spath,'/AcorPi');		
fid201 = fopen(outfile201,'w');		% output file (set to write)   
fwrite(fid201,AcorPi,'single');
fclose(fid201);


%%%% presample
YY_p = YYall_p(1:I_p-stime,:);
XX_p = XXall_p(1:I_p-stime,:);             
nobs_p = size(YY_p,1);

MeY_p = mean(YY_p,1)';
VaY_p = cov(YY_p,1);
stdY_p = sqrt(diag(VaY_p));
CorY_p = VaY_p./(stdY_p*stdY_p');
ACorY_p = zeros(nvar,1);
for ii = 1:nvar;
  ACorY_p(ii) = corr(YY_p(:,ii),XX_p(:,1+cointall+ii));
end

stats_p = [MeY_p' stdY_p' ACorY_p' CorY_p(:)'];
outfile200 = strcat(spath,'/statsPre');		
fid200 = fopen(outfile200,'w');		% output file (set to write)   
fwrite(fid200,stats_p,'single');
fclose(fid200);

k_l = 8;
CorLsPi_p = zeros(1,2*k_l+1);
for il = -k_l:k_l;
  if il < 0
    CorLsPi_p(k_l+1+il) = corr(YY_p(1:end+il,4),YY_p(1-il:end,3));
  else
    CorLsPi_p(k_l+1+il) = corr(YY_p(1+il:end,4),YY_p(1:end-il,3));
  end
end

outfile201 = strcat(spath,'/CorLsPi_p');		
fid201 = fopen(outfile201,'w');		% output file (set to write)   
fwrite(fid201,CorLsPi_p,'single');
fclose(fid201);


CorLsY_p = zeros(1,2*k_l+1);
for il = -k_l:k_l;
  if il < 0
    CorLsY_p(k_l+1+il) = corr(YY_p(1:end+il,1),YY_p(1-il:end,3));
  else
    CorLsY_p(k_l+1+il) = corr(YY_p(1+il:end,1),YY_p(1:end-il,3));
  end
end

outfile201 = strcat(spath,'/CorLsY_p');		
fid201 = fopen(outfile201,'w');		% output file (set to write)   
fwrite(fid201,CorLsY_p,'single');
fclose(fid201);

AcorLs_p = zeros(1,k_l);
for il = 1:k_l;
    AcorLs_p(il) = corr(YY_p(1:end-il,3),YY_p(1+il:end,3));
end

outfile201 = strcat(spath,'/AcorLs_p');		
fid201 = fopen(outfile201,'w');		% output file (set to write)   
fwrite(fid201,AcorLs_p,'single');
fclose(fid201);

AcorPi_p = zeros(1,k_l);
for il = 1:k_l;
    AcorPi_p(il) = corr(YY_p(1:end-il,4),YY_p(1+il:end,4));
end

outfile201 = strcat(spath,'/AcorPi_p');		
fid201 = fopen(outfile201,'w');		% output file (set to write)   
fwrite(fid201,AcorPi_p,'single');
fclose(fid201);


%% take constant out and demean

YYYY_p = (YY_p-repmat(mean(YY_p,1),[size(YY_p,1) 1]))'*(YY_p-repmat(mean(YY_p,1),[size(YY_p,1) 1]))/nobs_p
outfile2000 = strcat(spath,'/yyyy',dataset,num2str(nlagsc),'PreSample')	
fid2000 = fopen(outfile2000,'w');		% output file (set to write)   
fwrite(fid2000,YYYY_p,'single');
fclose(fid2000);

if nlagsc > 0
  XX_p = XX_p(:,2:end); 
  XXYY_p = (XX_p-repmat(mean(XX_p,1),[size(XX_p,1) 1]))'*(YY_p-repmat(mean(YY_p,1),[size(YY_p,1) 1]))/nobs_p;
  XXXX_p = (XX_p-repmat(mean(XX_p,1),[size(XX_p,1) 1]))'*(XX_p-repmat(mean(XX_p,1),[size(XX_p,1) 1]))/nobs_p;

  outfile3000 = strcat(spath,'/xxyy',dataset,num2str(nlagsc),'PreSample');		
  fid3000 = fopen(outfile3000,'w');		% output file (set to write)   
  outfile4000 = strcat(spath,'/xxxx',dataset,num2str(nlagsc),'PreSample');		
  fid4000 = fopen(outfile4000,'w');		% output file (set to write)   

  fwrite(fid3000,XXYY_p,'single');
  fwrite(fid4000,XXXX_p,'single');

  fclose(fid3000);
  fclose(fid4000);
end

%%%% first presample
YY_p1 = YYall_p(1:round((I_p-stime)/2),:);
XX_p1 = XXall_p(1:round((I_p-stime)/2),:);
nobs_p1 = size(YY_p1,1);

MeY_p1 = mean(YY_p1,1)';
VaY_p1 = cov(YY_p1,1);
stdY_p1 = sqrt(diag(VaY_p1));
CorY_p1 = VaY_p1./(stdY_p1*stdY_p1');
ACorY_p1 = zeros(nvar,1);
for ii = 1:nvar;
  ACorY_p1(ii) = corr(YY_p1(:,ii),XX_p1(:,1+cointall+ii));
end

stats_p1 = [MeY_p1' stdY_p1' ACorY_p1' CorY_p1(:)'];
outfile200 = strcat(spath,'/statsPre1');		
fid200 = fopen(outfile200,'w');		% output file (set to write)   
fwrite(fid200,stats_p1,'single');
fclose(fid200);

%% take constant out and demean

YYYY_p1 = (YY_p1-repmat(mean(YY_p1,1),[size(YY_p1,1) 1]))'*(YY_p1-repmat(mean(YY_p1,1),[size(YY_p1,1) 1]))/nobs_p1;
outfile2000 = strcat(spath,'/yyyy1',dataset,num2str(nlagsc),'PreSample')	
fid2000 = fopen(outfile2000,'w');		% output file (set to write)   
fwrite(fid2000,YYYY_p1,'single');
fclose(fid2000);

if nlagsc > 0
  XX_p1 = XX_p1(:,2:end); 
  XXYY_p1 = (XX_p1-repmat(mean(XX_p1,1),[size(XX_p1,1) 1]))'*(YY_p1-repmat(mean(YY_p1,1),[size(YY_p1,1) 1]))/nobs_p1;
  XXXX_p1 = (XX_p1-repmat(mean(XX_p1,1),[size(XX_p1,1) 1]))'*(XX_p1-repmat(mean(XX_p1,1),[size(XX_p1,1) 1]))/nobs_p1;

  outfile3000 = strcat(spath,'/xxyy1',dataset,num2str(nlagsc),'PreSample');		
  fid3000 = fopen(outfile3000,'w');		% output file (set to write)   
  outfile4000 = strcat(spath,'/xxxx1',dataset,num2str(nlagsc),'PreSample');		
  fid4000 = fopen(outfile4000,'w');		% output file (set to write)   

  fwrite(fid3000,XXYY_p1,'single');
  fwrite(fid4000,XXXX_p1,'single');

  fclose(fid3000);
  fclose(fid4000);
end


%%%% second presample
YY_p2 = YYall_p(round((I_p-stime)/2)+1:I_p-stime,:);
XX_p2 = XXall_p(round((I_p-stime)/2)+1:I_p-stime,:);
nobs_p2 = size(YY_p2,1);

MeY_p2 = mean(YY_p2,1)';
VaY_p2 = cov(YY_p2,1);
stdY_p2 = sqrt(diag(VaY_p2));
CorY_p2 = VaY_p2./(stdY_p2*stdY_p2');
ACorY_p2 = zeros(nvar,1);
for ii = 1:nvar;
  ACorY_p2(ii) = corr(YY_p2(:,ii),XX_p2(:,1+cointall+ii));
end

stats_p2 = [MeY_p2' stdY_p2' ACorY_p2' CorY_p2(:)'];
outfile200 = strcat(spath,'/statsPre2');		
fid200 = fopen(outfile200,'w');		% output file (set to write)   
fwrite(fid200,stats_p2,'single');
fclose(fid200);

%% take constant out and demean

YYYY_p2 = (YY_p2-repmat(mean(YY_p2,1),[size(YY_p2,1) 1]))'*(YY_p2-repmat(mean(YY_p2,1),[size(YY_p2,1) 1]))/nobs_p2;
outfile2000 = strcat(spath,'/yyyy2',dataset,num2str(nlagsc),'PreSample')	
fid2000 = fopen(outfile2000,'w');		% output file (set to write)   
fwrite(fid2000,YYYY_p2,'single');
fclose(fid2000);

if nlagsc > 0
  XX_p2 = XX_p2(:,2:end); 
  XXYY_p2 = (XX_p2-repmat(mean(XX_p2,1),[size(XX_p2,1) 1]))'*(YY_p2-repmat(mean(YY_p2,1),[size(YY_p2,1) 1]))/nobs_p2;
  XXXX_p2 = (XX_p2-repmat(mean(XX_p2,1),[size(XX_p2,1) 1]))'*(XX_p2-repmat(mean(XX_p2,1),[size(XX_p2,1) 1]))/nobs_p2;

  outfile3000 = strcat(spath,'/xxyy2',dataset,num2str(nlagsc),'PreSample');		
  fid3000 = fopen(outfile3000,'w');		% output file (set to write)   
  outfile4000 = strcat(spath,'/xxxx2',dataset,num2str(nlagsc),'PreSample');		
  fid4000 = fopen(outfile4000,'w');		% output file (set to write)   

  fwrite(fid3000,XXYY_p2,'single');
  fwrite(fid4000,XXXX_p2,'single');

  fclose(fid3000);
  fclose(fid4000);
end



ICUM = find(cum_for);
INCUM = find(cum_for == 0);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%*
% Load information for prior distribution

lprior    = num2str(mprior);
lmodel    = strcat('m',num2str(mspec));
if isempty(mspec_ref)
  priorfile = strcat('pri',lprior)
elseif ~isempty(mspec_ref)
  priorfile = strcat('pri',lprior)
end
prior = feval(priorfile);

pmean  = prior(1:npara,1);
pstdd  = prior(1:npara,2);
pshape = prior(1:npara,3);

pshape = pshape.*(1-para_mask);

pmean = pmean.*(1-para_mask)+para_fix.*para_mask;

nonpolipar = [1:1:npara];
nonpolipar(polipar) = [];

% Load transformation scheme for parameters
trspec = feval('transp',mspec);

trspec(:,1) = trspec(:,1).*(1-para_mask);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Reference Model for Prior Second Moments
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
nobsd = nobsdrat*nobs; %% is NaN if isempty(mspec_ref)


if ~isempty(mspec_ref)

  if isnan(mspec_ref)

    lprior_ref    = '';
    disp(nobs_p)
    k = nlagsc*nvar;

    POPUL = 0
    if POPUL 
      POP_ = '';
    else
      POP_ = 'P';
    end
    
    if isempty(n_s)
      
      infile02 = strcat(spath,'/yyyy',dataset,num2str(nlagsc),'PreSample')
      fid02 = fopen(infile02,'r');		% output file (set to write)   
      YYYYd = fread(fid02,[nvar nvar],'single')
      fclose(fid02);
      

      if nlagsc > 0
        
        infile03 = strcat(spath,'/xxyy',dataset,num2str(nlagsc),'PreSample');		
        fid03 = fopen(infile03,'r');		% output file (set to write)   
        infile04 = strcat(spath,'/xxxx',dataset,num2str(nlagsc),'PreSample');		
        fid04 = fopen(infile04,'r');		% output file (set to write)   


        XXYYd = fread(fid03,[k  nvar],'single');
        XXXXd = fread(fid04,[k k],'single');
        


        VaY = YYYYd;
        stdY = sqrt(diag(VaY))
        CorY = VaY./(stdY*stdY')
        CoY = XXYYd(1:nvar,:)
        ACorY = diag(CoY)./diag(VaY)

        fclose(fid03);
        fclose(fid04);
        
      elseif nlagsc == 0
        
        XXYYd = zeros([k  nvar]);
        XXXXd = zeros([k k]);
        
      end

    elseif ~isempty(n_s)
      nobsd = nobsd/n_s;

      YYYYd = zeros([nvar  nvar n_s]);
      XXYYd = zeros([k  nvar n_s]);
      XXXXd = zeros([k k n_s]);
      
      for i_s = 1:n_s
        infile02 = strcat(spath,'/yyyy',num2str(i_s),dataset,num2str(nlagsc),'PreSample')
        fid02 = fopen(infile02,'r');		% output file (set to write)   
        YYYYd(:,:,i_s) = fread(fid02,[nvar nvar],'single')
        fclose(fid02);
        
        

        if nlagsc > 0
          
          infile03 = strcat(spath,'/xxyy',num2str(i_s),dataset,num2str(nlagsc),'PreSample');		
          fid03 = fopen(infile03,'r');		% output file (set to write)   
          infile04 = strcat(spath,'/xxxx',num2str(i_s),dataset,num2str(nlagsc),'PreSample');		
          fid04 = fopen(infile04,'r');		% output file (set to write)   


          XXYYd(:,:,i_s) = fread(fid03,[k  nvar],'single');
          XXXXd(:,:,i_s) = fread(fid04,[k k],'single');
          
          fclose(fid03);
          fclose(fid04);
          
        elseif nlagsc == 0
          
          XXYYd(:,:,i_s) = zeros([k  nvar]);
          XXXXd(:,:,i_s) = zeros([k k]);
          
        end
        
      end    
    end

    outfile2 = strcat(spath,'/yyyy',lmodel_ref,lprior_ref,dataset,nlagsc_,n_s_,POP_,'Bench');
    fid2 = fopen(outfile2,'w');		% output file (set to write)   
    fwrite(fid2,YYYYd,'single');    
    fclose(fid2);
    outfile3 = strcat(spath,'/xxyy',lmodel_ref,lprior_ref,dataset,nlagsc_,n_s_,POP_,'Bench');
    fid3 = fopen(outfile3,'w');		% output file (set to write)   
    outfile4 = strcat(spath,'/xxxx',lmodel_ref,lprior_ref,dataset,nlagsc_,n_s_,POP_,'Bench');
    fid4 = fopen(outfile4,'w');		% output file (set to write)   


    fwrite(fid3,XXYYd,'single');
    fwrite(fid4,XXXXd,'single');

    fclose(fid3);
    fclose(fid4);

  end

  %infile0 = strcat(spath,'/mhpriopara',lmodel,lprior_bar,dataset,[],[],'Mean')

  %fid0 = fopen(infile0,'r');     % input file (set to read)   
  %params_1bar = fread(fid0,[npara,1],'single');
  %fclose(fid0);  
  %params_1bar = params_1bar.*(1-para_mask)+para_fix.*para_mask;


  YYYYd = YYYYd*nobsd;
  XXYYd = XXYYd*nobsd;
  XXXXd = XXXXd*nobsd;




else
  YYYYd = [];
  XXYYd = [];
  XXXXd = [];
end  % end if ~isempty(mspec_ref)

  

marglh = 'marglh';

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Set parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% set date
I = find(ti == dates);

%% prior params file 
 infile0 = strcat(spath,'/mhpriopara',lmodel,lprior,dataset,lmodel_ref,nobsdrat_,nlagsc_,n_s_,'Mode')
%infile0 = '/home/f1mdn14/nas02/amdn/wk/save/dsgeprio/fed/507/6//mhprioparam106160mNaN31Mode'
lmodel00    = lmodel;%
lmodel00 = strcat('m',num2str(106)); 
nobsdrat_00 = num2str(4);
%infile0 = strcat(spath,'/mhpriopara',lmodel00,lprior,dataset,lmodel_ref,nobsdrat_00,nlagsc_,n_s_,'Mode')

if exist(infile0,'file');
  fid0 = fopen(infile0,'r');     % input file (set to read)   
  params = fread(fid0,[npara,1],'single');
  fclose(fid0);
else
  params = pmean;
end
params = params.*(1-para_mask)+para_fix.*para_mask;



CH = menu('Re -  Maximize the posterior density?','Yes','No');


if CH == 1
  %%     Maximize the posterior density
  x0= invtrans(params,trspec);%+.0005*randn(npara,1);
  H0= eye(npara)*1E-4;
  nit = input('number of iterations?'); 

  crit= 1E-16;
  MIN = 1;
  
  [fh,xh,g,H,itct,fcount,retcode] = csminwel('objfcnprio',x0,H0,[],crit,nit,...
                                             YYYYd,XXYYd,XXXXd,nobsd,nlagsc,nvar,mspec,npara,trspec,...
                                             pmean,pstdd,pshape,para_mask,para_fix,marglh,coint,cointadd,cointall,MIN);

  xh = real(xh);
  params = trans(xh,trspec);
  params = params.*(1-para_mask)+para_fix.*para_mask;
  disp('move on?');	pause;

  outfile0 = strcat(spath,'/mhpriopara',lmodel,lprior,dataset,lmodel_ref,nobsdrat_,nlagsc_,n_s_,'Mode')
  fid0 = fopen(outfile0,'w');     % output file (set to write)   
  fwrite(fid0,params','single');
  fclose(fid0);
  
end

%% prior params file (first block has already been thrown out)
infile01 = strcat(spath,'/mhpriopara',lmodel,lprior,dataset,lmodel_ref,nobsdrat_,nlagsc_,n_s_,'Hessian');   
if ~exist(infile01,'file');
  CH = 1;
else
  fid01 = fopen(infile01,'r');     % input file (set to read)   
  hessian = fread(fid01,[npara,npara],'single');
  fclose(fid01);
  CH = menu('Re-Compute hessian?','Yes','No','just finish');
end
if CH == 1
  MIN = 0;
  hessian = hessizero('objfcnprio',[params,para_mask],1,...
                      YYYYd,XXYYd,XXXXd,nobsd,nlagsc,nvar,mspec,npara,trspec,...
                      pmean,pstdd,pshape,para_mask,para_fix,marglh,coint,cointadd,cointall,MIN);
  disp('proceed?');     
  %pause
elseif CH == 3
  return;
end;
outfile01 = strcat(spath,'/mhpriopara',lmodel,lprior,dataset,lmodel_ref,nobsdrat_,nlagsc_,n_s_,'Hessian');   

fid01 = fopen(outfile01,'w');     % output file (set to write)   
fwrite(fid01,hessian(:),'single');
fclose(fid01);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% set up Metropolis Hastings
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%*
% Load information for prior distribution

lprior    = num2str(mprior);
lmodel    = strcat('m',num2str(mspec));
priorfile = strcat('pri',lprior)
prior = feval(priorfile);

pmean  = prior(1:npara,1);
pstdd  = prior(1:npara,2);
pshape = prior(1:npara,3);

pshape = pshape.*(1-para_mask);
pmean = pmean.*(1-para_mask)+para_fix.*para_mask;
noflip = 0
if noflip & exist(infile01,'file');
infile01 = strcat(spath,'/mhpriopara',lmodel,lprior,dataset,lmodel_ref,nobsdrat_,nlagsc_,n_s_,'Cov')

  fid01 = fopen(infile01,'r');     % input file (set to read)   
  hessian = fread(fid01,[npara,npara],'single');
noflip = 1;
  fclose(fid01);
end

rankhhm = npara;
% Create Inverse by Singular Value Decomposition
[u,s,v] = svd(hessian);
md = min(size(s)); 
bigev = find(diag(s(1:md,1:md))>1e-6);
sigpropdim = length(bigev);

sigproplndet = 0;
for i = 1:npara
  
  if i > sigpropdim
    s(i,i) = 0;
  else
    
    if noflip
    s(i,i)    = s(i,i);
      
      else
    s(i,i)    = 1/s(i,i);
    end
    
    sigproplndet = sigproplndet+log(s(i,i));  
    
  end
end


invhhm  = u*s*u';
sigscale = u*sqrt(s);
sigpropinv  =  hessian; 
clear hessian*;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%  Configure the Metropolis Algorithm
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
cc0     = 0.01;
cc      = 0.1;

ntimes = 1

Verbose = 0;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  stmoms;
  
  
statname = {'POST';'LIKE';'PROP';'PROPPOST';'REJECT'};

pred = [];
vpred = [];

%% check bounds
ind1 = (params > bounds(:,2));
ind1(find(para_mask)) = [];
ind2 = (params < bounds(:,1));
ind2(find(para_mask)) = [];
if any(ind1) | any(ind2)
  lnpost0 = -1E6;
  disp('mode out of bounds'); 
  return;

else

  lnprio  = priodens(params,pmean,pstdd,pshape);

  [M_vec] = getparaM(params,mspec)
  lnprioM = - sum( ( (M_vec-M_mean).^2 )./M_var );

  lnpy = 0; %% this is the dummy obs part
  [TTT,RRR,valid] = dsgesolv(params,mspec);
  nstate = length(TTT);
  nshocks = size(RRR,2);
  if ~isnan(nobsd)

    [yyyyd,xxyyd,xxxxd,retcode] = varprio_dmean(TTT,RRR,valid,params,nvar,nlagsc,mspec,npara,coint,cointadd,cointall);
    lnpy = feval(strcat('objfcnmh',addc),params,YYYYd,XXYYd,XXXXd,nobsd,...
                 nlagsc,nvar,mspec,npara,trspec,pmean,pstdd,pshape,yyyyd,xxyyd,xxxxd,retcode,para_mask,coint,cointadd,cointall);
  end

  lnpost0  = lnpy + real(lnprio) + real(lnprioM);
end

% Initialize PARANEW            
valid0 = 0;
while ~valid0
  
  paranew   = params + cc0*(sigscale*randn(npara,1));
  paranew = paranew.*(1-para_mask)+para_fix.*para_mask;

  %% check bounds
  ind1 = (paranew > bounds(:,2));
  ind1(find(para_mask)) = [];
  ind2 = (paranew < bounds(:,1));
  ind2(find(para_mask)) = [];
  if any(ind1) | any(ind2)
    postnew = -1E6;
  else
    lnprionew  = priodens(paranew,pmean,pstdd,pshape);

    [M_vec] = getparaM(paranew,mspec);
    lnprioMnew = - sum( ( (M_vec-M_mean).^2 )./M_var );

    likenew = 0; %% this is the dummy obs part
    [TTT,RRR,valid] = dsgesolv(paranew,mspec);
    if valid < 1;
      likenew = -10000; %% this is the dummy obs part
      
    else
      likenew = 0; %% this is the dummy obs part
      if ~isnan(nobsd)
        
        [yyyyd,xxyyd,xxxxd,retcode] = varprio_dmean(TTT,RRR,valid,paranew,nvar,nlagsc,mspec,npara,coint,cointadd,cointall);
        likenew = feval(strcat('objfcnmh',addc),paranew,YYYYd,XXYYd,XXXXd,nobsd,...
                        nlagsc,nvar,mspec,npara,trspec,pmean,pstdd,pshape,yyyyd,xxyyd,xxxxd,retcode,para_mask,coint,cointadd,cointall);
        
      end
    end

    postnew =  likenew + real(lnprionew) + real(lnprioMnew);
  end

  propdens  = -0.5*sigpropdim*log(2*pi) - 0.5*sigproplndet - 0.5*sigpropdim*log(cc0^2) ...
      -0.5*(paranew - params)'*sigpropinv*(paranew - params)/cc0^2;
  if postnew > -10000;
    valid0 = 1
  end
  disp('initializing')
  
end  

tic
fprintf(1,'\n model = %2.3f ',[mspec]);
fprintf(1,'\n Time %3.2f ',[ti(I)]);
fprintf(1,'\n Peak = %2.3f',[lnpost0]);



%% prior params file 
outfile1 = strcat(spath,'/mhNIpriopara',lmodel,lprior,dataset,lmodel_ref,nobsdrat_,nlagsc_,n_s_);
fid1 = fopen(outfile1,'w');		% input file (set to write)               

%% Posterior file
outfile4 = strcat(spath,'/priopost',lmodel,lprior,dataset,lmodel_ref,nobsdrat_,nlagsc_,n_s_);
fid4 = fopen(outfile4,'w');     % output file (set to write)   

%% MA representation: TTT (nstate x nstate) and RRR (nstate x nshocks)
outfile11 = strcat(spath,'/TTTprio',lmodel,lprior,dataset,lmodel_ref,nobsdrat_,nlagsc_,n_s_);    
fid11 = fopen(outfile11,'w');		% input file (set to write) 

outfile12 = strcat(spath,'/RRRprio',lmodel,lprior,dataset,lmodel_ref,nobsdrat_,nlagsc_,n_s_);  
fid12 = fopen(outfile12,'w');		% input file (set to write) 



%%  set initial values for simulations
Tim = 0;
eT = 0;	        
reje = 0;

for iblock = 1:nblocks  

  if iblock >1; fprintf(1,' block: %2.0f %3.2f ;',[iblock,toc/(iblock-1)]); end;


    parasimm = zeros(nsim,npara);
    postsim = zeros(nsim,1);
    TTTsim = zeros(nsim,nstate^2);
    RRRsim = zeros(nsim,nstate*nshocks);
    
  
    rej = 0;
    bds = [0 0];
for j = 1:nsim*ntimes
      % for j = 1:nsim
    Tim = Tim+1;  	        
    
    if ( j == 1 ) & (iblock == 1)
      postold      = postnew;
      likeold      = likenew;
      paraold      = paranew;     
      rej(1) = 0;

    if ~isnan(nobsd)
      yyyydold = yyyyd; 
      xxyydold = xxyyd; 
      xxxxdold = xxxxd; 
      end
      

      TTTold = TTT;
      RRRold = RRR;
      validold = valid;
      
    end
    
    paranew          = paraold + cc*(sigscale*randn(npara,1));
    paranew = paranew.*(1-para_mask)+para_fix.*para_mask;

    %paranew(33:end) = abs(paranew(33:end));
    %paranew(26:33) = min(paranew(26:33),bounds(26:33,2));
    %paranew([3 13]) = min(paranew([3 13]),bounds([3 13],2));
    
    %% check bounds
    ind1 = (paranew > bounds(:,2));
    %find1 = find(ind1);
    ind1(find(para_mask)) = [];
    ind2 = (paranew < bounds(:,1));
    %find2 = find(ind2);
    ind2(find(para_mask)) = [];
    if any(ind1) | any(ind2)
      postnew = -1E6;
    else
      lnprionew  = priodens(paranew,pmean,pstdd,pshape);

      [M_vec] = getparaM(paranew,mspec);
      lnprioMnew = - sum( ( (M_vec-M_mean).^2 )./M_var );

      likenew = 0; %% this is the dummy obs part
      [TTT,RRR,valid] = dsgesolv(paranew,mspec);
      if valid < 1;
        likenew = -10000; %% this is the dummy obs part
        
      else
        likenew = 0; %% this is the dummy obs part
        if ~isnan(nobsd)
          
          [yyyyd,xxyyd,xxxxd,retcode] = varprio_dmean(TTT,RRR,valid,paranew,nvar,nlagsc,mspec,npara,coint,cointadd,cointall);
          likenew = feval(strcat('objfcnmh',addc),paranew,YYYYd,XXYYd,XXXXd,nobsd,...
                          nlagsc,nvar,mspec,npara,trspec,pmean,pstdd,pshape,yyyyd,xxyyd,xxxxd,retcode,para_mask,coint,cointadd,cointall);
          
        end
      end

      postnew =  likenew + real(lnprionew) + real(lnprioMnew);
    end

    
    propdens         = -0.5*sigpropdim*log(2*pi) - 0.5*sigproplndet - 0.5*sigpropdim*log(cc^2) ...
        -0.5*(paranew - paraold)'*sigpropinv*(paranew - paraold)/cc^2;
    
    r = min([1 ; exp( postnew - postold)]);      
    
    ra = rand(1,1);
    
    if ra  < r;
      % Accept proposed jump
      
      parasim = paranew;
      
      paraold = paranew;
      postold = postnew;
      likeold = likenew;
      
    if ~isnan(nobsd)
      yyyydold = yyyyd; 
      xxyydold = xxyyd; 
      xxxxdold = xxxxd;                                 
      end
      
      TTTold = TTT;
      RRRold = RRR;
      validold = valid;
      
      if (j/ntimes) == round(j/ntimes)
        parasimm(j/ntimes,:) = paranew';
        postsim(j/ntimes,1) = postnew;
        TTTsim(j/ntimes,:) = TTT(:)';
        RRRsim(j/ntimes,:) = RRR(:)';
      end      
    else;
      
      % Reject proposed jump
      parasim = paranew;
      
      reje = reje+1;
      rej = rej+1;
      
      if       postnew <= -1E6
        bds(1) = bds(1)+1;
        
      else
        bds(2) = bds(2)+1;
      end
      
      
      if ~isnan(nobsd)
        yyyyd = yyyydold; 
        xxyyd = xxyydold; 
        xxxxd = xxxxdold; 
      end
      
      TTT = TTTold;
      RRR = RRRold;
      valid = validold;
      
      if (j/ntimes) == round(j/ntimes)
        parasimm(j/ntimes,:) = paraold';
        postsim(j/ntimes,1) = postold;
        TTTsim(j/ntimes,:) = TTTold(:)';
        RRRsim(j/ntimes,:) = RRRold(:)';
      end
      
    end
    if Verbose
      fprintf(1,'\nBlock %2.2g of %2.2g',[iblock,nblocks]);
      fprintf(1,'\nSimulation step %2.0f of %2.0f',[j,nsim]);
      fprintf(1,'\nRejection r: %2.6f rej %2.2g perct %2.4f ',[r,reje/Tim]);
      %    fprintf(1,'\n Parameters: %2.6f',parasim(26:end));
      
    end                            
    
  end % end j=1:nsim  
  fprintf(1,'\n block rejection rate = %2.4f, overall rejection rate = %2.4f',[rej/j reje/Tim]);

  fwrite(fid1,parasimm','single');
  fwrite(fid4,postsim','single');
  fwrite(fid11,TTTsim','single');
  fwrite(fid12,RRRsim','single');

  
end;    % end simulation - given lambda and time period
fclose(fid1);
fclose(fid4);
fclose(fid11);
fclose(fid12);
toc
fprintf(1,'rejection rate = %2.4f',reje/Tim);

