close all;
clear all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% PRELIMINARY STUFF
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
run startdsswfed;
!hostname;
!ps -C matlab;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%      paths & parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
varspec;

[fpath,spath,gpath] = pathspec(num2str(floor(dataset)));


fprintf(1,'model: %2.0f, dataset: %2.1f, prior: %2.0f, cointall: %2.0f,',[mspec,dataset,mprior,cointall]);

if isempty(mspec_ref)
  lmodel_ref = [];
  nobsdrat_ = [];
  lambdac_ = [];
  nlagsc_ = [];
  n_s_ = [];

  disp('NO reference model set in varspec.m')

else
  lmodel_ref = strcat('m',num2str(mspec_ref));
  nobsdrat_ = num2str(100*nobsdrat);
  lambdac_ = [];
  n_s_ = num2str(n_s);
  if nlagsc == 4
    nlagsc_ = [];
  else
    nlagsc_ = num2str(nlagsc);
  end  
  addc = 'inf';
  
end
stup_ = num2str(stup);

%% set of parameters that are subject to this procedure
list_t2 = find(para_type == 2);
npara2 = length(list_t2);

para_names{list_t2}
if isempty(list_t2)
  disp('No params of type 2');
  return;
end

%% other set of params
list_t0 = find(para_type == 0);
npara0 = length(list_t0)
list_t1 = find(para_type == 1);
npara1 = length(list_t1)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% load data and set moments matrices for dummy obs
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
setmommat;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

nobsd = nobsdrat*nobs; %% is NaN if isempty(mspec_ref)

if ~isempty(mspec_ref)

  if isnan(mspec_ref)

    lprior_ref    = '';
    disp(nobs_p)
    k = nlagsc*nvar;

    POPUL = 0
    if POPUL 
      POP_ = '';
    else
      POP_ = 'P';
    end
    
    
    infile02 = strcat(spath,'/yyyy',dataset,num2str(nlagsc),'PreSample')
    fid02 = fopen(infile02,'r');		% output file (set to write)   
    YYYYd = fread(fid02,[nvar nvar],'single')
    fclose(fid02);
    

    if nlagsc > 0
      
      infile03 = strcat(spath,'/xxyy',dataset,num2str(nlagsc),'PreSample');		
      fid03 = fopen(infile03,'r');		% output file (set to write)   
      infile04 = strcat(spath,'/xxxx',dataset,num2str(nlagsc),'PreSample');		
      fid04 = fopen(infile04,'r');		% output file (set to write)   


      XXYYd = fread(fid03,[k  nvar],'single');
      XXXXd = fread(fid04,[k k],'single');
      


      VaY = YYYYd;
      stdY = sqrt(diag(VaY))
      CorY = VaY./(stdY*stdY')
      CoY = XXYYd(1:nvar,:)
      ACorY = diag(CoY)./diag(VaY)

      fclose(fid03);
      fclose(fid04);
      
    elseif nlagsc == 0
      
      XXYYd = zeros([k  nvar]);
      XXXXd = zeros([k k]);
      
    end


    outfile2 = strcat(spath,'/yyyy',lmodel_ref,lprior_ref,dataset,nlagsc_,n_s_,POP_,'Bench');
    fid2 = fopen(outfile2,'w');		% output file (set to write)   
    fwrite(fid2,YYYYd,'single');    
    fclose(fid2);
    outfile3 = strcat(spath,'/xxyy',lmodel_ref,lprior_ref,dataset,nlagsc_,n_s_,POP_,'Bench');
    fid3 = fopen(outfile3,'w');		% output file (set to write)   
    outfile4 = strcat(spath,'/xxxx',lmodel_ref,lprior_ref,dataset,nlagsc_,n_s_,POP_,'Bench');
    fid4 = fopen(outfile4,'w');		% output file (set to write)   


    fwrite(fid3,XXYYd,'single');
    fwrite(fid4,XXXXd,'single');

    fclose(fid3);
    fclose(fid4);

  end

  YYYYd = YYYYd*nobsd;
  XXYYd = XXYYd*nobsd;
  XXXXd = XXXXd*nobsd;

else
  YYYYd = [];
  XXYYd = [];
  XXXXd = [];
end  % end if ~isempty(mspec_ref)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%*
% Load information for prior distribution

lprior    = num2str(mprior);
lmodel    = strcat('m',num2str(mspec));
if isempty(mspec_ref)
  priorfile = strcat('pri',lprior)
elseif ~isempty(mspec_ref)
  priorfile = strcat('pri',lprior)
end
prior = feval(priorfile);

pmean  = prior(1:npara,1);
pstdd  = prior(1:npara,2);
pshape = prior(1:npara,3);

pshape = pshape.*(1-para_mask);

pmean = pmean.*(1-para_mask)+para_fix.*para_mask;

nonpolipar = [1:1:npara];
nonpolipar(polipar) = [];

% Load transformation scheme for parameters
trspec = feval('transp',mspec);

trspec(:,1) = trspec(:,1).*(1-para_mask);


marglh = 'marglh';

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Set parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% set date
I = find(ti == dates);

%% prior params file 
infile0 = strcat(spath,'/mhprioparat2',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_,'Mode')
%infile0 = '/home/f1mdn14/nas02/amdn/wk/save/dsgeprio/fed/507/6//mhprioparam106160mNaN31Mode'
lmodel00    = lmodel;%
%lmodel00 = strcat('m',num2str(106)); 
nobsdrat_00 = num2str(10);
%infile0 = strcat(spath,'/mhpriopara',lmodel00,lprior,dataset,lmodel_ref,stup_,nobsdrat_00,nlagsc_,n_s_,'Mode')

if exist(infile0,'file');
  fid0 = fopen(infile0,'r');     % input file (set to read)   
  params = fread(fid0,[npara,1],'single');
  fclose(fid0);
else
  params = pmean;
end


%% redefine para_mask (and para_fix) to include type ~= 0
para_mask2 = para_mask + (para_type ~= 2).*(1-para_mask);
pshape2 = pshape.*(1-para_mask2);
para_fix2 = para_fix;

%% recover the mean for type 0 and type 1 params and redefine para_fix for type 2
if ~isempty(list_t0)
  infile000 = strcat(spath,'/mhprioparat0',lmodel,lprior(1),dataset,'Mean');
  fid000 = fopen(infile000,'r');     % input file (set to read)   
  pmean0 = fread(fid000,[npara0,1],'single');
  fclose(fid000);
  
  para_fix2(list_t0) = pmean0;  
end
if ~isempty(list_t1)
  infile001 = strcat(spath,'/mhprioparat1',lmodel,lprior,dataset,lmodel_ref,stup_,'Mean');
  fid001 = fopen(infile001,'r');     % input file (set to read)   
  pmean1 = fread(fid001,[npara1,1],'single');
  fclose(fid001);
  
  para_fix2(list_t1) = pmean1;
end

params = params.*(1-para_mask2)+para_fix2.*para_mask2;

CH = 2%menu('Re -  Maximize the posterior density?','Yes','No');


if CH == 1
  %%     Maximize the posterior density
  x0= invtrans(params,trspec);%+.0005*randn(npara,1);
  H0= eye(npara)*1E-4;
  nit = input('number of iterations?'); 

  crit= 1E-16;
  MIN = 1;
  
  [fh,xh,g,H,itct,fcount,retcode] = csminwel('objfcnprioql',x0,H0,[],crit,nit,...
                                             YYYYd,XXYYd,XXXXd,nobsd,nlagsc,nvar,mspec,npara,trspec,...
                                             pmean,pstdd,pshape2,para_mask2,para_fix2,coint,cointadd,cointall,MIN);

  xh = real(xh);
  params = trans(xh,trspec);
  params = params.*(1-para_mask2)+para_fix2.*para_mask2;
  disp('move on?');	pause;

  outfile0 = strcat(spath,'/mhprioparat2',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_,'Mode')
  fid0 = fopen(outfile0,'w');     % output file (set to write)   
  fwrite(fid0,params','single');
  fclose(fid0);
  
end

%% prior params file (first block has already been thrown out)
infile01 = strcat(spath,'/mhprioparat2',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_,'Hessian');   
if ~exist(infile01,'file');
  CH = 1;
else
  fid01 = fopen(infile01,'r');     % input file (set to read)   
  hessian = fread(fid01,[npara,npara],'single');
  fclose(fid01);
  CH = 2%menu('Re-Compute hessian?','Yes','No','just finish');
end
if CH == 1
  MIN = 0;
  hessian = hessizero('objfcnprioql',[params,para_mask2],1,...
                      YYYYd,XXYYd,XXXXd,nobsd,nlagsc,nvar,mspec,npara,trspec,...
                      pmean,pstdd,pshape2,para_mask2,para_fix2,coint,cointadd,cointall,MIN);
  disp('proceed?');     
  %pause
elseif CH == 3
  return;
end;
outfile01 = strcat(spath,'/mhprioparat2',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_,'Hessian');   

fid01 = fopen(outfile01,'w');     % output file (set to write)   
fwrite(fid01,hessian(:),'single');
fclose(fid01);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% set up Metropolis Hastings
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


noflip = 0
if noflip & exist(infile01,'file');
infile01 = strcat(spath,'/mhprioparat2',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_,'Cov')

  fid01 = fopen(infile01,'r');     % input file (set to read)   
  hessian = fread(fid01,[npara,npara],'single');
noflip = 1;
  fclose(fid01);
end

rankhhm = npara;
% Create Inverse by Singular Value Decomposition
[u,s,v] = svd(hessian);
md = min(size(s)); 
bigev = find(diag(s(1:md,1:md))>1e-6);
sigpropdim = length(bigev);

sigproplndet = 0;
for i = 1:npara
  
  if i > sigpropdim
    s(i,i) = 0;
  else
    
    if noflip
    s(i,i)    = s(i,i);
      
      else
    s(i,i)    = 1/s(i,i);
    end
    
    sigproplndet = sigproplndet+log(s(i,i));  
    
  end
end


invhhm  = u*s*u';
sigscale = u*sqrt(s);
sigpropinv  =  hessian; 
clear hessian*;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%  Configure the Metropolis Algorithm
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
cc0     = 0.01;
cc      = 0.1;

ntimes = 1

Verbose = 0;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
DOD = 1%input('\n\n Skip Metropolis Hastings? (0 = just skip, else produce draws)');
if DOD

  statname = {'POST';'LIKE';'PROP';'PROPPOST';'REJECT'};

  pred = [];
  vpred = [];

  %% check bounds
  ind1 = (params > bounds(:,2));
  ind1(find(para_mask2)) = [];
  ind2 = (params < bounds(:,1));
  ind2(find(para_mask2)) = [];
  if any(ind1) | any(ind2)
    lnpost0 = -1E6;
    disp('mode out of bounds'); 
    return;

  else

    lnprio  = priodens(params,pmean,pstdd,pshape2);

    lnpy = 0; %% this is the dummy obs part
    [TTT,RRR,valid] = dsgesolv(params,mspec);
    nstate = length(TTT);
    nshocks = size(RRR,2);
    if ~isnan(nobsd)

      [yyyyd,xxyyd,xxxxd,retcode] = varprio_dmean(TTT,RRR,valid,params,nvar,nlagsc,mspec,npara,coint,cointadd,cointall);
      lnpy = feval(strcat('objfcnmh',addc),params,YYYYd,XXYYd,XXXXd,nobsd,...
                   nlagsc,nvar,mspec,npara,trspec,pmean,pstdd,pshape2,yyyyd,xxyyd,xxxxd,retcode,para_mask2,coint,cointadd,cointall);
    end

    lnpost0  = lnpy + real(lnprio);
  end

  % Initialize PARANEW            
  valid0 = 0;
  while ~valid0
    
    paranew   = params + cc0*(sigscale*randn(npara,1));
    paranew = paranew.*(1-para_mask2)+para_fix2.*para_mask2;

    %% check bounds
    ind1 = (paranew > bounds(:,2));
    ind1(find(para_mask2)) = [];
    ind2 = (paranew < bounds(:,1));
    ind2(find(para_mask2)) = [];
    if any(ind1) | any(ind2)
      postnew = -1E6;
    else
      lnprionew  = priodens(paranew,pmean,pstdd,pshape2);


      likenew = 0; %% this is the dummy obs part
      [TTT,RRR,valid] = dsgesolv(paranew,mspec);
      if valid < 1;
        likenew = -10000; %% this is the dummy obs part
        
      else
        likenew = 0; %% this is the dummy obs part
        if ~isnan(nobsd)
          
          [yyyyd,xxyyd,xxxxd,retcode] = varprio_dmean(TTT,RRR,valid,paranew,nvar,nlagsc,mspec,npara,coint,cointadd,cointall);
          likenew = feval(strcat('objfcnmh',addc),paranew,YYYYd,XXYYd,XXXXd,nobsd,...
                          nlagsc,nvar,mspec,npara,trspec,pmean,pstdd,pshape2,yyyyd,xxyyd,xxxxd,retcode,para_mask2,coint,cointadd,cointall);
          
        end
      end

      postnew =  likenew + real(lnprionew);
    end

    propdens  = -0.5*sigpropdim*log(2*pi) - 0.5*sigproplndet - 0.5*sigpropdim*log(cc0^2) ...
        -0.5*(paranew - params)'*sigpropinv*(paranew - params)/cc0^2;
    if postnew > -10000;
      valid0 = 1
    end
    disp('initializing')
    
  end  

  tic
  fprintf(1,'\n model = %2.3f ',[mspec]);
  fprintf(1,'\n Time %3.2f ',[ti(I)]);
  fprintf(1,'\n Peak = %2.3f',[lnpost0]);



  %% prior params file 
  outfile1 = strcat(spath,'/mhprioparat2',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_);
  fid1 = fopen(outfile1,'w');		% input file (set to write)               

  %% Posterior file
  outfile4 = strcat(spath,'/priopostt2',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_);
  fid4 = fopen(outfile4,'w');     % output file (set to write)   

  %%  set initial values for simulations
  Tim = 0;
  eT = 0;	        
  reje = 0;

  for iblock = 1:nblocks  

    if iblock >1; fprintf(1,' block: %2.0f %3.2f ;',[iblock,toc/(iblock-1)]); end;


    parasimm = zeros(nsim,npara2);
    postsim = zeros(nsim,1);
    
    rej = 0;
    bds = [0 0];
    for j = 1:nsim*ntimes
      % for j = 1:nsim
      Tim = Tim+1;  	        
      
      if ( j == 1 ) & (iblock == 1)
        postold      = postnew;
        likeold      = likenew;
        paraold      = paranew;     
        rej(1) = 0;

        if ~isnan(nobsd)
          yyyydold = yyyyd; 
          xxyydold = xxyyd; 
          xxxxdold = xxxxd; 
        end
        

        TTTold = TTT;
        RRRold = RRR;
        validold = valid;
        
      end
      
      paranew          = paraold + cc*(sigscale*randn(npara,1));
      paranew = paranew.*(1-para_mask2)+para_fix2.*para_mask2;

      %paranew(33:end) = abs(paranew(33:end));
      %paranew(26:33) = min(paranew(26:33),bounds(26:33,2));
      %paranew([3 13]) = min(paranew([3 13]),bounds([3 13],2));
      
      %% check bounds
      ind1 = (paranew > bounds(:,2));
      %find1 = find(ind1);
      ind1(find(para_mask2)) = [];
      ind2 = (paranew < bounds(:,1));
      %find2 = find(ind2);
      ind2(find(para_mask2)) = [];
      if any(ind1) | any(ind2)
        postnew = -1E6;
      else
        lnprionew  = priodens(paranew,pmean,pstdd,pshape2);

        likenew = 0; %% this is the dummy obs part
        [TTT,RRR,valid] = dsgesolv(paranew,mspec);
        if valid < 1;
          likenew = -10000; %% this is the dummy obs part
          
        else
          likenew = 0; %% this is the dummy obs part
          if ~isnan(nobsd)
            
            [yyyyd,xxyyd,xxxxd,retcode] = varprio_dmean(TTT,RRR,valid,paranew,nvar,nlagsc,mspec,npara,coint,cointadd,cointall);
            likenew = feval(strcat('objfcnmh',addc),paranew,YYYYd,XXYYd,XXXXd,nobsd,...
                            nlagsc,nvar,mspec,npara,trspec,pmean,pstdd,pshape2,yyyyd,xxyyd,xxxxd,retcode,para_mask2,coint,cointadd,cointall);
            
          end
        end

        postnew =  likenew + real(lnprionew);
      end

      
      propdens         = -0.5*sigpropdim*log(2*pi) - 0.5*sigproplndet - 0.5*sigpropdim*log(cc^2) ...
          -0.5*(paranew - paraold)'*sigpropinv*(paranew - paraold)/cc^2;
      
      r = min([1 ; exp( postnew - postold)]);      
      
      ra = rand(1,1);
      
      if ra  < r;
        % Accept proposed jump
        
        parasim = paranew;
        
        paraold = paranew;
        postold = postnew;
        likeold = likenew;
        
        if ~isnan(nobsd)
          yyyydold = yyyyd; 
          xxyydold = xxyyd; 
          xxxxdold = xxxxd;                                 
        end

        validold = valid;
        
        if (j/ntimes) == round(j/ntimes)
          parasimm(j/ntimes,:) = paranew(list_t2)';
          postsim(j/ntimes,1) = postnew;
        end      
      else;
        
        % Reject proposed jump
        parasim = paranew;
        
        reje = reje+1;
        rej = rej+1;
        
        if       postnew <= -1E6
          bds(1) = bds(1)+1;
        else
          bds(2) = bds(2)+1;
        end
        
        if ~isnan(nobsd)
          yyyyd = yyyydold; 
          xxyyd = xxyydold; 
          xxxxd = xxxxdold; 
        end
        
        valid = validold;
        
        if (j/ntimes) == round(j/ntimes)
          parasimm(j/ntimes,:) = paraold(list_t2)';
          postsim(j/ntimes,1) = postold;
        end
        
      end
      if Verbose
        fprintf(1,'\nBlock %2.2g of %2.2g',[iblock,nblocks]);
        fprintf(1,'\nSimulation step %2.0f of %2.0f',[j,nsim]);
        fprintf(1,'\nRejection r: %2.6f rej %2.2g perct %2.4f ',[r,reje/Tim]);
        %    fprintf(1,'\n Parameters: %2.6f',parasim(26:end));
        
      end                            
      
    end % end j=1:nsim  
    fprintf(1,'\n block rejection rate = %2.4f, overall rejection rate = %2.4f',[rej/j reje/Tim]);

    fwrite(fid1,parasimm','single');
    fwrite(fid4,postsim','single');
    
  end;    % end simulation - given lambda and time period
  fclose(fid1);
  fclose(fid4);
  toc
  fprintf(1,'rejection rate = %2.4f',reje/Tim);

end



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% Compute determinacy ratio for prio 2 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
DOD = 1%input('\n\n Compute determinacy ratio for prio 2');
if DOD
  nsimall = 2*nsim
  parasim2 = zeros(nsimall,npara2);
  
  for i0 = 1:npara2

    i = list_t2(i0);

    if pshape(i) == 1 %% BETA Prior  
      a = (1-pmean(i))*pmean(i)^2/pstdd(i)^2 - pmean(i);
      b = a*(1/pmean(i) - 1);
      parasim2(:,i0) = betarnd(a,b,nsimall,1);
      
    elseif pshape(i) == 2 %% GAMMA PRIOR  
      b = pstdd(i)^2/pmean(i);
      a = pmean(i)/b;
      parasim2(:,i0) = b*gamrnd(a,1,nsimall,1);

    elseif pshape(i) == 3 %% GAUSSIAN PRIOR  
      a = pmean(i);
      b = pstdd(i);
      parasim2(:,i0) = a + b*randn(nsimall,1);

    elseif pshape(i) == 4 %% INVGAMMA PRIOR  
      a = pmean(i);
      b = pstdd(i);
      parasim2(:,i0) = sqrt((b*a^2)./sum(randn(nsimall,b).^2,2));

    elseif pshape(i) == 5 %% uniform prior  
      a = pmean(i);
      b = pstdd(i);
      parasim2(:,i0) = a + (b-a)*rand(nsimall,1);

    elseif pshape(i) == 0 %% No Prior - Fixed  
      a = pmean(i);
      parasim2(:,i0) = a*ones(nsimall,1);

    end
    
  end
  

  parasim = zeros([nsimall,npara]);
  detsim      = zeros(nsimall,1);

  parasim(:,find(~para_mask2)) = parasim2;
  parasim(:,find(para_mask2)) = repmat(para_fix2(find(para_mask2))',[nsimall 1]);

  for j = 1:nsimall
    paradraw = parasim(j,:)';

    [TTT,RRR,valid] = dsgesolv(paradraw,mspec);

    if valid ~= 1 | any(isnan(TTT))
      %% indeterminacy or non-existence
      detsim(j) = 1;
      
    end

  end
  Indrat2 = length(find(detsim))/length(detsim);
  fprintf(1,'\n\n  ratio of indeterminacy draws %2.2f\n',Indrat2);
  
  %% determinacy ratio
  outfile212 =  strcat(spath,'/detrat2',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_);
  fid212 = fopen(outfile212,'w');		% output file (set to write)   
  fwrite(fid212,Indrat2,'single');
  fclose(fid212);
end 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

infile10 = strcat(spath,'/mhprioparat2',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_);
fid10 = fopen(infile10,'r');		% input file (set to read)   
num10 = nblocks*nsim*npara2*4;            % number of bites per file
numb10 = nburn*npara2*4;                  % number of bites to discard
status = fseek(fid10,numb10,'bof');       % discard nburn 

para2 = fread(fid10,[npara2,inf],'single')';
fclose(fid10);

ndraws = size(para2,1)

para2hat = mean(para2,1)';
para2sig = cov(para2,1);
para2bands = hpdint(para2,percent,1)';


%% save mean
outfile0 = strcat(spath,'/mhprioparat2',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_,'Mean')
fid0 = fopen(outfile0,'w');     % output file (set to write)   
fwrite(fid0,para2hat','single');
fclose(fid0);
 

outfile00 = strcat(fpath,lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_,'PrioMomt2.tex');		% output file name 
fid00 = fopen(outfile00,'w');		% output file (set to write)

fprintf(fid00,'\n \\documentclass[12pt]{article} \n \\usepackage[dvips]{color}\n ');
fprintf(fid00,'\n \\begin{document}');

fprintf(fid00,'\n \\documentclass{article}');
fprintf(fid00,'\n \\begin{document}');
fprintf(fid00,'\n \\setlength{\\tabcolsep}{.7mm}');


fprintf(1,'%4.99s  ','Mean');
for i0 = 1:npara2;
  i = list_t2(i0);
  fprintf(1,'\n %4.10s  ',para_names{i});
  fprintf(1,' %8.4f  ',para2hat(i0,:));
end    

outmat = [para2hat,sqrt(diag(para2sig)),para2bands];

fprintf(fid00,'\n');


colnames = {'Parameter' 'Support '  'Density '  'Prior Mean ' 'Prior Stdd ' strcat(num2str(100*percent),'\% LB') ...
            strcat(num2str(100*percent),'\% UB') };

[nrows,ncols] = size(outmat);

fprintf(fid00,'PARAMETERS \n $$');
fprintf(fid00,'\n \\vspace{.2cm} \n \\begin{array}{|@{\\hspace*{.5cm}} l @{\\hspace*{.5cm}}|@{\\hspace*{-.2cm}}c@{\\hspace*{-.2cm}}|@{\\hspace*{-.2cm}}c@{\\hspace*{-.2cm}}|');
FORMAT = '  ';
for j = 1:ncols
  fprintf(fid00,' @{\\hspace*{.5cm}} c'); 
  if j == 1
    FORMAT = strcat(FORMAT,' &  %8.3f  '); 
    % elseif (j == ncols) | (j == (ncols-1))
    %	FORMAT = strcat(FORMAT,' & \\mbox{{\\scriptsize $%8.3f$ }} '); 
  else
    FORMAT = strcat(FORMAT,' & %8.3f '); 
  end

end

fprintf(fid00,'|}\\hline');
FORMAT = strcat(FORMAT,' \\\\');  

fprintf(fid00,'\n  ');
fprintf(fid00,' %4.99s  & ',colnames{:});		
fprintf(fid00,'	\\\\ \\hline '); 

for i0 = 1:nrows
  i = list_t2(i0);
  fprintf(fid00,'\n %4.99s & ',para_names{i});
  if pshape2(i) == 1
    fprintf(fid00,'[0,1) & \\mbox{Beta} ');	
  elseif pshape2(i) == 2
    fprintf(fid00,'R^{+} & \\mbox{Gamma} ');	
  elseif pshape2(i) == 3
    fprintf(fid00,' R & \\mbox{\\cal N} ');	
  elseif pshape2(i) == 4
    fprintf(fid00,'R^{+} & \\mbox{InvGamma} ');	
  elseif pshape2(i) == 0
    fprintf(fid00,' &  ');	    
  end
  fprintf(fid00,FORMAT,outmat(i0,:));

end   
fprintf(fid00,' \\hline');
fprintf(fid00,'\n \\end{array} $$');        
fprintf(fid00,'\n \\end{document}');


fclose(fid00);		% close output file

exit;
