close all;
clear all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% PRELIMINARY STUFF
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
run startdsswfed;
!hostname;
!ps -C matlab;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%      paths & parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
chdata = choosedata;
[mspec,mprior,dataset,dates,nvar,nlags,T0,Tend,npara,lambdaseq,para_names,bounds,para, ...
 varnames,cum_for,polipar,polivalue,cum_irf,names_shocks,fixparamseq,coint,cointadd,cointall,cointvec,cointaddvec,JustMode, ...
 stime,st,nblocks,nsim,nburn,qahead,para_mask,para_fix,para_aux,mspec_ref,nobsdrat,lambdac,nlagsc,diago] = varspec(chdata);

[fpath,spath,gpath] = pathspec(num2str(floor(dataset)),chdata);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%*
% Load information for prior distribution

lprior    = num2str(mprior);
lmodel    = strcat('m',num2str(mspec));
priorfile = strcat(lmodel,lprior,'pri');
prior = feval(priorfile);

pmean  = prior(1:npara,1);
pstdd  = prior(1:npara,2);
pshape = prior(1:npara,3);

pshape = pshape.*(1-para_mask);


nonpolipar = [1:1:npara];
nonpolipar(polipar) = [];

% Load transformation scheme for parameters
trspec = feval('transp',mspec);

trspec(:,1) = trspec(:,1).*(1-para_mask);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% load data
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[YYall,XXall,ti,nobsall] = loaddata(dataset,fpath,T0,Tend,coint,cointadd,cointall,nvar,nlags,chdata,mspec);

dataset = num2str(10*dataset);

ICUM = find(cum_for);
INCUM = find(cum_for == 0);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Set parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% set date
I = find(ti == dates);

Verbose = 0;

fixparam = fixparamseq(1);
if fixparam ~= 0 
    fixparam
    break
end

percent = .90;


mspecno = [1 2 3 4 5 6];
mspeclist = [106,106,104,113,105,101];
mspec_ref_list = cell(length(mspeclist),1);
mspec_ref_list(1) = {[]};
mspec_ref_list(2) = {[NaN]};
mspec_ref_list(3) = {[NaN]};
mspec_ref_list(4) = {[NaN]};
mspec_ref_list(5) = {[NaN]};
mspec_ref_list(6) = {[NaN]};

nobsdrat_list = cell(length(mspeclist),1);
nobsdrat_list(1) = {[10/100]};
nobsdrat_list(2) = {[10/100]};
nobsdrat_list(3) = {[10/100]};
nobsdrat_list(4) = {[10/100]};
nobsdrat_list(5) = {[10/100]};
nobsdrat_list(6) = {[10/100]};

lambdac_list = cell(length(mspeclist),1);
lambdac_list(1) = {[Inf]};
lambdac_list(2) = {[Inf]};
lambdac_list(3) = {[Inf]};
lambdac_list(4) = {[Inf]};
lambdac_list(5) = {[Inf]};
lambdac_list(6) = {[Inf]};

nlagsc_list = cell(length(mspeclist),1);
nlagsc_list(1) = {[1]};
nlagsc_list(2) = {[1]};
nlagsc_list(3) = {[1]};
nlagsc_list(4) = {[1]};
nlagsc_list(5) = {[1]};
nlagsc_list(6) = {[1]};

diago_list = cell(length(mspeclist),1);
diago_list(1) = {[0]};
diago_list(2) = {[0]};
diago_list(3) = {[0]};
diago_list(4) = {[0]};
diago_list(5) = {[0]};
diago_list(6) = {[0]};

mprior_list = cell(length(mspeclist),1);
mprior_list(1) = {[1]};
mprior_list(2) = {[1]};
mprior_list(3) = {[1]};
mprior_list(4) = {[1]};
mprior_list(5) = {[1]};
mprior_list(6) = {[1]};

%% if = 1 use prior, = 0 use posterior
mPostPrio_list = cell(length(mspeclist),1);
mPostPrio_list(1) = {[1]};
mPostPrio_list(2) = {[1]};
mPostPrio_list(3) = {[1]};
mPostPrio_list(4) = {[1]};
mPostPrio_list(5) = {[1]};
mPostPrio_list(6) = {[1]};

allmodelnames = cell(20,1);
allmodelnames(1) = {'No Dynamic Indexation'};
allmodelnames(6) = {'Baseline'};
allmodelnames(4) = {'Flex Wages and  Prices'};
allmodelnames(5) = {'Flex Wages'};
allmodelnames(7) = {'Full Indexation'};
allmodelnames(8) = {'No Habit'};
allmodelnames(9) = {'No Investment Adj. Costs'};
allmodelnames(10) = {'No Capital Adj. Costs'};
allmodelnames(11) = {'No Wage Stickiness and No Indexation'};
allmodelnames(12) = {'Uncorrelated Mark-up Shocks'};
allmodelnames(13) = {'Flex Prices'};
allmodelnames(14) = {'Uncorrelated Mark-up Shocks and No Indexation'};


modelnames = cell(length(mspeclist),1);
for ii = 1:length(mspeclist)
  modelnames{ii} = {allmodelnames{mspeclist(ii)-100}};
end

modls = 'm';
for ispec = mspecno 
  mspec = mspeclist(ispec);
  modls = strcat(modls,num2str(mspec));
  modls = strcat(modls,num2str(mprior_list{ispec}));  
  if ~isempty(mspec_ref_list{ispec})
    modls = strcat(modls,'-',num2str(mspec_ref_list{ispec}));
    modls = strcat(modls,'nobsd',num2str(100*nobsdrat_list{ispec}));
    if ~isinf(lambdac_list{ispec})
      modls = strcat(modls,'lam',num2str(lambdac_list{ispec}));
    end  
    modls = strcat(modls,'l',num2str(nlagsc_list{ispec}));
    if diago_list{ispec}
      modls = strcat(modls,'d',num2str(diago_list{ispec}));
    end
  end    
  if mPostPrio_list{ispec} == 1 %% use prior
      modls = strcat(modls,'Prio');
  else
      modls = strcat(modls,'Post');
  end

  modls = strcat(modls,'---');  
end

Acolor = zeros(length(mspeclist),3);
Fcolor = zeros(length(mspeclist),3);
Lstyle = cell(length(mspeclist),1);
Mstyle = cell(length(mspeclist),1);
Lstyle(1) = {'-'};
Mstyle(1) = {'+'};
Fcolor(1,:) = [.2 .2 .2];
Acolor(2,:) = [0 .2 .2];
Fcolor(2,:) = [.5 .5 .5];
Lstyle(2) = {'--'};
Mstyle(2) = {'^'};
Acolor(3,:) = [0 .5 .5];
Fcolor(3,:) = [.9 .9 .9];
Lstyle(3) = {'-.'};
Mstyle(3) = {'o'};


outfile00 = strcat(fpath,modls,'-',num2str(JustMode),'PostMoms.tex');		% output file name 
fid00 = fopen(outfile00,'w')		% output file (set to write)
fprintf(fid00,'\n \\documentclass[12pt]{article} \n \\usepackage[dvips]{color}\n ');
fprintf(fid00,'\n \\begin{document}');


Theta1 = [];
Theta2 = [];

for ispec = mspecno 
  mspec = mspeclist(ispec)
  lmodel    = strcat('m',num2str(mspec));

  mprior = mprior_list{ispec}
  lprior    = num2str(mprior);
  
  mspec_ref = mspec_ref_list{ispec}
  nobsdrat = nobsdrat_list{ispec}
  lambdac = lambdac_list{ispec}
  nlagsc = nlagsc_list{ispec}
  diago = diago_list{ispec}
  if isempty(mspec_ref)
    lmodel_ref = [];
    nobsdrat_ = [];
    lambdac_ = [];
    nlagsc_ = [];
    diago_ = [];
  
  lprior    = num2str(2);
  
  else
    lmodel_ref = strcat('m',num2str(mspec_ref));
    nobsdrat_ = num2str(100*nobsdrat);
    if isinf(lambdac)
      lambdac_ = [];
    else
      lambdac_ = num2str(100*lambdac);
    end
    if nlagsc == 4
      nlagsc_ = [];
    else
      nlagsc_ = num2str(nlagsc);
    end  
    if ~diago
      diago_ = [];
    else
      diago_ = num2str(diago);
    end
  
  lprior    = num2str(1);
  
  end
  lambdas = lambdaseq
	if isnan(lambdas)
		coint0 = coint;
	else
		coint0 = cointall;
	end
        
  if mPostPrio_list{ispec} == 1 %% use prior

    if isempty(mspec_ref)

      %% w/o correcting model - already discarded nburns
      infile1 = strcat(spath,'/mhNIpriopara',lmodel,lprior,dataset,lmodel_ref,nobsdrat_,lambdac_,nlagsc_,diago_)
      fid1 = fopen(infile1,'r');		% input file (set to read)   
      theta = fread(fid1,[npara,inf],'single')';
      fclose(fid1);

      infile2 = strcat(spath,'/priodet',lmodel,lprior,dataset);
      fid2 = fopen(infile2,'r');		% input file (set to read)   
      detsim = fread(fid2,[1,inf],'int8')';
      fclose(fid2);

      %% discard indeterminacy
      ndraws = size(theta,1)
      theta(find(detsim),:) = [];
      fprintf(1,'\n\n  ratio of determinacy draws %2.2f\n',size(para,1)/ndraws);
      ndraws = size(para,1)


    else
      %% w/ correcting model -  have to  discard nburns
      
      infile1 = strcat(spath,'/mhNIpriopara',lmodel,lprior,dataset,lmodel_ref,nobsdrat_,lambdac_,nlagsc_,diago_)
      fid1 = fopen(infile1,'r');		% input file (set to read)   
      numb1 = nburn*npara*4;                  % number of bites to discard
      status = fseek(fid1,numb1,'bof');       % discard nburn 
      theta = fread(fid1,[npara,inf],'single')';
      fclose(fid1);

      
      ndraws = size(para,1)


    end
    
  elseif mPostPrio_list{ispec} == 0 %% use posterior
        
	infile1 = strcat(spath,'/mhpara',lmodel,lprior,dataset,lmodel_ref,nobsdrat_,lambdac_,nlagsc_,diago_,num2str(coint0),st,num2str(100*lambdas),num2str(100*ti(I)),num2str(nlags),num2str(fixparam),num2str(JustMode));		
	num1 = nblocks*nsim*npara*4;            % number of bites per file
	numb1 = nburn*npara*4;                  % number of bites to dicard
	
    fid1 = fopen(infile1,'r');		% input file (set to read)   
    numb1 = nburn*npara*4;                  % number of bites to discard
    status = fseek(fid1,numb1,'bof');       % discard nburn 
    theta = fread(fid1,[npara,inf],'single')';
    fclose(fid1);

    
    ndraws = size(para,1)
  end
	
	%%%%%%%%%%% Compute posterior moments of the parameters
	thetahat = mean(theta,1)';
	thetasig = cov(theta,1);
        thetastd = sqrt(diag(thetasig));

	thetabands = hpdint(theta,percent,1)';

        %% save the mean
        outfile0 = strcat(spath,lmodel,lprior,'para',num2str(coint0),st,num2str(100*lambdas),num2str(100*ti(I)),num2str(nlags),'Mean');

        fid0 = fopen(outfile0,'w');     % output file (set to write)   
        fwrite(fid0,thetahat','single');
        fclose(fid0);
        
	colnames = {'Parameter ' 'Prior Mean '  'Prior Stdd '  'Post Mean ' strcat(num2str(100*percent),'\% {\tiny Lower Band}') ...
                    strcat(num2str(100*percent),'\% {\tiny Upper Band}') };
	outmat = [pmean,pstdd,thetahat,thetabands];

	Theta1 = [Theta1,thetahat];
	%Theta2 = [Theta2,thetahat,thetabands];
	Theta2 = [Theta2,thetahat,thetastd];

	
	fprintf(1,'\n');
	fprintf(1,'%4.99s  ',colnames{:});
	for i = 1:length(para_names)
		fprintf(1,'\n $%4.99s$ & ',para_names{i});
		fprintf(1,' %8.3f & ',outmat(i,:));
	end    
	

	fprintf(fid00,'\n \\begin{table}[h] \\centering');        
	fprintf(fid00,'\n \\caption{Parameter Estimates, $\\lambda$ = %2.1f } \n\\vspace*{.5cm}',lambdas);
	fprintf(fid00,'\n \\begin{tabular}{lllllll}\\hline \n');

	fprintf(fid00,' %4.99s  & ',colnames{:});
	for i = 1:length(para_names)
		fprintf(fid00,'\\\\ \n $%4.99s$ &  ',para_names{i});
		fprintf(fid00,' %8.3f & ',outmat(i,:));
	end   
	fprintf(fid00,'\\\\  \\hline');		    
        fprintf(fid00,'\n \\end{tabular}');
	fprintf(fid00,'\n \\end{table} \n\n');
	
	clear parasimm postsim;

	
  
end


fprintf(1,'\n');



fprintf(fid00,'\n \\begin{table}[h] \\centering');        
fprintf(fid00,'\n \\caption{Parameter Estimates: Posterior Mean} \n\\vspace*{.5cm}',lambdas);
fprintf(fid00,'\n \\begin{tabular}{c@{\\hspace*{.05cm}}');
for ispec = mspecno 
	fprintf(fid00,'ll@{\\hspace*{.5cm}}');
end
fprintf(fid00,'}\\hline \n');
fprintf(fid00,' Paramter  ');
for ispec = mspecno 
  mspec = mspeclist(ispec);
fprintf(fid00,' &  \\multicolumn{2}{c}{%9.99s} ',char(modelnames{ispec}));
end
fprintf(fid00,'\\\\ \\hline \n');

for i = 1:length(para_names)
  fprintf(fid00,' \n $%4.99s$   ',para_names{i});
  L =1;
  for ispec = mspecno 

    fprintf(fid00,' & %8.3f & (%8.3f) ',Theta2(i,L:L+1));
        L=L+2;
  end
  fprintf(fid00,'\\\\ ');
end   
fprintf(fid00,'\\\\  \\hline');		    
fprintf(fid00,'\n \\end{tabular}');
fprintf(fid00,'\n \\end{table} \n\n');


fprintf(fid00,'\n \\end{document}');

fclose(fid00);		% close output file


return
