function obj = objfcn(para,YYYY,XXYY,XXXX,nobs,lambda,nlags,nvar,mspec,...
         npara,trspec,pmean,pstdd,pshape,para_mask,para_fix,marglh,coint,cointadd,cointall,mspec_ref,params_1bar,YYYYd,XXYYd,XXXXd,nobsd,para_aux,lambdac,nlagsc,addc,bounds,MIN);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% obj evaluates the log  posterior = log likelihood + log prior
%% MIN takes into account that csminwel minimizes as opposed to max, and that the parameters are rescaled
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% likelihood 
if MIN
    para = trans(para,trspec);
end
para = para.*(1-para_mask)+para_fix.*para_mask;

% Evaluate the Prior distribution

if isempty(mspec_ref)
  lnprio  = priodens(para,pmean,pstdd,pshape);
elseif ~isempty(mspec_ref)
  %% Fix non-auxiliary parameters
  para_ = para.*para_aux+params_1bar.*(1-para_aux);
  [TTT_,RRR_,valid_] = dsgesolv(para_,mspec);

  [yyyyd_,xxyyd_,xxxxd_,retcode] = varprio_dmean(TTT_,RRR_,valid_,para_,nvar,nlagsc,mspec,npara,coint,cointadd,cointall);
  [lnprio,likenew_] = feval('objfcnmhinf',para,bounds,YYYYd,XXYYd,XXXXd,nobsd,lambda,...
                            nlagsc,nvar,mspec,npara,trspec,pmean,pstdd,pshape,yyyyd_,xxyyd_,xxxxd_,retcode,para_mask,coint,cointadd,cointall);
end

lnpy = feval(marglh,para,YYYY,XXYY,XXXX,nobs,lambda,nlags,nvar,mspec,npara,coint,cointadd,cointall);

if MIN 
    obj = real(-lnpy-lnprio);  % We minize the inverse of the likelihood fcn 
else 
    obj = real(lnpy+lnprio);  
end

