function obj = objfcndsge(para,YY,YY0,nobs,lambda,nlags,nvar,mspec,npara,trspec,pmean,pstdd,pshape,para_mask,...
  para_fix,marglh,coint,cointadd,cointall,YYcoint0,mspec_ref,YYYYd,XXYYd,XXXXd,nobsd,nlagsc,bounds,MIN);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% obj evaluates the log  posterior = log likelihood + log prior
%% MIN takes into account that csminwel minimizes as opposed to max, and that the parameters are rescaled
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% likelihood 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if MIN
  para = trans(para,trspec);
end
para = para.*(1-para_mask(:,end))+para_fix(:,end).*para_mask(:,end);

lnpy = dsgelh(para,YY,YY0,nobs,nlags,nvar,mspec,npara,coint,cointadd,YYcoint0);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Evaluate the Prior distribution
%%% type 0 parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
lnprio0 = 0;
if any(pshape(:,1))
  %% this line is redundant
  para0 = para.*(1-para_mask(:,1))+para_fix(:,1).*para_mask(:,1);

  lnprio0 = priodens(para0,pmean,pstdd,pshape(:,1));

  %% moments from data
  stmoms;
  
  %% computes moments from model
  M_vec = getparaM(para0,mspec);
  lnprioM = - sum( ( (M_vec-M_mean).^2 )./M_var );
  
  lnprio0 = lnprioM+lnprio0;
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Evaluate the Prior distribution
%%% type 1 parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
lnprio1 = 0;
if any(pshape(:,2))
  %% this line is redundant
  para1 = para.*(1-para_mask(:,2))+para_fix(:,2).*para_mask(:,2);
  lnprio1 = priodens(para1,pmean,pstdd,pshape(:,2));
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Evaluate the Prior distribution
%%% type 2 parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
lnprio2 = 0;
if any(pshape(:,3))
  para2 = para.*(1-para_mask(:,3))+para_fix(:,3).*para_mask(:,3);

  lnprio2 = priodens(para2,pmean,pstdd,pshape(:,3));

  lnprioD = 0;
  if ~isempty(mspec_ref)

    %% Solve the model and evaluate the (dummy) likelihood
    [TTT,RRR,valid] = dsgesolv(para2,mspec);
    [yyyyd,xxyyd,xxxxd,retcode] = varprio_dmean(TTT,RRR,valid,para2,nvar,nlagsc,mspec,npara,coint,cointadd,cointall);
    lnprioD = feval('objfcnmhinf',para2,YYYYd,XXYYd,XXXXd,nobsd,...
                    nlagsc,nvar,mspec,npara,trspec,pmean,pstdd,pshape(:,3),yyyyd,xxyyd,xxxxd,retcode,para_mask(:,3),coint,cointadd,cointall);
  end
  lnprio2 = lnprioD+lnprio2;
end

if MIN 
  obj = real(-lnpy-lnprio0-lnprio1-lnprio2);  % We minize the inverse of the likelihood fcn 
else 
  obj = real(lnpy+lnprio0+lnprio1+lnprio2);  
end


  
