function [lnpost,lnpy] = objfcnmhinfdiag(para,bounds,yyyy,xxyy,xxxx,nobs,lambda,nlags,nvar,mspec,npara,trspec,pmean,pstdd,pshape,yyyyd,xxyyd,xxxxd,retcode,para_mask,coint,cointadd,cointall);

ind1 = (para > bounds(:,2));
ind1(find(para_mask)) = [];
ind2 = (para < bounds(:,1));
ind2(find(para_mask)) = [];


if any(ind1) | any(ind2)

	lnpost = -1E6;
	lnpy   = -1E20;

else
    if retcode == 0
	    % inderterminacy
	    lnpy = -1E10;
	else
          
          % remove cointadd component
          xxxxd = xxxxd(1+cointadd:end,1+cointadd:end);
          xxxx  = xxxx(1+cointadd:end,1+cointadd:end);
          
          xxyyd = xxyyd(1+cointadd:end,:);
          xxyy  = xxyy(1+cointadd:end,:);
          
          lnpy = 0;
          for i_var = 1:nvar
            
            % evaluate restricted GAUSSIAN likelihood
            phis = xxyyd(i_var,i_var)/xxxxd(i_var,i_var);
            sigs = yyyyd(i_var,i_var) -xxyyd(i_var,i_var)*phis;

            lnpy = lnpy -(1*(nobs)/2)*log(2*pi)-(nobs/2)*log(det(sigs)) ...
                   -.5*( sigs \ (yyyy(i_var,i_var)-phis'*xxyy(i_var,i_var)-xxyy(i_var,i_var)'*phis+phis'*xxxx(i_var,i_var)*phis) );

          end
    		
	end;

	lnpy    = real(lnpy);
	lnprio  = priodens(para,pmean,pstdd,pshape);
	lnpost  = lnpy + real(lnprio);
end

