function obj = objfcnpriostst(para,mspec,npara,trspec,pmean,pstdd,pshape,para_mask,para_fix,MIN);
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %% obj evaluates the log  posterior = log likelihood + log prior
  %% MIN takes into account that csminwel minimizes as opposed to max, and that the parameters are rescaled
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  %% likelihood 
  if MIN
    para = trans(para,trspec);
  end
  para = para.*(1-para_mask)+para_fix.*para_mask;

  %% Evaluate the Prior distribution
  lnprio = priodens(para,pmean,pstdd,pshape);


  %% moments from data
  stmoms;
  
  %% computes moments from model
  M_vec = getparaM(para,mspec);
  lnprioM = - sum( ( (M_vec-M_mean).^2 )./M_var );
 
  
  
  

  if MIN 
    obj = real(-lnprio-lnprioM);  % We minize the inverse of the likelihood fcn 
  else 
    obj = real(lnprio+lnprioM);  
  end
