varspec;

[fpath,spath,gpath] = pathspec(num2str(floor(dataset)));
  
%%%% presample
nlagsc2 = 1;
T0_p = nlagsc2;
[YYall_p,XXall_p,ti_p,nobsall_p] = loaddata(dataset,fpath,T0_p,Tend,coint,cointadd,cointall,nvar,nlagsc2,mspec);
I_p = find(ti_p == dates);
dataset = num2str(10*dataset);


%%%% presample
YY_p = YYall_p(1:I_p-stime,:);
XX_p = XXall_p(1:I_p-stime,:);             
nobs_p = size(YY_p,1);

MeY_p = mean(YY_p,1)';
VaY_p = cov(YY_p,1);
stdY_p = sqrt(diag(VaY_p));
CorY_p = VaY_p./(stdY_p*stdY_p');
ACorY_p = zeros(nvar,1);
for ii = 1:nvar;
  ACorY_p(ii) = corr(YY_p(:,ii),XX_p(:,1+cointall+ii));
end

stats_p = [MeY_p' stdY_p' ACorY_p' CorY_p(:)'];

%%%% first presample
YY_p1 = YYall_p(1:round((I_p-stime)/2),:);
XX_p1 = XXall_p(1:round((I_p-stime)/2),:);
nobs_p1 = size(YY_p1,1);

MeY_p1 = mean(YY_p1,1)';
VaY_p1 = cov(YY_p1,1);
stdY_p1 = sqrt(diag(VaY_p1));
CorY_p1 = VaY_p1./(stdY_p1*stdY_p1');
ACorY_p1 = zeros(nvar,1);
for ii = 1:nvar;
  ACorY_p1(ii) = corr(YY_p1(:,ii),XX_p1(:,1+cointall+ii));
end

stats_p1 = [MeY_p1' stdY_p1' ACorY_p1' CorY_p1(:)'];

%%%% second presample
YY_p2 = YYall_p(round((I_p-stime)/2)+1:I_p-stime,:);
XX_p2 = XXall_p(round((I_p-stime)/2)+1:I_p-stime,:);
nobs_p2 = size(YY_p2,1);

MeY_p2 = mean(YY_p2,1)';
VaY_p2 = cov(YY_p2,1);
stdY_p2 = sqrt(diag(VaY_p2));
CorY_p2 = VaY_p2./(stdY_p2*stdY_p2');
ACorY_p2 = zeros(nvar,1);
for ii = 1:nvar;
  ACorY_p2(ii) = corr(YY_p2(:,ii),XX_p2(:,1+cointall+ii));
end

stats_p2 = [MeY_p2' stdY_p2' ACorY_p2' CorY_p2(:)'];

D_p = zeros(2,nobs_p);
D_p(1,1:round((I_p-stime)/2)) = 1;
D_p(2,round((I_p-stime)/2)+1:I_p-stime) = 1;

%% 40 quarters window
stats_all = zeros(nobs_p-40,length(stats_p));
for i = 1:(nobs_p-40)
  YY_w = YY_p(i:i+40,:);
  XX_w = XX_p(i:i+40,:);
  
MeY_w = mean(YY_w,1)';
VaY_w = cov(YY_w,1);
stdY_w = sqrt(diag(VaY_w));
CorY_w = VaY_w./(stdY_w*stdY_w');
ACorY_w = zeros(nvar,1);
for ii = 1:nvar;
  ACorY_w(ii) = corr(YY_w(:,ii),XX_w(:,1+cointall+ii));
end

stats_all(i,:) = [MeY_w' stdY_w' ACorY_w' CorY_w(:)']';
end

D_p(~D_p) = NaN;
D_p = D_p(:,1:nobs_p-40);
tg = 'GDP Std';
figure(1)
        P1 = line(ti_p(1:nobs_p-40),stats_all(:,nvar+1));
        set(P1,'Color',[0 0 0],'LineStyle','-');
        P2 = line(ti_p(1:nobs_p-40),stats_p(nvar+1)*ones(nobs_p-40)); 
        set(P2,'Color',[1 .3 .3],'LineStyle','-.');
        P3 = line(ti_p(1:nobs_p-40),D_p(1,:)'*stats_p1(nvar+1)); 
        set(P3,'Color',[.3 .3 1],'LineStyle','--');
        P3 = line(ti_p(1:nobs_p-40),D_p(2,:)'*stats_p2(nvar+1)); 
        set(P3,'Color',[.3 .3 1],'LineStyle','--');
        title(tg);                      
figure(1)
        print(char(strcat(gpath,tg,'.eps')),'-depsc');
close(figure(1))


figure(1)
tg = 'H Std';
        P1 = line(ti_p(1:nobs_p-40),stats_all(:,nvar+2));
        set(P1,'Color',[0 0 0],'LineStyle','-');
        P2 = line(ti_p(1:nobs_p-40),(stats_p(nvar+2))*ones(nobs_p-40)); 
        set(P2,'Color',[1 .3 .3],'LineStyle','-');
        P3 = line(ti_p(1:nobs_p-40),D_p(1,:)'*stats_p1(nvar+2)); 
        set(P3,'Color',[.3 .3 1],'LineStyle','--');
        P3 = line(ti_p(1:nobs_p-40),D_p(2,:)'*stats_p2(nvar+2)); 
        set(P3,'Color',[.3 .3 1],'LineStyle','--');
        title(tg);                      
        print(char(strcat(gpath,tg,'.eps')),'-depsc');
close(figure(1))
        

figure(1)
tg = 'Ls Std';
        P1 = line(ti_p(1:nobs_p-40),stats_all(:,nvar+3));
        set(P1,'Color',[0 0 0],'LineStyle','-');
        P2 = line(ti_p(1:nobs_p-40),(stats_p(nvar+3))*ones(nobs_p-40)); 
        set(P2,'Color',[1 .3 .3],'LineStyle','-');
        P3 = line(ti_p(1:nobs_p-40),D_p(1,:)'*stats_p1(nvar+3)); 
        set(P3,'Color',[.3 .3 1],'LineStyle','--');
        P3 = line(ti_p(1:nobs_p-40),D_p(2,:)'*stats_p2(nvar+3)); 
        set(P3,'Color',[.3 .3 1],'LineStyle','--');
        
        title(tg);                      
        print(char(strcat(gpath,tg,'.eps')),'-depsc');
close(figure(1))

figure(1)
tg = 'Inf Std';
        P1 = line(ti_p(1:nobs_p-40),stats_all(:,nvar+4));
        set(P1,'Color',[0 0 0],'LineStyle','-');
        P2 = line(ti_p(1:nobs_p-40),(stats_p(nvar+4))*ones(nobs_p-40)); 
        set(P2,'Color',[1 .3 .3],'LineStyle','-');
        P3 = line(ti_p(1:nobs_p-40),D_p(1,:)'*stats_p1(nvar+4)); 
        set(P3,'Color',[.3 .3 1],'LineStyle','--');
        P3 = line(ti_p(1:nobs_p-40),D_p(2,:)'*stats_p2(nvar+4)); 
        set(P3,'Color',[.3 .3 1],'LineStyle','--');
        
        title(tg);                      
        print(char(strcat(gpath,tg,'.eps')),'-depsc');
close(figure(1))

figure(1)
tg = 'R Std';
        P1 = line(ti_p(1:nobs_p-40),stats_all(:,nvar+5));
        set(P1,'Color',[0 0 0],'LineStyle','-');
        P2 = line(ti_p(1:nobs_p-40),(stats_p(nvar+5))*ones(nobs_p-40)); 
        set(P2,'Color',[1 .3 .3],'LineStyle','-');
        P3 = line(ti_p(1:nobs_p-40),D_p(1,:)'*stats_p1(nvar+5)); 
        set(P3,'Color',[.3 .3 1],'LineStyle','--');
        P3 = line(ti_p(1:nobs_p-40),D_p(2,:)'*stats_p2(nvar+5)); 
        set(P3,'Color',[.3 .3 1],'LineStyle','--');
        
        title(tg);                      
        print(char(strcat(gpath,tg,'.eps')),'-depsc');
close(figure(1))

tg = 'GDP AutoCor';
figure(1)
        P1 = line(ti_p(1:nobs_p-40),stats_all(:,2*nvar+1));
        set(P1,'Color',[0 0 0],'LineStyle','-');
        P2 = line(ti_p(1:nobs_p-40),stats_p(2*nvar+1)*ones(nobs_p-40)); 
        set(P2,'Color',[1 .3 .3],'LineStyle','-');
        P3 = line(ti_p(1:nobs_p-40),D_p(1,:)'*stats_p1(2*nvar+1)); 
        set(P3,'Color',[.3 .3 1],'LineStyle','--');
        P3 = line(ti_p(1:nobs_p-40),D_p(2,:)'*stats_p2(2*nvar+1)); 
        set(P3,'Color',[.3 .3 1],'LineStyle','--');
        
        title(tg);                      
figure(1)
        print(char(strcat(gpath,tg,'.eps')),'-depsc');
close(figure(1))

figure(1)
tg = 'H AutoCor';
        P1 = line(ti_p(1:nobs_p-40),stats_all(:,2*nvar+2));
        set(P1,'Color',[0 0 0],'LineStyle','-');
        P2 = line(ti_p(1:nobs_p-40),(stats_p(2*nvar+2))*ones(nobs_p-40)); 
        set(P2,'Color',[1 .3 .3],'LineStyle','-');
        P3 = line(ti_p(1:nobs_p-40),D_p(1,:)'*stats_p1(2*nvar+2)); 
        set(P3,'Color',[.3 .3 1],'LineStyle','--');
        P3 = line(ti_p(1:nobs_p-40),D_p(2,:)'*stats_p2(2*nvar+2)); 
        set(P3,'Color',[.3 .3 1],'LineStyle','--');
        title(tg);                      
        print(char(strcat(gpath,tg,'.eps')),'-depsc');
close(figure(1))
        

figure(1)
tg = 'Ls AutoCor';
        P1 = line(ti_p(1:nobs_p-40),stats_all(:,2*nvar+3));
        set(P1,'Color',[0 0 0],'LineStyle','-');
        P2 = line(ti_p(1:nobs_p-40),(stats_p(2*nvar+3))*ones(nobs_p-40)); 
        set(P2,'Color',[1 .3 .3],'LineStyle','-');
        P3 = line(ti_p(1:nobs_p-40),D_p(1,:)'*stats_p1(2*nvar+3)); 
        set(P3,'Color',[.3 .3 1],'LineStyle','--');
        P3 = line(ti_p(1:nobs_p-40),D_p(2,:)'*stats_p2(2*nvar+3)); 
        set(P3,'Color',[.3 .3 1],'LineStyle','--');
        title(tg);                      
        print(char(strcat(gpath,tg,'.eps')),'-depsc');
close(figure(1))

figure(1)
tg = 'Inf AutoCor';
        P1 = line(ti_p(1:nobs_p-40),stats_all(:,2*nvar+4));
        set(P1,'Color',[0 0 0],'LineStyle','-');
        P2 = line(ti_p(1:nobs_p-40),(stats_p(2*nvar+4))*ones(nobs_p-40)); 
        set(P2,'Color',[1 .3 .3],'LineStyle','-');
        P3 = line(ti_p(1:nobs_p-40),D_p(1,:)'*stats_p1(2*nvar+4)); 
        set(P3,'Color',[.3 .3 1],'LineStyle','--');
        P3 = line(ti_p(1:nobs_p-40),D_p(2,:)'*stats_p2(2*nvar+4)); 
        set(P3,'Color',[.3 .3 1],'LineStyle','--');
        title(tg);                      
        print(char(strcat(gpath,tg,'.eps')),'-depsc');
close(figure(1))

figure(1)
tg = 'R AutoCor';
        P1 = line(ti_p(1:nobs_p-40),stats_all(:,2*nvar+5));
        set(P1,'Color',[0 0 0],'LineStyle','-');
        P2 = line(ti_p(1:nobs_p-40),(stats_p(2*nvar+5))*ones(nobs_p-40)); 
        set(P2,'Color',[1 .3 .3],'LineStyle','-');
        P3 = line(ti_p(1:nobs_p-40),D_p(1,:)'*stats_p1(2*nvar+5)); 
        set(P3,'Color',[.3 .3 1],'LineStyle','--');
        P3 = line(ti_p(1:nobs_p-40),D_p(2,:)'*stats_p2(2*nvar+5)); 
        set(P3,'Color',[.3 .3 1],'LineStyle','--');
        title(tg);                      
        print(char(strcat(gpath,tg,'.eps')),'-depsc');
close(figure(1))
