close all;
clear all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% PRELIMINARY STUFF
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

run startdsswfed;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%      paths & parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
chdata = choosedata;
[mspec,mprior,dataset,dates,nvar,nlags,T0,Tend,npara,lambdaseq,para_names,bounds,para, ...
 varnames,cum_for,polipar,polivalue,cum_irf,names_shocks,fixparamseq,coint,cointadd,cointall,cointvec,cointaddvec,JustMode, ...
 stime,st,nblocks,nsim,nburn,qahead,para_mask,para_fix,para_aux,mspec_ref] = varspec(chdata);


%[fpath,spath,gpath] = pathspecmh(num2str(floor(dataset)),chdata,coint);
[fpath,spath,gpath] = pathspec(num2str(floor(dataset)),chdata);




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% do Lambda loop
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


tirf = (-3:.01:3)';
centr = .7;
centr2 = 1.3;

nprior = 2;
Mh = zeros(length(tirf),nprior+1);

Mh(:,1) = normpdf(tirf,0,1);
Mh(:,2) = normpdf(tirf,centr,.2);
Mh(:,3) = normpdf(tirf,centr2,.5);

%Mh(:,4) = normpdf(tirf,centr,.5);
%Mh(:,5) = normpdf(tirf,centr,2);


Mh(:,1) = .8*max(max(Mh(:,2:end)))*Mh(:,1)/max(max(Mh(:,1)));


Acolor = zeros(size(Mh,2),3);
Lstyle = cell(size(Mh,2),1);
Mstyle = cell(size(Mh,2),1);
Lstyle(1) = {'-'};
Mstyle(1) = {'x'};

%Lstyle(end) = {'-'};
%Mstyle(end) = {'x'};


Yl = [0,1.05*max(max(Mh))];

figure(101);
%P = plot([centr,centr],Yl,'r-');
%set(P,'LineWidth',2);
%T =text(centr,-.1,'\Phi^*');
%set(T,'VerticalAlignment','top');
%set(T,'HorizontalAlignment','center');
%set(T,'FontSize',15);
%set(T,'FontWeight','bold');

V = xlabel('\rho');
set(V,'FontSize',20);
set(V,'VerticalAlignment','top');


hold on;

for M = 1:size(Mh,2)
  
  if (M == 2) 
    Acolor(M,:) = [1 0 0];
    Lstyle(M) = {'--'};
    Mstyle(M) = {'*'};
    
    T =text(1.07*centr,1.05*max(Mh(:,2)),'Prior 1');
set(T,'VerticalAlignment','top');
set(T,'HorizontalAlignment','left');
set(T,'FontSize',15);
set(T,'FontWeight','bold');

  elseif (M == 3) 
    Acolor(M,:) = [0 0 1];
    Lstyle(M) = {'--'};
    Mstyle(M) = {'*'};
    
    T =text(1.07*centr2,1.09*max(Mh(:,3)),'Prior 2');
set(T,'VerticalAlignment','top');
set(T,'HorizontalAlignment','left');
set(T,'FontSize',15);
set(T,'FontWeight','bold');
  
  end
  if M == 1

    T =text(0,max(Mh(:,1)),'Likelihood');
    set(T,'VerticalAlignment','bottom');
    set(T,'HorizontalAlignment','right');
    set(T,'FontSize',15);
    set(T,'FontWeight','bold');


  end

  figure(101);
  P = plot(tirf,Mh(:,M));
  set(P,'Color',Acolor(M,:));
  set(P,'LineStyle',Lstyle{M});
  %set(P,'Marker',Mstyle{M});
  %set(P,'MarkerSize',8);
  set(P,'LineWidth',2);
  
  
  hold on;

  set(gca,'YLim',Yl);
  set(gca,'XLim',[min(tirf)-.1,max(tirf)+.1]);
  set(gca,'XTick',[]);
  set(gca,'XTickLabel',[]);
  set(gca,'YTick',[]);
  set(gca,'YTickLabel',[]);


  figure(101);
  %set(figure(101),'PaperPosition',[0 0 7 9])
  ng=strcat(gpath,'misplot-',num2str(M));

  %saveas(figure(101),char(ng),'fig');
  figure(101);
  print(char(strcat(ng,'.eps')),'-depsc2');
  print(char(strcat(ng,'.pdf')),'-dpdf');

end


close all;
