close all;
clear all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% PRELIMINARY STUFF
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
run startdsswfed;
!hostname;
!ps -C matlab;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%      paths & parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
varspec;


if isempty(mspec_ref)
  lmodel_ref = [];
  nobsdrat_ = [];
  lambdac_ = [];
  nlagsc_ = [];
  n_s_ = [];
  disp('NO reference model set in varspec.m')
else
  lmodel_ref = strcat('m',num2str(mspec_ref));
  nobsdrat_ = num2str(100*nobsdrat);
  lambdac_ = [];
  n_s_ = num2str(n_s);
  if nlagsc == 4
    nlagsc_ = [];
  else
    nlagsc_ = num2str(nlagsc);
  end  
  
end
stup_ = num2str(stup);

[fpath,spath,gpath] = pathspec(num2str(floor(dataset)));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%*
% Load information for prior distribution

lprior    = num2str(mprior);
lmodel    = strcat('m',num2str(mspec));
priorfile = strcat('pri',lprior)
prior = feval(priorfile);

pmean  = prior(1:npara,1);
pstdd  = prior(1:npara,2);
pshape = prior(1:npara,3);

pshape = pshape.*(1-para_mask);


nonpolipar = [1:1:npara];
nonpolipar(polipar) = [];

% Load transformation scheme for parameters
trspec = feval('transp',mspec);

trspec(:,1) = trspec(:,1).*(1-para_mask);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% load data
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[YYall,XXall,ti,nobsall] = loaddata(dataset,fpath,T0,Tend,coint,cointadd,cointall,nvar,nlags,mspec);

dataset = num2str(10*dataset);

Iseq = find(ti == dates);
I = Iseq;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Set parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

percent = .90;

dobench = 2%inf;

mspecno = [1 2 ];
mspeclist = [105,106,105,106];
mspec_ref_list = cell(length(mspeclist),1);
mspec_ref_list(1) = {[]};
mspec_ref_list(2) = {[]};
mspec_ref_list(3) = {[NaN]};
mspec_ref_list(4) = {[NaN]};

nobsdrat_list = cell(length(mspeclist),1);
nobsdrat_list(1) = {[6/100]};
nobsdrat_list(2) = {[6/100]};
nobsdrat_list(3) = {[6/100]};
nobsdrat_list(4) = {[6/100]};

nlagsc_list = cell(length(mspeclist),1);
nlagsc_list(1) = {[1]};
nlagsc_list(2) = {[1]};
nlagsc_list(3) = {[1]};
nlagsc_list(4) = {[1]};

mprior_list = cell(length(mspeclist),1);
mprior_list(1) = {[52]};
mprior_list(2) = {[52]};
mprior_list(3) = {[53]};
mprior_list(4) = {[53]};

prio_list = cell(length(mspeclist),1);
prio_list(1) = {[1]};
prio_list(2) = {[1]};
prio_list(3) = {[1]};
prio_list(4) = {[1]};


stup_list = cell(length(mspeclist),1);
stup_list(1) = {[1]};
stup_list(2) = {[1]};
stup_list(3) = {[1]};
stup_list(4) = {[1]};

pos_list = cell(length(mspeclist),1);
pos_list(1) = {[1]};
pos_list(2) = {[1]};
pos_list(3) = {[2]};
pos_list(4) = {[2]};

Acolor = zeros(length(mspeclist),3);
Acolor(1,:) = [1 0 0]%[0 .2 .2];
Acolor(2,:) = [0 0 0]%[0 .2 .2];
Acolor(3,:) = [1 0 0]%[0 .2 .2];
Acolor(4,:) = [0 0 0]%[0 .2 .2];


modls = 'm';
for ispec = mspecno 
  mspec = mspeclist(ispec);
  modls = strcat(modls,num2str(mspec));
  modls = strcat(modls,num2str(mprior_list{ispec}));  
  if prio_list{ispec}
  modls = strcat(modls,'Prio');  
  elseif ~prio_list{ispec}
  modls = strcat(modls,'Post');  
  end
  
  if ~isempty(mspec_ref_list{ispec})
    modls = strcat(modls,num2str(mspec_ref_list{ispec}));
    modls = strcat(modls,'n',num2str(100*nobsdrat_list{ispec}));
    modls = strcat(modls,'l',num2str(nlagsc_list{ispec}));
    modls = strcat(modls,'stup',num2str(stup_list{ispec}));
  end    
  modls = strcat(modls,'_');  
end
%modls = strcat(modls,'/');  
%mkdir(gpath,modls);


Fcolor = zeros(length(mspeclist),3);
Lstyle = cell(length(mspeclist),1);
Mstyle = cell(length(mspeclist),1);
Lstyle(1) = {'-.'};
Mstyle(1) = {'+'};%o
Lstyle(2) = {'-'};
Mstyle(2) = {'+'};
Lstyle(3) = {'-.'};
Mstyle(3) = {'+'};%o
Lstyle(4) = {'-'};
Mstyle(4) = {'+'};


tirf = (1:1:nirf)';
sirf = (1:17);

titlenames = varnames;
%titlenames(cum_irf) = strcat(titlenames(cum_irf),' - cumulative');

intx = tirf(sirf);

%% which shocks, which variables
nshocks = length(names_shocks)
Shseq = [2]%  1:nshocks
Vseq = [1 2 3 4]% 1:nvar


%% set YLim
ylims = zeros(nvar,2);
ylims(1,:) = [-.1 .5];        %% fed fund
ylims(1,:) = [-.1 .6];        %% fed fund
ylims(2,:) = [-.6 .1];        %% infl
ylims(3,:) = [-.1  .5];        %% gap
ylims(3,:) = [-.2  .6];        %% gap
ylims(4,:) = [-.5  .1];        %% l share
ylims(5,:) = [-.5 .1];        %% hrs

ylims = repmat(ylims, [1 1 nshocks]);

ylims(1,:,2) = [-.5 .1];        %% fed fund (tech)
ylims(2,:,3) = [-.1 0.6];        %% infl (demand)
ylims(2,:,4) = [-.1 0.6];        %% infl (mkup)
ylims(2,:,5) = [-.1 0.6];        %% infl (pref)
ylims(3,:,3) = [-.2  .7];        %% gap  (demand)
ylims(3,:,4) = [-.5  .1];        %% gap (mkup)
ylims(3,:,5) = [-.5  .1];        %% gap (pref)
ylims(4,:,3) = [-.1 .5];        %% l share (dmnd)
ylims(4,:,5) = [-.1 .5];        %% l share (pref)
ylims(5,:,3) = [-.1 .5];        %% hrs (dmnd)

ylims(:,:,6:7) = NaN
ylims(:,:,:) = NaN;

for ispec = mspecno 
  mspec = mspeclist(ispec)
  lmodel    = strcat('m',num2str(mspec));

  mprior = mprior_list{ispec}
  lprior    = num2str(mprior);
  
  mspec_ref = mspec_ref_list{ispec}
  nobsdrat = nobsdrat_list{ispec}
  nlagsc = nlagsc_list{ispec}
  stup = stup_list{ispec}
  if isempty(mspec_ref)
    lmodel_ref = [];
    nobsdrat_ = [];
    nlagsc_ = [];
    stup_ = [];
    
    %    lprior    = '12';
    
  else
    lmodel_ref = strcat('m',num2str(mspec_ref));
    nobsdrat_ = num2str(100*nobsdrat);
    stup_ = num2str(stup);
    if nlagsc == 4
      nlagsc_ = [];
    else
      nlagsc_ = num2str(nlagsc);
    end  
    %        lprior    = '11';

  end


  if prio_list{ispec}
    infile01 = strcat(spath,'/prioirfsMeanBands',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_)
  elseif ~prio_list{ispec}
    coint0 = coint;
    lambdas = NaN;   
    fixparam = fixparamseq(1);
    infile01 =  strcat(spath,'/prioirfsMeanBands',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_,num2str(coint0),st,num2str(100*lambdas),num2str(100*ti(I)),num2str(nlags),num2str(fixparam),num2str(JustMode));   
  end
  
  if ~exist(infile01)
    if prio_list{ispec}
      infile01 = strcat(spath,'/prioirfs',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_)
    elseif ~prio_list{ispec}
      infile01 = strcat(spath,'/postirfs',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_,num2str(coint0),st,num2str(100*lambdas),num2str(100*ti(I)),num2str(nlags),num2str(fixparam),num2str(JustMode));		
    end
    
    fid01 = fopen(infile01,'r');		% output file (set to write)   

    tic
    irfs = fread(fid01,[nvar*nshocks*nirf,inf],'single')';
    toc
    fclose(fid01);


    mirf = mean(irfs,1)';
    birf = hpdint(irfs,percent,0)';


    clear irfs;

    outfile01 = strcat(spath,'/prioirfsMeanBands',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_)
    fid01 = fopen(outfile01,'w');		% output file (set to write)   
    fwrite(fid01,[mirf,birf],'single');
    fclose(fid01);

  else
    
    fid01 = fopen(infile01,'r');		% output file (set to write)   
    irfmb = fread(fid01,[nvar*nshocks*nirf,3],'single');
    fclose(fid01);
    
    mirf = irfmb(:,1);
    birf = irfmb(:,2:3);
    
  end
  mirf = reshape(mirf,[nirf nvar*nshocks]);
  birf = reshape(birf,[nirf nvar*nshocks 2]);
  
  NIirf = 0;
  for Iirf = Shseq
     NIirf = NIirf+1;
  VIirf = 0;
    for V = Vseq
     VIirf = VIirf+1;
      figure(1000);
      subplot(3,length(Vseq),VIirf+length(Vseq)*(pos_list{ispec}-1));   

      
      mlp = mirf(:,V+nvar*(Iirf-1));
      mbands = birf(:,V+nvar*(Iirf-1),:);

      ax1 = gca;
      P = line(intx,mlp(sirf));
      set(P,'LineWidth',2);
      set(P,'Color',Acolor(ispec,:));
      set(P,'Marker','none','LineStyle',Lstyle{ispec},'Parent',ax1);
      hold on;

      P = line(intx,mbands(sirf,1));
      set(P,'LineWidth',.8);
      set(P,'Color',Acolor(ispec,:));
      set(P,'Marker','none','LineStyle',Lstyle{ispec},'Parent',ax1);
      hold on;
      
      P = line(intx,mbands(sirf,2));
      set(P,'LineWidth',.8);
      set(P,'Color',Acolor(ispec,:));
      set(P,'Marker','none','LineStyle',Lstyle{ispec},'Parent',ax1);
      hold on;

      if Iirf == Shseq(1)
        title(titlenames(V));
      end
      
      if V == 1 
        ylabel(names_shocks(Iirf));
      end
      if ~isnan(ylims)
        set(gca,'YLim',ylims(V,:,Iirf));
      end
      
      set(gca,'XLim',[min(tirf(sirf)),max(tirf(sirf))]);
      set(gca,'XTick',intx([1 5:4:end]));
      
      if Iirf == Shseq(end)
        set(gca,'XTickLabel',num2str(intx([1 5:4:end])-1));
      else 
        set(gca,'XTickLabel',[]);
      end	   	   
      set(gca,'FontSize',8.5);
      
    end   %% end variable
  end; %% end shock



end %% end mspec list


figure(1000);
ng=strcat(gpath,modls,'Irfs');
ng = strcat(gpath,'105vs106-Ps-phi')
print(char(strcat(ng,'.eps')),'-depsc2');        
print(char(strcat(ng,'.pdf')),'-dpdf');   


close all;
return
