close all;
clear all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% PRELIMINARY STUFF
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
run startdsswfed;
!hostname;
!ps -C matlab;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%      paths & parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
varspec;

  n_s_ = [];

[fpath,spath,gpath] = pathspec(num2str(floor(dataset)));
gpath = strcat(gpath,'/revision/');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%*
% Load information for prior distribution

lprior    = num2str(mprior);
lmodel    = strcat('m',num2str(mspec));
priorfile = strcat('pri',lprior)
prior = feval(priorfile);

pmean  = prior(1:npara,1);
pstdd  = prior(1:npara,2);
pshape = prior(1:npara,3);

pshape = pshape.*(1-para_mask);


nonpolipar = [1:1:npara];
nonpolipar(polipar) = [];

% Load transformation scheme for parameters
trspec = feval('transp',mspec);

trspec(:,1) = trspec(:,1).*(1-para_mask);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% load data
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[YYall,XXall,ti,nobsall] = loaddata(dataset,fpath,T0,Tend,coint,cointadd,cointall,nvar,nlags,mspec);

dataset = num2str(10*dataset);

Iseq = find(ti == dates);
I = Iseq;
if stime                           
  YY = YYall(I-stime+1:I,:);
  XX = XXall(I-stime+1:I,:);             
  tiI = ti(I-stime+1:I);
  
  YY_p = YYall(1:I-stime,:);
  XX_p = XXall(1:I-stime,:);             
  nobs_p = size(YY_p,1)
  
else
  YY     = YYall(1:I,:);
  XX     = XXall(1:I,:);                   
  tiI = ti(1:I);
end
nobs = size(YY,1);

k     = nlags*nvar;

YYYY = YY'*YY;
XXYY = XX'*YY;
XXXX = XX'*XX;

MeY_0 = XXYY(1+cointall,:)'/nobs
VaY_0 = (YYYY/nobs)-MeY_0*MeY_0';
stdY_0 = sqrt(diag(VaY_0));
CorY_0 = VaY_0./(stdY_0*stdY_0');
%CoY_0 = (XXYY(1+cointall+1:1+cointall+nvar,:)/nobs)-MeY_0*MeY_0'
%ACorY_0 = diag(CoY_0)./diag(VaY_0)
ACorY_0 = zeros(nvar,1);
for ii = 1:nvar;
  ACorY_0(ii) = corr(YY(:,ii),XX(:,1+cointall+ii));
end
ACorY_0

stats_0 = [MeY_0' stdY_0' ACorY_0' CorY_0(:)'];

infile200 = strcat(spath,'/stats');		
fid200 = fopen(infile200,'r');		% output file (set to write)   
stats_0 = fread(fid200,[1 inf],'single'); 
fclose(fid200);

infile200 = strcat(spath,'/statsPre');		
fid200 = fopen(infile200,'r');		% output file (set to write)   
stats_0b = fread(fid200,[1 inf],'single'); 
fclose(fid200);

ICUM = find(cum_for);
INCUM = find(cum_for == 0);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Set parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% WANT POPULATION OR SAMPLE MOMENTS?
POPUL = 0
if POPUL 
  POP_ = '';
else
  POP_ = 'P';
end

percent = .90;

dobench = 2%inf;

mspecno = [1 2];
mspeclist = [106,106,106,106];
mspec_ref_list = cell(length(mspeclist),1);
mspec_ref_list(1) = {[]};
mspec_ref_list(2) = {[]};
mspec_ref_list(3) = {[NaN]};
mspec_ref_list(4) = {[NaN]};

nobsdrat_list = cell(length(mspeclist),1);
nobsdrat_list(1) = {[6/100]};
nobsdrat_list(2) = {[6/100]};
nobsdrat_list(3) = {[6/100]};
nobsdrat_list(4) = {[6/100]};

nlagsc_list = cell(length(mspeclist),1);
nlagsc_list(1) = {[1]};
nlagsc_list(2) = {[1]};
nlagsc_list(3) = {[1]};
nlagsc_list(4) = {[1]};

mprior_list = cell(length(mspeclist),1);
mprior_list(1) = {[42]};
mprior_list(2) = {[62]};
mprior_list(3) = {[43]};
mprior_list(4) = {[63]};

prio_list = cell(length(mspeclist),1);
prio_list(1) = {[1]};
prio_list(2) = {[1]};
prio_list(3) = {[1]};
prio_list(4) = {[1]};

stup_list = cell(length(mspeclist),1);
stup_list(1) = {[1]};
stup_list(2) = {[1]};
stup_list(3) = {[1]};
stup_list(4) = {[1]};

Acolor = zeros(length(mspeclist),3);
Acolor(1,:) = [.5 .5 .5]%[0 .2 .2];
Acolor(2,:) = [0 0 0]%[0 .2 .2];
Acolor(3,:) = [.5 .5 .5]%[0 .2 .2];
Acolor(4,:) = [0 0 0]%[0 .2 .2];


modls = 'm';
for ispec = mspecno 
  mspec = mspeclist(ispec);
  modls = strcat(modls,num2str(mspec));
  modls = strcat(modls,num2str(mprior_list{ispec}));  
  if prio_list{ispec}
    modls = strcat(modls,'Prio');  
  elseif ~prio_list{ispec}
    modls = strcat(modls,'Post');  
  end
  if ~isempty(mspec_ref_list{ispec})
    modls = strcat(modls,num2str(mspec_ref_list{ispec}));
    modls = strcat(modls,'n',num2str(100*nobsdrat_list{ispec}));
    modls = strcat(modls,'l',num2str(nlagsc_list{ispec}));
    modls = strcat(modls,'stup',num2str(stup_list{ispec}));
  end    
  modls = strcat(modls,'_');  
end
modls = strcat(modls,'/');  
mkdir(gpath,modls);


Fcolor = zeros(length(mspeclist),3);
Lstyle = cell(length(mspeclist),1);
Mstyle = cell(length(mspeclist),1);

Lstyle(1) = {'-'};
Mstyle(1) = {'+'};%o
Fcolor(1,:) = [.9 .9 .9];
Lstyle(2) = {'--'};
Mstyle(2) = {'+'};
Fcolor(2,:) = [.2 .2 .2];
Lstyle(3) = {'-'};
Mstyle(3) = {'+'};%o
Fcolor(3,:) = [.9 .9 .9];
Lstyle(4) = {'--'};
Mstyle(4) = {'+'};
Fcolor(4,:) = [.2 .2 .2];

LListnames = cell(11,1);
LListtitle = cell(length(LListnames),20);
Lylim = zeros(length(LListnames),2); 

LListnames(1) = {'CorLsPi'}; 
LListtitle(1) = {strcat('Corr(',varnames{3},'(t),',varnames{4},'(t+k))')};;

LListnames(2) = {'CorLsY'};
LListtitle(2) = {strcat('Corr(',varnames{1},'(t),',varnames{3},'(t+k))')};;

LListnames(3) = {'AcorLs'};
LListtitle(3) = {strcat('Corr(',varnames{3},'(t),',varnames{3},'(t+k))')};;

LListnames(4) = {'AcorPi'};
LListtitle(4) = {strcat('Corr(',varnames{4},'(t),',varnames{4},'(t+k))')};;

WLListnames = [1 3 4]

outfile00 = strcat(gpath,modls,lprior,POP_,'-',num2str(JustMode),'PrioStats.tex');		% output file name 
fid00 = fopen(outfile00,'w')		% output file (set to write)
fprintf(fid00,'\n \\documentclass[12pt]{article} \n \\usepackage[dvips]{color}\n ');
fprintf(fid00,'\n \\begin{document}');

Listnames = cell(11,1);
Listxlabel = cell(length(Listnames),20);
Listylabel = cell(length(Listnames),20);

WListnames = [2 4 8 10 11 12]

xminth = zeros(10,length(Listnames)); 
xmaxth = zeros(10,length(Listnames));
yminth = zeros(10,length(Listnames)); 
ymaxth = zeros(10,length(Listnames));

xminth_ = zeros(10,length(Listnames)); 
xmaxth_ = zeros(10,length(Listnames));
yminth_ = zeros(10,length(Listnames)); 
ymaxth_ = zeros(10,length(Listnames));


Listnames(1) = {'Autocor'};
Listallx(1) = {repmat(2*nvar+1,[1 (nvar-1)])};
Listally(1) = {2*nvar+2:3*nvar};
for il = 1:4
  Listxlabel(1,il) = {varnames{1}};
  Listylabel(1,il) = {varnames{1+il}};
end

xminth_(:,1) = 0;
xmaxth_(:,1) = 1;
yminth_(:,1) = 0;
ymaxth_(:,1) = 1;

Listnames(2) = {'Std'};
%Listallx(2) = {repmat(nvar+1,[1 (nvar-1)])};
Listallx(2) = {[nvar+1 nvar+3]};
Listally(2) = {[nvar+2 nvar+4]};
%for il = 1:4
%  Listxlabel(2,il) = {varnames{1}};
%  Listylabel(2,il) = {varnames{1+il}};
%end
Listxlabel(2,1) = {varnames{1}};
Listylabel(2,1) = {varnames{2}};
Listxlabel(2,2) = {varnames{3}};
Listylabel(2,2) = {varnames{4}};

xminth_(:,2) = 0;
xmaxth_(1:4,2) = 5;
yminth_(:,2) = 0;
ymaxth_(1:4,2) = [15 15 25 35]';

Listnames(3) = {'Corr'};
Listallx(3) = {[3*nvar+2*nvar+4,3*nvar+2]};
Listally(3) = {[3*nvar+2*nvar+nvar,3*nvar+3]};
Listxlabel(3,1) = {strcat('Corr(',varnames{3},',',varnames{4},')')};
Listylabel(3,1) = {strcat('Corr(',varnames{3},',',varnames{5},')')};

Listxlabel(3,2) = {strcat('Corr(',varnames{1},',',varnames{2},')')};
Listylabel(3,2) = {strcat('Corr(',varnames{1},',',varnames{3},')')};

xminth(:,3) = .5;%-.2;
xmaxth(:,3) = 1;
yminth(:,3) = .5;%-.2;
ymaxth(:,3) = 1;
xminth_(:,3) = -1;
xmaxth_(:,3) = 1;
yminth_(:,3) = -1;
ymaxth_(:,3) = 1;



Listnames(4) = {'Infl'};
Listallx(4) = {2*nvar+4};
Listally(4) = {nvar+4};
Listxlabel(4,1) = {strcat('Autocorr(',varnames{4},')')};
Listylabel(4,1) = {strcat('St Dev(',varnames{4},')')};

xminth(:,4) = 0;%-.2;
xmaxth(:,4) = 1;
yminth(:,4) = 0;
ymaxth(:,4) = 15;
xminth_(:,4) = 0;%-.2;
xmaxth_(:,4) = 1;
yminth_(:,4) = 0;
ymaxth_(:,4) = 15;

Listnames(5) = {'StdIR'};
Listallx(5) = {nvar+4};
Listally(5) = {nvar+5};
Listxlabel(5,1) = {varnames{4}};
Listylabel(5,1) = {varnames{5}};

xminth(:,5) = 0;
xmaxth(:,5) = 35;
yminth(:,5) = 0;
ymaxth(:,5) = 35;
xminth_(:,5) = 0;
xmaxth_(:,5) = 35;
yminth_(:,5) = 0;
ymaxth_(:,5) = 35;

Listnames(6) = {'RhoIR'};
Listallx(6) = {2*nvar+4};
Listally(6) = {2*nvar+5};
Listxlabel(6,1) = {varnames{4}};
Listylabel(6,1) = {varnames{5}};

xminth(:,6) = 0;%-.2;
xmaxth(:,6) = 1;
yminth(:,6) = 0;%-.2;
ymaxth(:,6) = 1;
xminth_(:,6) = 0;%-.2;
xmaxth_(:,6) = 1;
yminth_(:,6) = 0;%-.2;
ymaxth_(:,6) = 1;

Listnames(7) = {'StdYR'};
Listallx(7) = {nvar+2};
Listally(7) = {nvar+4};
Listxlabel(7,1) = {varnames{2}};
Listylabel(7,1) = {varnames{4}};

xminth(:,7) = 0;
xmaxth(:,7) = 15;
yminth(:,7) = 0;
ymaxth(:,7) = 15;
xminth_(:,7) = 0;
xmaxth_(:,7) = 15;
yminth_(:,7) = 0;
ymaxth_(:,7) = 15;

Listnames(8) = {'RhoLsInfl'};
Listallx(8) = {2*nvar+3};
Listally(8) = {2*nvar+4};
Listxlabel(8,1) = {strcat('Autocorr(',varnames{3},')')};
Listylabel(8,1) = {strcat('Autocorr(',varnames{4},')')};

xminth(:,8) = -.5;
xmaxth(:,8) = 1;
yminth(:,8) = -.5;
ymaxth(:,8) = 1;
xminth_(:,8) = -.5;
xmaxth_(:,8) = 1;
yminth_(:,8) = -.5;
ymaxth_(:,8) = 1;

Listnames(9) = {'Stdev'};
Listallx(9) = {[nvar+2,nvar+3]};
Listally(9) = {[nvar+4,nvar+4]};
Listxlabel(9,1) = {varnames{2}};
Listylabel(9,1) = {varnames{4}};
Listxlabel(9,2) = {varnames{3}};
Listylabel(9,2) = {varnames{4}};
xminth(:,9) = 0;%-.2;
xmaxth(:,9) = 1;
yminth(:,9) = 0;%-.2;
ymaxth(:,9) = 1;
xminth_(:,9) = 0;
xmaxth_(1:2,9) = [5 20]';
yminth_(:,9) = 0;
ymaxth_(1:2,9) = [25 20]';

Listnames(10) = {'StdLsCorrPiLs'};
Listallx(10) = {[1*nvar+3]};
Listally(10) = {[3*nvar+2*nvar+4]};
Listxlabel(10,1) = {strcat('Stdev(',varnames{3},')')};
Listylabel(10,1) = {strcat('Corr(',varnames{3},',',varnames{4},')')};
xminth(:,10) = 0;
xmaxth(:,10) = 5;
yminth(:,10) = -1;%-.2;
ymaxth(:,10) = 1;
xminth_(:,10) = 0;%-.5;
xmaxth_(:,10) = 5;
yminth_(:,10) = -1;
ymaxth_(:,10) = 1;

Listnames(11) = {'RhoPiCorrPiLs'};
Listallx(11) = {[2*nvar+4]};
Listally(11) = {[3*nvar+2*nvar+4]};
Listxlabel(11,1) = {strcat('Autocorr(',varnames{4},')')};
Listylabel(11,1) = {strcat('Corr(',varnames{3},',',varnames{4},')')};
xminth(:,11) = 0;
xmaxth(:,11) = 1;
yminth(:,11) = -1;%-.2;
ymaxth(:,11) = 1;
xminth_(:,11) = -1;%-.2;
xmaxth_(:,11) = 1;
yminth_(:,11) = -1;
ymaxth_(:,11) = 1;

Listnames(12) = {'StdPiCorrPiLs'};
Listallx(12) = {[1*nvar+4]};
Listally(12) = {[3*nvar+2*nvar+4]};
Listxlabel(12,1) = {strcat('Stdev(',varnames{4},')')};
Listylabel(12,1) = {strcat('Corr(',varnames{3},',',varnames{4},')')};
xminth(:,12) = 0;
xmaxth(:,12) = 10;
yminth(:,12) = -1;%-.2;
ymaxth(:,12) = 1;
xminth_(:,12) = 0;%-.5;
xmaxth_(:,12) = 10;
yminth_(:,12) = -1;
ymaxth_(:,12) = 1;

Listnames(13) = {'CorrYLsCorrPiLs'};
Listallx(13) = {[3*nvar+3]};
Listally(13) = {[3*nvar+2*nvar+4]};
Listxlabel(13,1) = {strcat('Corr(',varnames{1},',',varnames{3},')')};
Listylabel(13,1) = {strcat('Corr(',varnames{3},',',varnames{4},')')};
xminth(:,13) = -1;
xmaxth(:,13) = 1;
yminth(:,13) = -1;%-.2;
ymaxth(:,13) = 1;
xminth_(:,13) = -1;%-.5;
xmaxth_(:,13) = 1;
yminth_(:,13) = -1;
ymaxth_(:,13) = 1;

%  Listallx(11) = {2*nvar+3};
%  Listally(11) = {};

nstats = 3*nvar+2*nvar+4




N1all = [];

for ispec = mspecno 
  mspec = mspeclist(ispec)
  lmodel    = strcat('m',num2str(mspec));

  mprior = mprior_list{ispec}
  lprior    = num2str(mprior);
  
  mspec_ref = mspec_ref_list{ispec}
  nobsdrat = nobsdrat_list{ispec}
  nlagsc = nlagsc_list{ispec}
  stup = stup_list{ispec}
  if isempty(mspec_ref)
    lmodel_ref = [];
    nobsdrat_ = [];
    nlagsc_ = [];
    stup_ = [];
    
    %lprior    = strcat(lprior,'2');
    
  else
    lmodel_ref = strcat('m',num2str(mspec_ref));
    nobsdrat_ = num2str(100*nobsdrat);
    stup_ = num2str(stup);
    if nlagsc == 4
      nlagsc_ = [];
    else
      nlagsc_ = num2str(nlagsc);
    end  
    
  end


  
  if prio_list{ispec}
    infile01 = strcat(spath,'/priostats',lmodel,lprior,dataset,POP_,lmodel_ref,stup_,nobsdrat_,nlagsc_);
  elseif ~prio_list{ispec}
    coint0 = coint;
    lambdas = NaN;   
    fixparam = fixparamseq(1);

    infile01 = strcat(spath,'/priostats',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_,num2str(coint0),st,num2str(100*lambdas),num2str(100*ti(I)),num2str(nlags),num2str(fixparam),num2str(JustMode));
  end
  fid01 = fopen(infile01,'r');		% output file (set to write)   
  num01 = (nblocks*nsim-nburn)*length(stats_0)*4;  % number of bites per file

  stats = [];

  
  stats = fread(fid01,[length(stats_0),inf],'single')';
  %% clean NaN rows
  i_NaN = find(isnan(stats(:,1)));
  stats(i_NaN,:) = [];
  %%%%%%%%%%% Compute posterior moments
  statsmean = median(stats,1);
  %statsbands = hpdint(theta,percent,1)';
  
  fclose(fid01);

  if ~isempty(mspec_ref)

    infile200 = strcat(spath,'/statsPre');		
    fid200 = fopen(infile200,'r');		% output file (set to write)   
    stats_ben = fread(fid200,[1 length(stats_0)],'single');
    fclose(fid200);

  end

  
  Fortab = '\n \\begin{tabular}{l@{\\hspace*{-0.01cm}}';
  Fornum = ' ';
  Heads = 'Variables ';
  Heads2 = ' ';

  %% mean (model, data)
  MeY = statsmean(1:nvar)';
  DatOut = [MeY MeY_0];
  Fortab = strcat(Fortab,'|ll');
  Fornum = strcat(Fornum,' & %2.2f & {\\it %2.2f }');
  Heads = strcat(Heads,'&  \\multicolumn{2}{c}{Mean}  ');
  Heads2 = strcat(Heads2,' & {\\tiny Prior} & {\\tiny Data}');

  %% st dev (model, data)
  stdY = statsmean(nvar+1:2*nvar)';
  DatOut = [DatOut stdY stdY_0];
  Fortab = strcat(Fortab,'|ll@{\\hspace*{-0.01cm}}');
  Fornum = strcat(Fornum,' & %2.2f & {\\it %2.2f }');
  Heads = strcat(Heads,'&  \\multicolumn{2}{c}{St. Dev.}  ');
  Heads2 = strcat(Heads2,' & {\\tiny Prior} & {\\tiny Data}');

  %% autocorr (model, data)
  ACorY = statsmean(2*nvar+1:3*nvar)';
  DatOut = [DatOut ACorY ACorY_0];
  Fortab = strcat(Fortab,'|ll@{\\hspace*{-0.01cm}}');
  Fornum = strcat(Fornum,' & %2.2f & {\\it %2.2f }');
  Heads = strcat(Heads,'&  \\multicolumn{2}{c}{Autocorr.}  ');
  Heads2 = strcat(Heads2,' & {\\tiny Prior} & {\\tiny Data}');


  %% contemp corr (model, data)
  CorY = reshape(statsmean(3*nvar+1:3*nvar+nvar^2),nvar,nvar);
  CorMix = tril(CorY,-1)+triu(CorY_0);
  DatOut2 = [CorMix];
  Heads = strcat(Heads,' & \\multicolumn{',num2str(nvar+1),'}{c}{Contemporanous Corr.}  ');
  Heads2 = strcat(Heads2,' &  & \\multicolumn{',num2str(nvar),'}{c}{ {\\tiny Data} }  ');

  Fortab = strcat(Fortab,'|@{\\hspace*{-0.01cm}}l');
  Fornum2 = ' ';
  for jj = 1:nvar
    Fortab = strcat(Fortab,'l');
    Fornum2 = strcat(Fornum2,' & %2.2f ');
  end


  %% finish up
  Fortab = strcat(Fortab,'}\\hline \n');
  Heads = strcat(Heads,'\\\\ \n');

  


  fprintf(fid00,'\n \\begin{table}[h] \\centering');        
  fprintf(fid00,'\n \\caption{Model %2.0f Statistics: Prior vs Data} \n\\vspace*{.5cm}',mspec);

  %% setting is: mean (model, data) , variances (model, data), autocorrelations (model, data), correlations (model, data)
  fprintf(fid00,Fortab);

  fprintf(fid00,Heads);
  fprintf(fid00,Heads2);

  for i = 1:size(DatOut,1);
    fprintf(fid00,'\\\\ \n $%4.99s$ ',varnames{i});
    fprintf(fid00,Fornum,DatOut(i,:));
    if i == 2
      fprintf(fid00,' & {\\tiny Pr} ');  
    else
      fprintf(fid00,' & ');  
    end
    fprintf(fid00,Fornum2,DatOut2(i,:));
  end   
  fprintf(fid00,'\\\\  \\hline');		    

  if ~isempty(mspec_ref)

    fprintf(fid00,' & \\multicolumn{4}{l}{{\\it vs. benchmark}} \\\\  ');		    

    %% mean (model, benchmark)
    MeY = statsmean(1:nvar)';
    MeY_ben = stats_ben(1:nvar)';
    DatOut_ben = [MeY MeY_ben];

    %% st dev (model, benchmark)
    stdY = statsmean(nvar+1:2*nvar)';
    stdY_ben = stats_ben(nvar+1:2*nvar)';
    DatOut_ben = [DatOut_ben stdY stdY_ben];

    %% autocorr (model, benchmark)
    ACorY = statsmean(2*nvar+1:3*nvar)';
    ACorY_ben = stats_ben(2*nvar+1:3*nvar)';
    DatOut_ben = [DatOut_ben ACorY ACorY_ben];

    %% contemp corr (model, benchmark)
    CorY = reshape(statsmean(3*nvar+1:3*nvar+nvar^2),nvar,nvar);
    CorY_ben = reshape(stats_ben(3*nvar+1:3*nvar+nvar^2),nvar,nvar);
    CorMix = tril(CorY,-1)+triu(CorY_ben);
    DatOut2_ben = [CorMix];
    
    
    for i = 1:size(DatOut,1);
      fprintf(fid00,'\\\\ \n $%4.99s$ ',varnames{i});
      fprintf(fid00,Fornum,DatOut_ben(i,:));
      if i == 2
        fprintf(fid00,' & {\\tiny Prior} ');  
      else
        fprintf(fid00,' & ');  
      end
      fprintf(fid00,Fornum2,DatOut2_ben(i,:));
    end   
    fprintf(fid00,'\\\\  \\hline');		    

  end

  
  fprintf(fid00,'\n \\end{tabular}');
  fprintf(fid00,'\n \\end{table} \n\n');


  stepp = 40;
  ind = ((nsim/stepp):(nsim/stepp):size(stats,1));
  statssc = stats(ind,:);
  %clear stats;


  
  mbar = 0

  %Listallx = [[2*nvar+1:3*nvar];[nvar+1:2*nvar]];
  %Listally = [[2*nvar+1:3*nvar];[nvar+1:2*nvar]];

  
  for ll = WListnames

    q1_List = Listallx{ll};
    q2_List = Listally{ll};

    tott = length(q1_List);

    siz1 = tott;
    siz2 = 1;
    
    for Iq = 1:tott

      q1 = q1_List(Iq);
      q1_statssc = statssc(:,q1);      
      q1_stats_0 = stats_0(:,q1);
      q1_stats_m = statsmean(q1);
      q1_stats_0b = stats_0b(:,q1);

      q2 = q2_List(Iq);
      q2_statssc = statssc(:,q2);
      q2_stats_0 = stats_0(:,q2);
      q2_stats_m = statsmean(q2);
      q2_stats_0b = stats_0b(:,q2);

      figure(2000+ll)
      Z = subplot(siz1,siz2,Iq);

      if ispec == mspecno(1)
        %        xminth(Iq,ll) = .99*min(min(q1_statssc),min(q1_stats_0));
        %        xmaxth(Iq,ll) = 1.01*max(max(q1_statssc),max(q1_stats_0));
      end

      xminth0 = .99*min(max(min(q1_statssc),xminth_(Iq,ll)),min(q1_stats_0));
      xmaxth0 = 1.01*max(min(max(q1_statssc),xmaxth_(Iq,ll)),max(q1_stats_0));
      xminth(Iq,ll) = min(xminth(Iq,ll),xminth0);
      xmaxth(Iq,ll) = max(xmaxth(Iq,ll),xmaxth0);

      if ispec == mspecno(1)
        %        yminth(Iq,ll) = .99*min(min(q2_statssc),min(q2_stats_0));
        %        ymaxth(Iq,ll) = 1.01*max(max(q2_statssc),max(q2_stats_0));
      end

      yminth0 = .99*min(max(min(q2_statssc),yminth_(Iq,ll)),min(q2_stats_0));
      ymaxth0 = 1.01*max(min(max(q2_statssc),ymaxth_(Iq,ll)),max(q2_stats_0));
      yminth(Iq,ll) = min(yminth(Iq,ll),yminth0);
      ymaxth(Iq,ll) = max(ymaxth(Iq,ll),ymaxth0);
      
      
      ax1 = gca;
      P = line(q1_statssc,q2_statssc);
      set(P,'Color',Acolor(ispec,:));
      set(P,'Marker',Mstyle{ispec},'MarkerSize',7,'LineStyle','none','Parent',ax1);
      

      if isnan(dobench) | isinf(dobench) |  (dobench == 2)
        P2 = line([q1_stats_m,q1_stats_m],[yminth(Iq,ll),ymaxth(Iq,ll)]);
        set(P2,'Color',Acolor(ispec,:));
        %set(ax2,'XLim',[xminth,xmaxth]);
        %set(ax2,'YLim',[yminth,ymaxth]);
        set(P2,'Marker','none','LineStyle',Lstyle{ispec},'Parent',ax1);

        %ax2 = axes('Position',get(ax1,'Position'),'Color','none');
        P3 = line([xminth(Iq,ll),xmaxth(Iq,ll)],[q2_stats_m,q2_stats_m]);
        set(P3,'Color',Acolor(ispec,:));
        %set(ax2,'XLim',[xminth,xmaxth]);
        %set(ax2,'YLim',[yminth,ymaxth]);
        set(P3,'Marker','none','LineStyle',Lstyle{ispec},'Parent',ax1);
      end
      
      if ispec == mspecno(end)

        if ~isnan(dobench)

          if isinf(dobench)

            %P2 = line(q1_stats_0,q2_stats_0);
            %set(P2,'Color',[1 0 0]);
            %set(P2,'Marker','*','Parent',ax1);
            %set(P2,'MarkerSize',20);

            %  T =text(q1_stats_0,q2_stats_0,'X');
            %  set(T,'VerticalAlignment','middle');
            %  set(T,'HorizontalAlignment','center');
            %  set(T,'FontSize',30);
            %  set(T,'FontWeight','bold');
            %  set(T,'Color',[1 .9 .9]);            

            P2 = line([q1_stats_0,q1_stats_0],[q2_stats_0-.05*(ymaxth(Iq,ll)-yminth(Iq,ll)),q2_stats_0+.05*(ymaxth(Iq,ll)-yminth(Iq,ll))]);
            set(P2,'Color',[1 .8 .8]);
            set(P2,'LineWidth',3);
            %set(ax2,'XLim',[xminth,xmaxth]);
            %set(ax2,'YLim',[yminth,ymaxth]);
            set(P2,'Marker','none','LineStyle','-','Parent',ax1);

            %ax2 = axes('Position',get(ax1,'Position'),'Color','none');
            P3 = line([q1_stats_0-.05*(xmaxth(Iq,ll)-xminth(Iq,ll)),q1_stats_0+.05*(xmaxth(Iq,ll)-xminth(Iq,ll))],[q2_stats_0,q2_stats_0]);
            set(P3,'Color',[1 .8 .8]);
            set(P3,'LineWidth',3);
            %set(ax2,'XLim',[xminth,xmaxth]);
            %set(ax2,'YLim',[yminth,ymaxth]);
            set(P3,'Marker','none','LineStyle','-','Parent',ax1);

          elseif (dobench == 1) |  (dobench == 2)
            
            P2 = line([q1_stats_0,q1_stats_0],[q2_stats_0-.05*(ymaxth(Iq,ll)-yminth(Iq,ll)),q2_stats_0+.05*(ymaxth(Iq,ll)-yminth(Iq,ll))]);
            set(P2,'Color',[.8 0 0]);
            set(P2,'LineWidth',3);
            %set(ax2,'XLim',[xminth,xmaxth]);
            %set(ax2,'YLim',[yminth,ymaxth]);
            set(P2,'Marker','none','LineStyle','-','Parent',ax1);

            %ax2 = axes('Position',get(ax1,'Position'),'Color','none');
            P3 = line([q1_stats_0-.05*(xmaxth(Iq,ll)-xminth(Iq,ll)),q1_stats_0+.05*(xmaxth(Iq,ll)-xminth(Iq,ll))],[q2_stats_0,q2_stats_0]);
            set(P3,'Color',[.8 0 0]);
            set(P3,'LineWidth',3);
            %set(ax2,'XLim',[xminth,xmaxth]);
            %set(ax2,'YLim',[yminth,ymaxth]);
            set(P3,'Marker','none','LineStyle','-','Parent',ax1);

            P4 = line([q1_stats_0b,q1_stats_0b],[q2_stats_0b-.05*(ymaxth(Iq,ll)-yminth(Iq,ll)),q2_stats_0b+.05*(ymaxth(Iq,ll)-yminth(Iq,ll))]);
            set(P4,'Color',[0 .5 .5]);
            set(P4,'LineWidth',3);
            %set(ax2,'XLim',[xminth,xmaxth]);
            %set(ax2,'YLim',[yminth,ymaxth]);
            set(P4,'Marker','none','LineStyle','-.','Parent',ax1);

            %ax2 = axes('Position',get(ax1,'Position'),'Color','none');
            P5 = line([q1_stats_0b-.05*(xmaxth(Iq,ll)-xminth(Iq,ll)),q1_stats_0b+.05*(xmaxth(Iq,ll)-xminth(Iq,ll))],[q2_stats_0b,q2_stats_0b]);
            set(P5,'Color',[0 .5 .5]);
            set(P5,'LineWidth',3);
            %set(ax2,'XLim',[xminth,xmaxth]);
            %set(ax2,'YLim',[yminth,ymaxth]);
            set(P5,'Marker','none','LineStyle','-.','Parent',ax1);

          end
        end
        
        
        set(ax1,'XLim',[xminth(Iq,ll),xmaxth(Iq,ll)]);
        set(ax1,'YLim',[yminth(Iq,ll),ymaxth(Iq,ll)]);

        
        

        T = xlabel(Listxlabel(ll,Iq));
        set(T,'FontSize',12);
        T = ylabel(Listylabel(ll,Iq));
        set(T,'FontSize',12);

        
        
        hold off;
        

      end
    end



    for ll = WLListnames
      infile201 = strcat(spath,'/',LListnames{ll});		
      fid201 = fopen(infile201,'r');		% output file (set to write)   
      lstats_0 = fread(fid201,[1 inf],'single'); 
      fclose(fid201);

      infile201 = strcat(spath,'/',LListnames{ll},'_p');		
      fid201 = fopen(infile201,'r');		% output file (set to write)   
      lstats_b = fread(fid201,[1 inf],'single'); 
      fclose(fid201);

      if prio_list{ispec}
        infile011 = strcat(spath,'/',LListnames{ll},lmodel,lprior,dataset,POP_,lmodel_ref,stup_,nobsdrat_,nlagsc_);
      elseif ~prio_list{ispec}
        coint0 = coint;
        lambdas = NaN;   
        fixparam = fixparamseq(1);

        infile011 = strcat(spath,'/',LListnames{ll},lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_,num2str(coint0),st,num2str(100*lambdas),num2str(100*ti(I)),num2str(nlags),num2str(fixparam),num2str(JustMode));
      end
      fid011 = fopen(infile011,'r');		% output file (set to write)   
      num011 = (nblocks*nsim-nburn)*length(lstats_0)*4;  % number of bites per file

      lstats = fread(fid011,[length(lstats_0),inf],'single')';
      %% clean NaN rows
      %i_NaN = find(isnan(stats(:,1)));
      %stats(i_NaN,:) = [];
      %%%%%%%%%%% Compute posterior moments
      lstatsmean = median(lstats,1);
      lstatsbands = hpdint(lstats,percent,1)';
      
      if length(lstats_0) == k_l
        intx = 1:length(lstats_0);
      else
        intx = -k_l:k_l;
      end

      fclose(fid011);

      figure(2200+ll)
      
      ax1 = gca;
      %P = line(intx,lstatsmean);
      %set(P,'Color',Acolor(ispec,:));
      %set(P,'Marker','none','LineStyle',Lstyle{ispec},'LineWidth',2,'Parent',ax1);

      P1 = line(intx,lstatsbands(:,1)');
      set(P1,'Color',Acolor(ispec,:));
      set(P1,'Marker','none','LineStyle',Lstyle{ispec},'LineWidth',1.5,'Parent',ax1);

      P2 = line(intx,lstatsbands(:,2)');
      set(P2,'Color',Acolor(ispec,:));
      set(P2,'Marker','none','LineStyle',Lstyle{ispec},'LineWidth',1.5,'Parent',ax1);

      P0 = line(intx,lstats_0);
      set(P0,'Color',[.8 .8 .8]);
      set(P0,'Marker','+','MarkerSize',16,'LineStyle','-','LineWidth',3,'Parent',ax1);

      set(gca,'FontSize',12);

      set(ax1,'YLim',[-1 1]);
      %title(LListtitle{ll});
      T = xlabel('k');
      set(T,'FontSize',16);

    end

  end %% end mspec list


  for ll = WListnames
    figure(2000+ll);
    ng=strcat(gpath,modls,Listnames{ll},'-',num2str(dobench));
    %print(char(strcat(ng,'.eps')),'-depsc2');        
    print(char(strcat(ng,'.pdf')),'-dpdf');   
  end

  for ll = WLListnames
    figure(2200+ll);
    ng=strcat(gpath,modls,LListnames{ll});
    print(char(strcat(ng,'.eps')),'-depsc2');        
    print(char(strcat(ng,'.pdf')),'-dpdf');   
  end
  
  
end

fprintf(fid00,'\n \\end{document}');

fclose(fid00);		% close output file

close all;
return
