
close all;
clear all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% PRELIMINARY STUFF
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
run startdsswfed;
!hostname;
!ps -C matlab;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%      paths & parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
varspec;

[fpath,spath,gpath] = pathspec(num2str(floor(dataset)));


fprintf(1,'model: %2.0f, dataset: %2.1f, prior: %2.0f, cointall: %2.0f,',[mspec,dataset,mprior,cointall]);


if isempty(mspec_ref)
  lmodel_ref = [];
  nobsdrat_ = [];
  lambdac_ = [];
  nlagsc_ = [];
  n_s_ = [];
  disp('NO reference model set in varspec.m')
else
  lmodel_ref = strcat('m',num2str(mspec_ref));
  nobsdrat_ = num2str(100*nobsdrat);
  lambdac_ = [];
  n_s_ = num2str(n_s);
  if nlagsc == 4
    nlagsc_ = [];
  else
    nlagsc_ = num2str(nlagsc);
  end  
  
end
stup_ = num2str(stup);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% load data
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[YYall,XXall,ti,nobsall] = loaddata(dataset,fpath,T0,Tend,coint,cointadd,cointall,nvar,nlags,mspec);
Iseq = find(ti == dates);
I = Iseq;
if stime                           
  YY = YYall(I-stime+1:I,:);
  XX = XXall(I-stime+1:I,:);             
  tiI = ti(I-stime+1:I);
else
  YY     = YYall(1:I,:);
  XX     = XXall(1:I,:);                   
  tiI = ti(1:I);
end
nobs = size(YY,1)


YYYY = YY'*YY;
XXYY = XX'*YY;
XXXX = XX'*XX;

k = 1+nlags*nvar+coint;


dataset = num2str(10*dataset);

ICUM = find(cum_for);
INCUM = find(cum_for == 0);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%*
% Load information for prior distribution

lprior    = num2str(mprior);
lmodel    = strcat('m',num2str(mspec));
priorfile = strcat('pri',lprior);
prior = feval(priorfile);

pmean  = prior(1:npara,1);
pstdd  = prior(1:npara,2);
pshape = prior(1:npara,3);

pshape = pshape.*(1-para_mask);


nonpolipar = [1:1:npara];
nonpolipar(polipar) = [];

% Load transformation scheme for parameters
trspec = feval('transp',mspec);

trspec(:,1) = trspec(:,1).*(1-para_mask);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Set parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% set date
I = find(ti == dates);



percent = .90;


[TTT,RRR,valid] = dsgesolv(para,mspec);
nstate = length(TTT);
nshocks = size(RRR,2);


PRIO = 1
if PRIO
  PRIO_ = [];

  %% prior params file (first block has already been thrown out)
  infile3 = strcat(spath,'/mhNIpriopara',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_);
  numb3 = nburn*npara*4;  % number of bites per file
  fid3 = fopen(infile3,'r');		% input file (set to read)               
                                        %% note nburn has already been discarded
  status = fseek(fid3,0,1);       % measure how many bytes in the file
  tot_ = ftell(fid3);
  status = fseek(fid3,0,-1);       % back to the beginning of the file


  %% MA representation: TTT (nstate x nstate) and RRR (nstate x nshocks)
  infile11 = strcat(spath,'/TTTprio',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_);    
  numb11 = nburn*nstate^2*4;  % number of bites per file
  fid11 = fopen(infile11,'r');		% input file (set to read) 

  infile12 = strcat(spath,'/RRRprio',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_);  
  numb12 = nburn*nstate*nshocks*4;  % number of bites per file
  fid12 = fopen(infile12,'r');		% input file (set to read) 

  outfile01 = strcat(spath,'/prioirfs',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_)
  fid01 = fopen(outfile01,'w');		% output file (set to write)   

else
    coint0 = coint;
    lambdas = NaN;   
    fixparam = fixparamseq(1);

  %% posterior
  infile3 = strcat(spath,'/mhpara',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_,num2str(coint0),st,num2str(100*lambdas),num2str(100*ti(I)),num2str(nlags),num2str(fixparam),num2str(JustMode));		
  num3 = nblocks*nsim*npara*4;            % number of bites per file
  numb3 = nburn*npara*4;                  % number of bites to dicard

  fid3 = fopen(infile3,'r');		% input file (set to read)               
  status = fseek(fid3,0,1);       % measure how many bytes in the file
  tot_ = ftell(fid3);
  status = fseek(fid3,0,-1);       % back to the beginning of the file
%  status = fseek(fid3,numb3,'bof');

  
  infile11 = strcat(spath,'/TTT',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_,num2str(cointall),st,num2str(100*lambdas),num2str(100*ti(I)),num2str(nlags),num2str(fixparam),num2str(JustMode));    
  numb11 = nburn*nstate^2*4;  % number of bites per file
  
  fid11 = fopen(infile11,'r');		% input file (set to read)               
%  status = fseek(fid11,numb11,'bof');

  infile12 = strcat(spath,'/RRR',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_,num2str(cointall),st,num2str(100*lambdas),num2str(100*ti(I)),num2str(nlags),num2str(fixparam),num2str(JustMode));    
  numb12 = nburn*nstate*nshocks*4;  % number of bites per file
  
  fid12 = fopen(infile12,'r');		% input file (set to read)               
%  status = fseek(fid12,numb12,'bof');
  

  outfile01 = strcat(spath,'/postirfs',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_,num2str(coint0),st,num2str(100*lambdas),num2str(100*ti(I)),num2str(nlags),num2str(fixparam),num2str(JustMode));		
  fid01 = fopen(outfile01,'w');		% output file (set to write)   

end


priotheta = [];
iblock = 0;
while ( ftell(fid3) < tot_ ) 
  % Read blocks of size nsim

  iblock = iblock+1;
  fprintf(1,'\n block: %2.0f  ;',iblock);
  priotheta = fread(fid3,[npara,nsim],'single')';
  TTTsim = fread(fid11,[nstate^2,nsim],'single')';
  RRRsim = fread(fid12,[nstate*nshocks,nsim],'single')';


  nsim_ = size(priotheta,1);
  fprintf(1,' block size: %2.0f  ;',nsim_);

  irfsim = zeros(nsim_,nvar*nshocks*nirf);

  for j = 1:nsim_

    params = priotheta(j,:)';          
    
    TTT = reshape(TTTsim(j,:),nstate,nstate);
    RRR = reshape(RRRsim(j,:),nstate,nshocks);
    if ~PRIO
      [TTT,RRR,valid] = dsgesolv(params,mspec);
    end
    aairf = irfdsge(TTT,RRR,params,nvar,mspec,npara,nirf,cum_irf,1,nlags,coint,cointadd,cointall);

    irfsim(j,:) = aairf(:)';    
    
  end
  fwrite(fid01,irfsim','single');

end;
fclose(fid3);
fclose(fid11);
fclose(fid12);

fclose(fid01);




infile01 = outfile01;

fid01 = fopen(infile01,'r');		% output file (set to write)   
tic

irfs = fread(fid01,[nvar*nshocks*nirf,inf],'single')';

toc
fclose(fid01);



mirf = mean(irfs,1)';
birf = hpdint(irfs,percent,0)';

clear irfs;

if PRIO
  outfile01 = strcat(spath,'/prioirfsMeanBands',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_)
else
  outfile01 = strcat(spath,'/prioirfsMeanBands',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_,num2str(coint0),st,num2str(100*lambdas),num2str(100*ti(I)),num2str(nlags),num2str(fixparam),num2str(JustMode));
end
fid01 = fopen(outfile01,'w');		% output file (set to write)   
fwrite(fid01,[mirf,birf],'single');
fclose(fid01);
