close all;
clear all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% PRELIMINARY STUFF
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
run startdsswfed;
!hostname;
!ps -C matlab;
rand('state',sum(100*clock))
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%      paths & parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
varspec;

[fpath,spath,gpath] = pathspec(num2str(floor(dataset)));


fprintf(1,'model: %2.0f, dataset: %2.1f, prior: %2.0f, cointall: %2.0f,',[mspec,dataset,mprior,cointall]);

if isempty(mspec_ref)
  lmodel_ref = [];
  nobsdrat_ = [];
  lambdac_ = [];
  nlagsc_ = [];
  n_s_ = [];

else
  lmodel_ref = strcat('m',num2str(mspec_ref));
  nobsdrat_ = num2str(100*nobsdrat);
  lambdac_ = [];
  n_s_ = num2str(n_s);
  if nlagsc == 4
    nlagsc_ = [];
  else
    nlagsc_ = num2str(nlagsc);
  end  
  
end

stup_ = num2str(stup);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% load data
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[YYall,XXall,ti,nobsall] = loaddata(dataset,fpath,T0,Tend,coint,cointadd,cointall,nvar,nlags,mspec);

dataset = num2str(10*dataset);

ICUM = find(cum_for);
INCUM = find(cum_for == 0);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Load information for prior distribution

lprior    = num2str(mprior);
lmodel    = strcat('m',num2str(mspec));
priorfile = strcat('pri',lprior);
prior = feval(priorfile);

pmean  = prior(1:npara,1);
pstdd  = prior(1:npara,2);
pshape = prior(1:npara,3);

pshape = pshape.*(1-para_mask);
pmean = pmean.*(1-para_mask)+para_fix.*para_mask;
pstdd = pstdd.*(1-para_mask);


nonpolipar = [1:1:npara];
nonpolipar(polipar) = [];

% Load transformation scheme for parameters
trspec = feval('transp',mspec);

trspec(:,1) = trspec(:,1).*(1-para_mask);

percent = .90


fpath2 = strcat(fpath,'/',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_,'/');
mkdir(fpath2);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Set parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% doing rolling sample estimation?
ROLL = 0;
SAVEALL = 0;
DOFORECAST = 0;
if ROLL 
  DOFORECAST = 1;
  SAVEALL = 0;
end
fprintf(1,'\n\n ROLL: %2.0f, SAVEALL: %2.0f, DOFORECAST: %2.0f\n',[ROLL,SAVEALL,DOFORECAST]);
start_period = stime;                               % minimum # quarters to compute VAR estimates 


%mkdir(spath,'/2/');
%spath = strcat(spath,'/1/');
%start_period = nobsall-qahead+1-3
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% CHAnGE

trial_period = nobsall-start_period-qahead+1;      % # quarters to compute RMSE


I = find(ti == dates);


Verbose = 0;

fixparam = fixparamseq(1);
if fixparam ~= 0 
  fixparam
  break
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Reference Model for Prior Second Moments
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  infile1 = strcat(spath,'/mhNIpriopara',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_)
  fid1 = fopen(infile1,'r');		% input file (set to read)   
 %% no need to discard draws -- already done
 % numb1 = nburn*npara*4;                  % number of bites to discard
 % status = fseek(fid1,numb1,'bof');       % discard nburn 
  
  para = fread(fid1,[npara,inf],'single')';
  fclose(fid1);

  
  ndraws = size(para,1)


  PLOTDRAWS = 1
  if PLOTDRAWS
    datec = strcat('Prio/',date);
    mkdir(fpath2,datec);
    gpath_2 = strcat(fpath2,datec,'/');


    Ip = 0;
    sirf = (1:length(para));
    for p = find(para_mask == 0)'
      Ip = Ip+1;


      
        figure(p)
        ax1 = gca;
        

        title(para_names{p});

        P = line(sirf,para(:,p));
        set(P,'Color',[0 0 0],'Parent',ax1,'LineStyle','-');

        set(P,'LineWidth',2.2);
        set(ax1,'YAxisLocation','left')
        set(ax1,'XLim',[min(sirf),max(sirf)]);
        %  set(gca,'XTickLabel',intx);
        set(ax1,'FontSize',8);    


        ng=strcat(gpath_2,num2str(p));
        figure(p)
        print(char(strcat(ng,'.pdf')),'-dpdf');   % print(char(strcat(ng,'.eps')),'-depsc2');             

    close all;      
    end

  end
  
  

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% read draws of  parameters and discard those for which the model has no solution
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%% Compute posterior moments of the parameters (after IND)
outfile00 = strcat(fpath2,lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_,'PrioMom.tex');		% output file name 
fid00 = fopen(outfile00,'w');		% output file (set to write)

parahat = mean(para,1)';
paramed = median(para,1)';
parasig = cov(para,1);

parabands = hpdint(para,percent,1)';

%% save mean
outfile0 = strcat(spath,'/mhpriopara',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_,'Mean')
fid0 = fopen(outfile0,'w');     % output file (set to write)   
fwrite(fid0,parahat','single');
fclose(fid0);

%% save median
outfile0 = strcat(spath,'/mhpriopara',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_,'Median')
fid0 = fopen(outfile0,'w');     % output file (set to write)   
fwrite(fid0,paramed','single');
fclose(fid0);

%% save cov matrix
outfile0 = strcat(spath,'/mhpriopara',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_,'Cov')
fid0 = fopen(outfile0,'w');     % output file (set to write)   
fwrite(fid0,parasig(:),'single');
fclose(fid0);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%% Mean
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

colnames = {  ' Mean ', 'St. Dev. ',strcat(num2str(100*percent),'\% Lower Band'),strcat(num2str(100*percent),'\% Upper Band') };
outmat = [parahat,sqrt(diag(parasig)),parabands];

fprintf(1,'\n');
fprintf(1,'%4.99s  ',colnames{:});
for i = 1:length(para_names)
  fprintf(1,'\n %4.10s  ',para_names{i});
  fprintf(1,' %8.4f  ',outmat(i,:));
end    

fprintf(fid00,'\n');


colnames = {'Parameter' 'Support '  'Density '  'Prior Mean ' 'Prior Stdd ' strcat(num2str(100*percent),'\% LB') ...
            strcat(num2str(100*percent),'\% UB') };
%outmat = [parahat,sqrt(diag(parasig)),parabands];

rownames = para_names;

[nrows,ncols] = size(outmat);
fprintf(fid00,'\n \\documentclass{article}');
fprintf(fid00,'\n \\begin{document}');
fprintf(fid00,'\n \\setlength{\\tabcolsep}{.7mm}');

fprintf(fid00,'PARAMETERS (FILTERNG OUT INDETERMINACY AND NON EX)\n $$');
fprintf(fid00,'\n \\vspace{.2cm} \n \\begin{array}{@{\\hspace*{.5cm}} l @{\\hspace*{.5cm}}@{\\hspace*{-.2cm}}c@{\\hspace*{-.2cm}}@{\\hspace*{-.2cm}}c@{\\hspace*{-.2cm}}');
FORMAT = '  ';
for j = 1:ncols
  fprintf(fid00,' @{\\hspace*{.5cm}} c'); 
  if j == 1
    FORMAT = strcat(FORMAT,' &  %8.3f  '); 
    % elseif (j == ncols) | (j == (ncols-1))
    %	FORMAT = strcat(FORMAT,' & \\mbox{{\\scriptsize $%8.3f$ }} '); 
  else
    FORMAT = strcat(FORMAT,' & %8.3f '); 
  end

end

fprintf(fid00,'}\\hline');
FORMAT = strcat(FORMAT,' \\\\');  

fprintf(fid00,'\n  ');
fprintf(fid00,' %4.99s   ',colnames{1});		
fprintf(fid00,' & %4.99s ',colnames{2:end});		
fprintf(fid00,'	\\\\ \\hline '); 

for i = 1:nrows
  fprintf(fid00,'\n %4.99s & ',rownames{i});
  if pshape(i) == 1
    fprintf(fid00,'[0,1) & \\mbox{Beta} ');	
  elseif pshape(i) == 2
    fprintf(fid00,'R^{+} & \\mbox{Gamma} ');	
  elseif pshape(i) == 3
    fprintf(fid00,' R & \\mbox{\\cal N} ');	
  elseif pshape(i) == 4
    fprintf(fid00,'R^{+} & \\mbox{InvGamma} ');	
  elseif pshape(i) == 0
    fprintf(fid00,' &  ');	    
  end
  fprintf(fid00,FORMAT,outmat(i,:));

end   
fprintf(fid00,' \\hline');
fprintf(fid00,'\n \\end{array} $$');        
fprintf(fid00,'\n  ratio of determinacy draws %2.2f\n',size(para,1)/ndraws);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%% Mean
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% compute moments
[TTT,RRR,valid] = dsgesolv(parahat,mspec);
%valid = 1;
%[yyyyd,xxyyd,xxxxd,retcode] = varprio(TTT,RRR,valid,para,nvar,nlagsc2,mspec,npara,coint,cointadd,cointall);

nlagsc2 = 1%nlagsc
  if nlagsc2 == 4
    nlagsc2_ = [];
  else
    nlagsc2_ = num2str(nlagsc2);
  end  


[ZZ,DD,DDcointadd,QQ,EE,MM,retcode] = measur(TTT,RRR,valid,parahat,nvar,nlagsc2,mspec,npara,coint,cointadd,cointall);

if retcode == 0
  disp('trouble');mm
  return;
end;

nirf = 20;
aairf = irfdsge(TTT,RRR,parahat,nvar,mspec,npara,nirf,cum_irf,1,nlags,coint,cointadd,cointall);


  
  titlenames = varnames;
  titlenames(cum_irf) = strcat(titlenames(cum_irf),' - cum');
  tirf = (1:1:nirf)';
  
  for Iirf = 1:nvar
    for V = 1:nvar
      figure(1001);
      subplot(nvar,nvar,V+nvar*(Iirf-1));   
      m = aairf(:,V+nvar*(Iirf-1));
      P = plot(tirf,m,'r-');
      set(P,'LineWidth',1);
      hold off;
      
      if Iirf == 1
        title(titlenames(V));
      end
      if V == 1 
        P = ylabel(names_shocks(Iirf));
        set(P,'FontSize',12);
      end
      
      set(gca,'XLim',[min(tirf),max(tirf)]);
      set(gca,'XTick',tirf([1:10:end]));
      if Iirf == nvar
        set(gca,'XTickLabel',num2str(tirf([1:10:end])-1));       
      else 
        set(gca,'XTickLabel',[]);
      end
      
    end                                                
  end	

ng = strcat(fpath2,lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_,'Irfs');
figure(1001);     print(char(strcat(ng,'.eps')),'-depsc2');   %print(char(strcat(ng,'.pdf')),'-dpdf');   % 
  outfile400 = strcat(spath,'/IrfsMean',lmodel,lprior,dataset,lmodel_ref,stup_,nobsdrat_,nlagsc_,n_s_);
  fid400 = fopen(outfile400,'w');		% output file (set to write)   
  fwrite(fid400,aairf,'single');
fclose(fid400);

close all;
    
size(aairf)
[nirf,nvar*length(names_shocks)]



fprintf(fid00,'\n \\end{document}');
fclose(fid00);          % close output file

list_t2 = find(para_type == 2);
npara2 = length(list_t2)
i_aux = list_t2
parastd = sqrt(diag(parasig(i_aux,i_aux)));
paracorr = parasig(i_aux,i_aux)./(parastd*parastd');
dm(paracorr);












