% Define Prior parameters
% pshape is 1: BETA(mean,stdd)
%           2: GAMMA(mean,stdd)
%           3: NORMAL(mean,stdd)
%           4: INVGAMMA(s^2,nu)
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% loose lambda_f prior %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function prior = pri42

prior = zeros(100,3);



prior(1,:) = [.4    inf  5]; %% alp - flat
prior(2,:) = [.45    .1  1];  %% zeta_p - beta
prior(3,:) = [.5    .28 1];  %% iota_p - beta
prior(4,:) = [.025  inf 5];  %% del - flat
prior(5,:) = [1     .5 2];   %% ups - gamma
prior(6,:) = [.5    .25 2];  %% Bigphi - gamma
prior(7,:) = [4     1.5 2];  %% s2 - normal
prior(8,:) = [.7    .05 1];  %% h - beta
prior(9,:) = [.2    .10 2];  %% a2 - gamma
prior(10,:) = [2    .75 2];  %% nu_l - gamma
prior(11,:) = [2    .75 2];  %% nu_m - gamma
prior(12,:) = [.45   .1  1];  %% zeta_w - beta
prior(13,:) = [.5   .28  1]; %% iota_w - beta
prior(14,:) = [.3   .5  2];  %% law - gamma
prior(15,:) = [1.5   1  2];  %% rstar - gamma
prior(16,:) = [2  .25  2];  %% psi1 - gamma
prior(17,:) = [.2   .1  2];  %% psi2 - gamma
prior(18,:) = [.5   .2  1];  %% rho_r - beta
prior(19,:) = [4.3  2.5 3];  %% pistar - normal


npara = 19;

%% exogenous processes - level
prior(npara+1,:) = [1.65  1  2];  %% gam - gamma
prior(npara+2,:) = [0     5 3];     %% Wadj - normal
prior(npara+3,:) = [.1   .1  2];    %% chi - gamma
prior(npara+4,:) = [.15  .1  2];    %% laf - gamma
prior(npara+5,:) = [.3  inf  5];    %% gstar - flat
prior(npara+6,:) = [252  10 3];     %% Ladj - normal

npara = npara+6;    

%% exogenous processes - autocorrelation
prior(npara+1,:) = [.4   .25  1];   %% rho_z - beta
prior(npara+2,:) = [.75  .25  1];   %% rho_phi - beta
prior(npara+3,:) = [.75  .25  1];   %% rho_chi - beta
prior(npara+4,:) = [.75  .25  1];   %% rho_laf - beta
prior(npara+5,:) = [.75  .25  1];   %% rho_mu - beta
prior(npara+6,:) = [.75  .25  1];   %% rho_b - beta
prior(npara+7,:) = [.75  .25  1];   %% rho_g - beta

npara = npara+7;    

%% exogenous processes - standard deviation
prior(npara+1,:) = [.9   4.00    4]; %% sig_z;
prior(npara+2,:) = [3    4.00    4]; %% sig_phi;
prior(npara+3,:) = [.75  4.00    4]; %% sig_chi;
prior(npara+4,:) = [.2  4.00    4]; %% sig_laf;
prior(npara+5,:) = [.75  4.00    4]; %% sig_mu;
prior(npara+6,:) = [.75  4.00    4]; %% sig_b;
prior(npara+7,:) = [.5  4.00    4]; %% sig_g;
prior(npara+8,:) = [.40  4.00    4]; %% sig_r;

npara = npara+8;
prior = prior(1:npara,:);
