%% Transformations:
%% format: type, a, b, c
%% Type 1:
%% x is [a,b] -> [-1,1] -> [-inf,inf] by (1/c)*c*z/sqrt(1-c*z^2)
%% Type 2:
%% x is [0,inf] -> [-inf,inf] by b + (1/c)*ln(para[i]-a);

function trspec = transp(mspec)

if any(mspec == [101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16])

	trspec = zeros(100,4);
	
	
	trspec(1,:) = [1	1E-5	.99	1]; 	%% alp;
	trspec(2,:) = [1	1E-5	.99	1];   	%% zeta_p;
	trspec(3,:) = [1	1E-5	.99	1];	%% iota_p;
	trspec(4,:) = [1	1E-5	.99	1]; 	%% del;
	trspec(5,:) = [2	1E-5	0	1];	%% ups;
	trspec(6,:) = [2	1E-5	0	1];	%% Bigphi;
	trspec(7,:) = [2	1E-5	0	1];	%% s2;
	trspec(8,:) = [1	1E-5	.99	1]; 	%% h;
	trspec(9,:) = [2	1E-5	0	1];	%% a2;
	trspec(10,:) = [2	1E-5	0	1];	%% nu_l;
	trspec(11,:) = [2	1E-5	0	1];	%% nu_m;
	trspec(12,:) = [1	1E-5	.99	1];	%% zeta_w;
	trspec(13,:) = [1	1E-5	.99	1];	%% iota_p;
	trspec(14,:) = [2	1E-5	0	1];	%% law;
	trspec(15,:) = [2	1E-5	0	1];	%% rstar;
	trspec(16,:) = [2	1E-5	0	1];	%% psi1;
	trspec(17,:) = [2	1E-5	0	1];	%% psi2;
	trspec(18,:) = [1	1E-5	.99	1];	%% rho_r;
	trspec(19,:) = [0	0	0	0];	%% pistar;
	
	
	npara = 19;
	
	%% exogenous processes - level
	trspec(npara+1,:) = [2	1E-5	0	1];	%% gam;
	trspec(npara+2,:) = [0	0	0	0];	%% Lstar;
	trspec(npara+3,:) = [2	1E-5	0	1];	%% chi;
	trspec(npara+4,:) = [2	1E-5	0	1];	%% laf;
	trspec(npara+5,:) = [2	1E-5	0	1];	%% gstar;
	trspec(npara+6,:) = [0	0	0	0];	%% Ladj
	
	npara = npara+6;	
	
	%% exogenous processes - autocorrelation
	trspec(npara+1,:) = [1	1E-5	.99	1];	%% rho_z;
	trspec(npara+2,:) = [1	1E-5	.99	1];	%% rho_phi;
	trspec(npara+3,:) = [1	1E-5	.99	1];	%% rho_chi;
	trspec(npara+4,:) = [1	1E-5	.99	1];	%% rho_laf;
	trspec(npara+5,:) = [1	1E-5	.99	1];	%% rho_mu;
	trspec(npara+6,:) = [1	1E-5	.99	1];	%% rho_b;
	trspec(npara+7,:) = [1	1E-5	.99	1];	%% rho_g;
	
	npara = npara+7;	
	
	%% exogenous processes - standard deviation
	trspec(npara+1,:) = [2	1E-5	0	1];	%% sig_z;
	trspec(npara+2,:) = [2	1E-5	0	1];	%% sig_phi;
	trspec(npara+3,:) = [2	1E-5	0	1];	%% sig_chi;
	trspec(npara+4,:) = [2	1E-5	0	1];	%% sig_laf;
	trspec(npara+5,:) = [2	1E-5	0	1];	%% sig_mu;
	trspec(npara+6,:) = [2	1E-5	0	1];	%% sig_b;
	trspec(npara+7,:) = [2	1E-5	0	1];	%% sig_g;
	trspec(npara+8,:) = [2	1E-5	0	1];	%% sig_r;
	
	npara = npara+8;
	trspec = trspec(1:npara,:);
	
	

    
end



