
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% load data
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[YYall,XXall,ti,nobsall] = loaddata(dataset,fpath,T0,Tend,coint,cointadd,cointall,nvar,nlags,mspec);
Iseq = find(ti == dates);
I = Iseq;
size(YYall)
%%%% presample
nlagsc2 = max(nlagsc,1);
T0_p = nlagsc2;
[YYall_p,XXall_p,ti_p,nobsall_p] = loaddata(dataset,fpath,T0_p,Tend,coint,cointadd,cointall,nvar,nlagsc2,mspec);
I_p = find(ti_p == dates);
dataset = num2str(10*dataset);

if stime                           
  YY = YYall(I-stime+1:I,:);
  XX = XXall(I-stime+1:I,:);             
  tiI = ti(I-stime+1:I);  
else
  YY     = YYall(1:I,:);
  XX     = XXall(1:I,:);                   
  tiI = ti(1:I);
end
nobs = size(YY,1);

YYYY = YY'*YY;
XXYY = XX'*YY;
XXXX = XX'*XX;

MeY_0 = mean(YY,1)'
VaY_0 = cov(YY,1);
stdY_0 = sqrt(diag(VaY_0));
CorY_0 = VaY_0./(stdY_0*stdY_0');
ACorY_0 = zeros(nvar,1);
for ii = 1:nvar;
  ACorY_0(ii) = corr(YY(:,ii),XX(:,1+cointall+ii));
end
stats_0 = [MeY_0' stdY_0' ACorY_0' CorY_0(:)'];


outfile200 = strcat(spath,'/stats');		
fid200 = fopen(outfile200,'w');		% output file (set to write)   
fwrite(fid200,stats_0,'single');
fclose(fid200);


CorLsPi = zeros(1,2*k_l+1);
for il = -k_l:k_l;
  if il < 0
    CorLsPi(k_l+1+il) = corr(YY(1:end+il,4),YY(1-il:end,3));
  else
    CorLsPi(k_l+1+il) = corr(YY(1+il:end,4),YY(1:end-il,3));
  end
end

outfile201 = strcat(spath,'/CorLsPi');		
fid201 = fopen(outfile201,'w');		% output file (set to write)   
fwrite(fid201,CorLsPi,'single');
fclose(fid201);

CorLsY = zeros(1,2*k_l+1);
for il = -k_l:k_l;
  if il < 0
    CorLsY(k_l+1+il) = corr(YY(1:end+il,3),YY(1-il:end,1));
  else
    CorLsY(k_l+1+il) = corr(YY(1+il:end,3),YY(1:end-il,1));
  end
end

outfile201 = strcat(spath,'/CorLsY');		
fid201 = fopen(outfile201,'w');		% output file (set to write)   
fwrite(fid201,CorLsY,'single');
fclose(fid201);

AcorLs = zeros(1,k_l);
for il = 1:k_l;
  AcorLs(il) = corr(YY(1:end-il,3),YY(1+il:end,3));
end

outfile201 = strcat(spath,'/AcorLs');		
fid201 = fopen(outfile201,'w');		% output file (set to write)   
fwrite(fid201,AcorLs,'single');
fclose(fid201);

AcorPi = zeros(1,k_l);
for il = 1:k_l;
  AcorPi(il) = corr(YY(1:end-il,4),YY(1+il:end,4));
end

outfile201 = strcat(spath,'/AcorPi');		
fid201 = fopen(outfile201,'w');		% output file (set to write)   
fwrite(fid201,AcorPi,'single');
fclose(fid201);


%%%% presample
YY_p = YYall_p(1:I_p-stime,:);
XX_p = XXall_p(1:I_p-stime,:);             
nobs_p = size(YY_p,1);

MeY_p = mean(YY_p,1)';
VaY_p = cov(YY_p,1);
stdY_p = sqrt(diag(VaY_p));
CorY_p = VaY_p./(stdY_p*stdY_p');
ACorY_p = zeros(nvar,1);
for ii = 1:nvar;
  ACorY_p(ii) = corr(YY_p(:,ii),XX_p(:,1+cointall+ii));
end

stats_p = [MeY_p' stdY_p' ACorY_p' CorY_p(:)'];
outfile200 = strcat(spath,'/statsPre');		
fid200 = fopen(outfile200,'w');		% output file (set to write)   
fwrite(fid200,stats_p,'single');
fclose(fid200);

k_l = 8;
CorLsPi_p = zeros(1,2*k_l+1);
for il = -k_l:k_l;
  if il < 0
    CorLsPi_p(k_l+1+il) = corr(YY_p(1:end+il,4),YY_p(1-il:end,3));
  else
    CorLsPi_p(k_l+1+il) = corr(YY_p(1+il:end,4),YY_p(1:end-il,3));
  end
end

outfile201 = strcat(spath,'/CorLsPi_p');		
fid201 = fopen(outfile201,'w');		% output file (set to write)   
fwrite(fid201,CorLsPi_p,'single');
fclose(fid201);


CorLsY_p = zeros(1,2*k_l+1);
for il = -k_l:k_l;
  if il < 0
    CorLsY_p(k_l+1+il) = corr(YY_p(1:end+il,1),YY_p(1-il:end,3));
  else
    CorLsY_p(k_l+1+il) = corr(YY_p(1+il:end,1),YY_p(1:end-il,3));
  end
end

outfile201 = strcat(spath,'/CorLsY_p');		
fid201 = fopen(outfile201,'w');		% output file (set to write)   
fwrite(fid201,CorLsY_p,'single');
fclose(fid201);

AcorLs_p = zeros(1,k_l);
for il = 1:k_l;
  AcorLs_p(il) = corr(YY_p(1:end-il,3),YY_p(1+il:end,3));
end

outfile201 = strcat(spath,'/AcorLs_p');		
fid201 = fopen(outfile201,'w');		% output file (set to write)   
fwrite(fid201,AcorLs_p,'single');
fclose(fid201);

AcorPi_p = zeros(1,k_l);
for il = 1:k_l;
  AcorPi_p(il) = corr(YY_p(1:end-il,4),YY_p(1+il:end,4));
end

outfile201 = strcat(spath,'/AcorPi_p');		
fid201 = fopen(outfile201,'w');		% output file (set to write)   
fwrite(fid201,AcorPi_p,'single');
fclose(fid201);


%% take constant out and demean

YYYY_p = (YY_p-repmat(mean(YY_p,1),[size(YY_p,1) 1]))'*(YY_p-repmat(mean(YY_p,1),[size(YY_p,1) 1]))/nobs_p
outfile2000 = strcat(spath,'/yyyy',dataset,num2str(nlagsc),'PreSample')	
fid2000 = fopen(outfile2000,'w');		% output file (set to write)   
fwrite(fid2000,YYYY_p,'single');
fclose(fid2000);

if nlagsc > 0
  XX_p = XX_p(:,2:end); 
  XXYY_p = (XX_p-repmat(mean(XX_p,1),[size(XX_p,1) 1]))'*(YY_p-repmat(mean(YY_p,1),[size(YY_p,1) 1]))/nobs_p;
  XXXX_p = (XX_p-repmat(mean(XX_p,1),[size(XX_p,1) 1]))'*(XX_p-repmat(mean(XX_p,1),[size(XX_p,1) 1]))/nobs_p;

  outfile3000 = strcat(spath,'/xxyy',dataset,num2str(nlagsc),'PreSample');		
  fid3000 = fopen(outfile3000,'w');		% output file (set to write)   
  outfile4000 = strcat(spath,'/xxxx',dataset,num2str(nlagsc),'PreSample');		
  fid4000 = fopen(outfile4000,'w');		% output file (set to write)   

  fwrite(fid3000,XXYY_p,'single');
  fwrite(fid4000,XXXX_p,'single');

  fclose(fid3000);
  fclose(fid4000);
end

ICUM = find(cum_for);
INCUM = find(cum_for == 0);




