    %% Endogenous variables 
    y_t = 1;
    c_t = 2;
    i_t = 3;
    k_t = 4;
    kbar_t = 5;
    L_t = 6;
    m_t = 7;
    mc_t = 8;
    pi_t = 9;
    R_t = 10;
    rk_t = 11;
    u_t = 12;
    w_t = 13;
    wtil_t = 14;
    xi_t = 15;
    xik_t = 16;

    n_end = 16;
    
    if any(mspec == [1003,1004]) %% output gap model
	    y_tFP = n_end+ 1;
	    c_tFP = n_end+ 2;
	    i_tFP = n_end+ 3;
	    k_tFP = n_end+ 4;
	    kbar_tFP = n_end+ 5;
	    L_tFP = n_end+ 6;
	    mc_tFP = n_end+ 7;
	    rk_tFP = n_end+ 8;
	    u_tFP = n_end+ 9;
	    w_tFP = n_end+ 10;
	    xi_tFP = n_end+ 11;
	    xik_tFP = n_end+ 12;	

	    n_end = n_end+12;
    end

    
    %% Exogenous variables (equations) and exogenous shocks (if shocks are iid the # of exog equations is less than the # of shocks)

     if any(mspec == [101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16])  
        %% note what we call z_t here is really z^*_t in the paper
        z_sh = 1;
        z_t = n_end+z_sh;
        phi_sh = 2;
        phi_t = n_end+phi_sh;
        g_sh = 3;
        g_t = n_end+g_sh;

        laf_sh = 4; %% this is actually iid: for the time being I treat it as an eq.- in case we want to change it
        laf_t = n_end+laf_sh;
        
        r_sh = 5;   %% this is the taylor rule shock - iid

        n_exo = 4;
        %% number of exogenous shocks
        nex = 5;
    
    end 

    %% Expectation terms 
    Ec_sh = 1; 
    E_c = n_end+n_exo+Ec_sh;
    Epi_sh = 2;
    E_pi = n_end+n_exo+Epi_sh;
    Erk_sh = 3;
    E_rk = n_end+n_exo+Erk_sh;
    Ew_sh = 4;
    E_w = n_end+n_exo+Ew_sh;
    Ewtil_sh = 5;
    E_wtil = n_end+n_exo+Ewtil_sh;
    Exi_sh = 6;
    E_xi = n_end+n_exo+Exi_sh;
    Exik_sh = 7;
    E_xik = n_end+n_exo+Exik_sh;
    Ei_sh = 8;
    E_i = n_end+n_exo+Ei_sh;

    n_exp = 8;
    %% number of endogenous shocks
    nend = n_exp;
    

    if any(mspec == [1003,1004]) %% output gap model  
	    Ec_shFP = n_exp+1; 
	    E_cFP = n_end+n_exo+Ec_shFP;
	    Erk_shFP = n_exp+2;
	    E_rkFP = n_end+n_exo+Erk_shFP;
	    Exi_shFP = n_exp+3;
	    E_xiFP = n_end+n_exo+Exi_shFP;
	    Exik_shFP = n_exp+4;
	    E_xikFP = n_end+n_exo+Exik_shFP;
	    Ei_shFP = n_exp+5;
	    E_iFP = n_end+n_exo+Ei_shFP;

	    %% Expectation terms 
	    n_exp = n_exp+5;
	    %% number of endogenous shocks
	    nend = n_exp;
    end
