close all;
clear all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% PRELIMINARY STUFF
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

run startdsgeprioeuro;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%      paths & parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
chdata = choosedata;
[mspec,mprior,dataset,dates,nvar,nlags,T0,Tend,npara,lambdaseq,para_names,bounds,para, ...
 varnames,cum_for,polipar,polivalue,cum_irf,names_shocks,fixparamseq,coint,cointadd,cointall,cointvec,cointaddvec,JustMode, ...
 stime,st,nblocks,nsim,nburn,qahead,para_mask,para_fix] = varspec(chdata);


%[fpath,spath,gpath] = pathspecmh(num2str(floor(dataset)),chdata,coint);
[fpath,spath,gpath] = pathspec(num2str(floor(dataset)),chdata);


fprintf(1,'model: %2.0f, dataset: %2.1f, prior: %2.0f',[mspec,dataset,mprior]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% load data
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[YYall,XXall,ti,nobsall] = loaddata(dataset,fpath,T0,Tend,coint,cointadd,cointall,nvar,nlags,chdata,mspec);
Dat = dataset
dataset = num2str(10*dataset);

ICUM = find(cum_for);
INCUM = find(cum_for == 0);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%*
% Load information for prior distribution

lprior    = num2str(mprior);
lmodel    = strcat('m',num2str(mspec));
priorfile = strcat(lmodel,lprior,'pri');
prior = feval(priorfile);

pmean  = prior(1:npara,1);
pstdd  = prior(1:npara,2);
pshape = prior(1:npara,3);

pshape = pshape.*(1-para_mask);


nonpolipar = [1:1:npara];
nonpolipar(polipar) = [];

% Load transformation scheme for parameters
trspec = feval('transp',mspec);

trspec(:,1) = trspec(:,1).*(1-para_mask);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Set parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% doing rolling sample estimation?
ROLL = 0
SAVEALL = 0
DOFORECAST = 1
if ROLL 
  DOFORECAST = 1;
  SAVEALL = 0;
end
start_period = stime;                               % minimum # quarters to compute VAR estimates 


%mkdir(spath,'/2/');
%spath = strcat(spath,'/1/');
%start_period = nobsall-qahead+1-3

trial_period = nobsall-start_period-qahead+1;      % # quarters to compute RMSE

Verbose = 0;

fixparam = fixparamseq(1);
if fixparam ~= 0 
  fixparam
  break
end

if Dat == 4
  I_inf = 6;
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% do Lambda loop
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Mh = zeros(1,length(lambdaseq));
percent = .90;

if ROLL        

  %Iseq = start_period+1:start_period+29;
  Iseq = start_period+1:start_period+trial_period;
  
  fprintf(1,'\n beginning: %2.4f ; end:  %2.4f \n',[ti(Iseq(1)),ti(Iseq(end))]);
  outfile00 = strcat(fpath,lmodel,lprior,dataset,num2str(cointall),st,num2str(100*ti(start_period+1)),num2str(100*ti(start_period+trial_period)),num2str(nlags),'rollFor.tex');	% output file name 


else
  Iseq = find(ti == dates);
  outfile00 = strcat(fpath,lmodel,lprior,dataset,num2str(cointall),st,num2str(100*ti(Iseq)),num2str(nlags),'For.tex');	% output file name 

end

%fid00 = fopen(outfile00,'w');		% output file (set to write)

for I = Iseq;
  if ~ROLL
    start_period = I-1;
  end



  %	        fprintf(1,' %8.98s;',fixparam);
  
  if stime                           
    YY = YYall(I-stime+1:I,:);
    XX = XXall(I-stime+1:I,:);             
    tiI = ti(I-stime+1:I);
  else
    YY     = YYall(1:I,:);
    XX     = XXall(1:I,:);                   
    tiI = ti(1:I);
  end
  
  %% Define initial Y's and cointegration vector for DSGE model estimation
  %% ignore cointadd
  
  %% YY0: lagged growth rates
  YY0 = zeros(nlags,size(YY,2));
  for lagind = 1:nlags
    YY0(nlags-lagind+1,:) = XX(1,1+cointall+(lagind-1)*nvar+1:1+cointall+lagind*nvar);
  end
  
  %% YYcoint0: lagged cointegration vector
  if coint > 0            
    YYcoint0 = XX(1,1+cointadd:cointall);
    for lagind = 1:(nlags-1)
      YYcoint0 = YYcoint0-XX(1,1+cointall+(lagind-1)*nvar+1:1+cointall+lagind*nvar)*cointvec';
    end
  else
    YYcoint0 = [];               
  end
  
  if I+qahead <= nobsall
    YYfut  = YYall(I+1:I+qahead,:);
    XXpred = XXall(I+1,:);
  elseif I == nobsall
    YYfut  = NaN*zeros(qahead,nvar);
    XXpred = XXall(end,:);
  elseif (I < nobsall) & (I+qahead > nobsall)
    Ii = nobsall-I
    YYfut  = [YYall(I+1:I+Ii,:);NaN*zeros(qahead-Ii,nvar)];
    XXpred = XXall(end-Ii,:);        
  end
  
  L = 0;
  for lambdas = lambdaseq     

  fprintf(1,'\n\nRMSE computation: lambda = %2.3f; date: %2.2f ',[lambdas,ti(I)]);    
    L = L+1;
    
    %% open read files
    %% forecasts file
    infile1 = strcat(spath,'/pred',lmodel,lprior,dataset,num2str(cointall),st,num2str(100*lambdas),num2str(100*ti(I)),num2str(nlags),num2str(fixparam),num2str(JustMode));        

    num1 = nblocks*nsim*(nvar*qahead)*4;            % number of bites per file
    numb1 = nburn*(nvar*qahead)*4;                  % number of bites to dicard
    
    fid1 = fopen(infile1,'r');		% input file (set to read)               
    status = fseek(fid1,numb1,'bof');

    ypred = [];
    it =0;
    it0=-inf;
    while ( ftell(fid1) < num1 ) & (it > it0)
      it0 = it;
      it=ftell(fid1);
      % Read blocks of size nsim
      ypredadd = fread(fid1,[nsim,nvar*qahead],'single');
      if all(size(ypredadd,2) == [nvar*qahead])
        ypred = [ypred;ypredadd];
      else
        %		fclose(fid1);
      end
      clear ypredadd;
      
    end;
    fclose(fid1);
    ndraws = size(ypred,1)
    
    
    %%%%%%%%%%% Compute posterior moments of the parameters
    ypredhat = mean(ypred,1)';

    ypredhat = reshape(ypredhat,[qahead,nvar]);

    yfut = YYfut;
    if Dat == 4
      %% de-annualize inflation
      %ypredhat(:,I_inf) = ypredhat(:,I_inf)/4;
      %yfut(:,I_inf) = yfut(:,I_inf)/4;
    end
    
    %% print out inflation forecasts vs actual
    fprintf(1,'\n ');
    fprintf(1,'%2.2f ',ypredhat(:,I_inf));
    fprintf(1,'\n ');
    fprintf(1,'%2.2f ',yfut(:,I_inf));

    
    %% cumulative forecasts and forecast errors
    ypredhat(:,ICUM) = cumsum(ypredhat(:,ICUM));
    yfut(:,ICUM) = cumsum(yfut(:,ICUM));
    
    fprintf(1,'\n ');
    fprintf(1,'%2.2f ',ypredhat(:,I_inf));
    fprintf(1,'\n ');
    fprintf(1,'%2.2f ',yfut(:,I_inf));

    Fh = ypredhat-yfut;
    
    %load(strcat(spath,'Fh',lmodel,lprior,dataset,num2str(coint),st,num2str(fixparam),num2str(JustMode),num2str(100*lambdas),num2str(100*ti(I))),'Fh');
    %load(strcat(spath,'Yh',lmodel,lprior,dataset,num2str(coint),st,num2str(fixparam),num2str(JustMode),num2str(100*lambdas),num2str(100*ti(I))),'Yh');
    
    outfile011 = strcat(spath,'yFh',lmodel,lprior,dataset,num2str(cointall),st,num2str(fixparam),num2str(JustMode),num2str(100*lambdas),num2str(100*ti(I)));
    fid011 = fopen(outfile011,'w');     % output file (set to write)   
    fwrite(fid011,Fh(:),'single');
    fclose(fid011);
    
    save(strcat(spath,'Fh',lmodel,lprior,dataset,num2str(cointall),st,num2str(fixparam),num2str(JustMode),num2str(100*lambdas),num2str(100*ti(I))),'Fh');
    
    outfile012 = strcat(spath,'yYh',lmodel,lprior,dataset,num2str(cointall),st,num2str(fixparam),num2str(JustMode),num2str(100*lambdas),num2str(100*ti(I)));
    fid012 = fopen(outfile012,'w');     % output file (set to write)   
    fwrite(fid012,ypredhat(:),'single');
    fclose(fid012);

    
  end         % end lambdaseq
  fprintf(1,'\n\n\n ');

  
end %% end rolling sample

fclose(fid00);		% close output file








